/**
 * @version    CVS: 3.7.8
 * @package    com_yoursites
 * @author     Geraint Edwards
 * @copyright  2017-2021 GWE Systems Ltd
 * @license    GNU General Public License version 3 or later; see LICENSE.txt
 */


'use strict';

document.addEventListener('DOMContentLoaded',  replaceYstsBtn);
document.addEventListener('DOMContentLoaded',  addYstsSelectStyle);
document.addEventListener('DOMContentLoaded', setupRSVPTemplateBootstrap);

function replaceYstsBtn() {
    console.log("replaceYstsBtn");
    if (document.querySelectorAll) {
        let elems = document.querySelectorAll('#gslc .btn-group');
        for (let e = 0; e < elems.length; e++) {
            elems[e].classList.remove('btn-group');
            elems[e].classList.remove('radio');
            elems[e].classList.add('gsl-button-group');
            let inputs = elems[e].querySelectorAll('.radio');
            for (let i = 0; i < inputs.length; i++) {
                inputs[i].classList.remove('radio');
            }
            inputs = elems[e].querySelectorAll("input[type='checkbox'], input[type='radio']");

            for (let i = 0; i < inputs.length; i++) {
               inputs[i].classList.add('gsl-hidden');
            }
            let labels = elems[e].querySelectorAll("label.btn");
            for (let l = 0; l < labels.length; l++) {
                let label = labels[l];
                label.classList.remove('btn');
                label.classList.add('gsl-button');
                label.classList.add('gsl-button-default');
                label.classList.add('gsl-button-small');

                let activeClass = false;
                let input = document.getElementById(label.getAttribute('for')) || label.querySelector('input');
                if (input) {

                    if (label.classList.contains('btn-danger')) {
                        label.classList.remove('btn-danger');
                        input.setAttribute('data-activeclass', 'danger');
                    }
                    if (label.classList.contains('btn-success')) {
                        label.classList.remove('btn-success');
                        input.setAttribute('data-activeclass', 'primary');
                    }
                    if (label.classList.contains('btn-warning')) {
                        label.classList.remove('btn-warning');
                        input.setAttribute('data-activeclass', 'warning');
                    }

                    if (input.checked || label.classList.contains('active')) {
                        activeClass = input.getAttribute('data-activeclass');
                        if (input.checked || label.classList.contains('active')) {
                            if (activeClass) {
                                label.classList.add('gsl-button-' + activeClass);
                            } else if (input.value == 0) {
                                label.classList.add('gsl-button-danger');
                            } else {
                                label.classList.add('gsl-button-primary');
                            }
                        } else {
                            if (activeClass) {
                                label.classList.remove('gsl-button-' + activeClass);
                            }
                            label.classList.remove('gsl-button-success');
                            label.classList.remove('gsl-button-primary');
                            label.classList.remove('gsl-button-danger');
                        }
                    }
                }

                label.classList.remove('active');

                // Version of gslframework.js from JEvents
                input.addEventListener('change', function() {changeHiddenInput(input);});
                //input.addEventListener('change', ysts_toggleRadios);
            }
        }

        elems = document.querySelectorAll('#gslc .checkbox-group');
        for (let e = 0; e < elems.length; e++) {
            elems[e].classList.remove('checkbox-group');
            elems[e].classList.remove('checkbox');
            elems[e].classList.add('gsl-button-group');

            let inputs = elems[e].querySelectorAll('.checkbox');
            for (let i = 0; i < inputs.length; i++) {
                inputs[i].classList.remove('checkbox');
            }
            inputs = elems[e].querySelectorAll("input[type='checkbox'], input[type='radio']");
            for (let i = 0; i < inputs.length; i++) {
                inputs[i].classList.add('gsl-hidden');
            }
            let labels = elems[e].querySelectorAll("label.btn");
            for (let l = 0; l < labels.length; l++) {
                let label = labels[l];
                label.classList.remove('btn');
                label.classList.add('gsl-button');
                label.classList.add('gsl-button-default');
                label.classList.add('gsl-button-small');

                let activeClass = false;
                let input = document.getElementById(label.getAttribute('for'));
                if (input) {
                    activeClass = input.getAttribute('data-activeclass');
                    if (input.checked || label.classList.contains('active')) {
                        if (activeClass) {
                            label.classList.add('gsl-button-' + activeClass);
                        } else if (this.value == 0) {
                            label.classList.add('gsl-button-danger');
                        } else {
                            label.classList.add('gsl-button-primary');
                        }
                    } else {
                        if (activeClass) {
                            label.classList.remove('gsl-button-' + activeClass);
                        }
                        label.classList.remove('gsl-button-primary');
                        label.classList.remove('gsl-button-danger');
                    }
                }

                label.classList.remove('active');
            }
        }
        /*
                elems = document.querySelectorAll("#gslc i[class^='icon-']");
                for (let e = 0; e < elems.length; e++) {
                    if (elems[e].classList.contains('icon-globe'))
                    {
                        alert (elems[e].classList);
                        elems[e].classList.remove('icon-globe');
                        elems[e].classList.add('gsl-icon');
                        elems[e].setAttribute('data-gsl-icon' , 'icon:location');
                    }
                }
         */


    }
};

function addYstsSelectStyle () {
    let selectFilters = document.querySelectorAll('#gslc .sessionfilters select, #gslc .rsvpsessionfilters select');
    for (let f = 0; f < selectFilters.length; f++) {
        let selectElem = selectFilters[f];
        if (selectElem.hasAttribute('size') && selectElem.getAttribute('size') == 1)
        {
            selectElem.removeAttribute('size');
        }
        if (!selectElem.classList.contains('gsl-select'))
        {
            selectElem.classList.add('gsl-select');
        }
    }
    let inputElements = document.querySelectorAll('#gslc .sessionfilters input, #gslc .rsvpsessionfilters input');
    for (let f = 0; f < inputElements.length; f++) {
        let inputElement = inputElements[f];
        if (!inputElement.classList.contains('gsl-input'))
        {
            inputElement.classList.add('gsl-input');
        }
    }

    // Template editing
    selectFilters = document.querySelectorAll('#gslc .edittemplate select ');

    for (let f = 0; f < selectFilters.length; f++) {
        let selectElem = selectFilters[f];
        if (selectElem.hasAttribute('size') && selectElem.getAttribute('size') == 1)
        {
            selectElem.removeAttribute('size');
        }
        if (!selectElem.classList.contains('gsl-select'))
        {
            selectElem.classList.add('gsl-select');
            selectElem.classList.add('gsl-form-small');
            selectElem.classList.add('gsl-form-width-medium');
        }
    }
    inputElements = document.querySelectorAll('#gslc .edittemplate input[type="text"] ');
    for (let f = 0; f < inputElements.length; f++) {
        let inputElement = inputElements[f];
        if (!inputElement.classList.contains('gsl-input'))
        {
            if (inputElement.hasAttribute('size') )
            {
                inputElement.removeAttribute('size');
            }

            inputElement.classList.add('gsl-input');
            inputElement.classList.add('gsl-form-small');
            inputElement.classList.add('gsl-form-width-medium');
        }
    }
    inputElements = document.querySelectorAll(' #gslc .edittemplate textarea  ');
    for (let f = 0; f < inputElements.length; f++) {
        let inputElement = inputElements[f];
        if (!inputElement.classList.contains('gsl-textarea'))
        {

            inputElement.classList.add('gsl-textarea');
            inputElement.classList.add('gsl-form-small');
            inputElement.classList.add('gsl-form-width-medium');
        }
    }

}

function setupRSVPTemplateBootstrap() {
console.log("setupRSVPTemplateBootstrap");
    let labelButtons = document.querySelectorAll('#gslc label.gsl-button');
    for (let e = 0; e < labelButtons.length; e++) {
        let label = labelButtons[e];
        let labelFor = label.getAttribute('for')
        if (labelFor) {
            let input = document.querySelector('#' + labelFor + "[type='radio']");
            if (!input) {
                continue;
            }

            if (!input.classList.contains('gsl-hidden')) {
                input.classList.add('gsl-hidden')
            }

            label.classList.remove('active');
            label.classList.remove('btn');
            label.classList.remove('btn-success');
            label.classList.remove('btn-danger');
            label.classList.remove('gsl-button-success');
            label.classList.remove('gsl-button-primary');
            label.classList.remove('gsl-button-danger');

            if (input.checked) {
                if (input.value == 0) {
                    label.classList.add('gsl-button-danger');
                } else {
                    label.classList.add('gsl-button-primary');
                }
            } else {
                label.classList.add('gsl-button-default');
            }

            if (input.getAttribute('disabled')) {
                continue;
            }

        }
    }

}
