<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

include_once(JPATH_ADMINISTRATOR.'/'."components/com_rsvppro/fields/JevrField.php");

class JFormFieldJevracymailingsubscription extends JevrField
{

	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var $_name = 'jevracymailingsubscription';

	const name = 'jevracymailingsubscription';

	static function isEnabled()
	{
		return is_dir(JPATH_ADMINISTRATOR . '/components/com_acymailing');

	}

	public static function loadScript($field = false)
	{
		HTMLHelper::script( 'administrator/components/' . RSVP_COM_COMPONENT . '/fields/js/jevracynewsletter.js');

		if ($field)
		{
			$id = 'field' . $field->field_id;
		}
		else
		{
			$id = '###';
		}
		if (!include_once(rtrim(JPATH_ADMINISTRATOR, '/') . '/' . 'components' . '/' . 'com_acymailing' . '/' . 'helpers' . '/' . 'helper.php'))
		{
			$html = 'This code can not work without the AcyMailing Component';
			return RsvpHelper::setField($id, $field, $html, self::name);
		}
		else
		{
			$listClass = acymailing_get('class.list');
			$allLists = $listClass->getFrontendLists();
			if (!$allLists || count($allLists) == 0)
			{
				$html = 'Please create an acyMailing List';
				return RsvpHelper::setField($id, $field, $html, self::name);
			}
		}

		$listid = "";
		$activeList = "";
		$defaultchecked = 1;
		if ($field)
		{
			try {
				$params = json_decode($field->params);
				$listid = isset($params->listid) ? $params->listid : 0;
				$defaultchecked = isset($params->defaultchecked) ?intval($params->defaultchecked) : 1;
			}
			catch (Exception $e) {

			}
		}

		ob_start();
		?>
		<div class='rsvpfieldinput'>

			<div class="gsl-form-label"><?php echo Text::_("RSVP_FIELD_TYPE"); ?></div>
			<div class="gsl-form-controls gsl-form-small" style="font-weight:bold;"><?php echo Text::_("RSVP_TEMPLATE_TYPE_JEVRACYMAILINGSUBSCRIPTION"); ?><?php RsvpHelper::fieldId($id); ?></div>
			<input type="hidden" name="dv[<?php echo $id; ?>]"  value="" />
			<div class="rsvpclear"></div>
			<div class="gsl-form-label"><?php echo Text::_("RSVP_TEMPLATE_TYPE_NEWSLETTER_SELECTION"); ?></div>
			<select name="params[<?php echo $id; ?>][listid]" id="fieldname<?php echo $id; ?>"  onchange="jevracynewsletter.setvalue('<?php echo $id; ?>');">
				<?php
				foreach ($allLists as $row)
				{

					$selected = "";
					if ($field && $listid == $row->listid)
					{
						$selected = "selected='selected'";
						$activeList = $row->name;
					}
					?>

					<option value="<?php echo $row->listid; ?>" <?php echo $selected; ?> ><?php echo $row->name ?></option>
					<?php
				}
				?>
			</select>
			<div class="rsvpclear"></div>

			<?php
			RsvpHelper::hidden($id, $field, self::name);
			RsvpHelper::label($id, $field, self::name);
			?>
			<div class="gsl-form-label"><?php echo Text::_("RSVP_ACY_CHECKED_BY_DEFAULT"); ?></div>
			<div class="gsl-form-controls">
				<label for="defaultchecked1<?php echo $id; ?>"><?php echo Text::_("JYES"); ?>
				<input type="radio" name="params[<?php echo $id; ?>][defaultchecked]"  id="defaultchecked1<?php echo $id; ?>" value="1" <?php
			if ($defaultchecked == 1)
			{
				echo 'checked="checked"';
			}
					?> />
				</label>
				<label for="defaultchecked0<?php echo $id; ?>"><?php echo Text::_("JNO"); ?>
				<input type="radio" name="params[<?php echo $id; ?>][defaultchecked]" id="defaultchecked0<?php echo $id; ?>" value="0" <?php
			   if ($defaultchecked == 0)
			   {
				   echo 'checked="checked"';
			   }
					?> />
				</label>
			</div>
			<div class="rsvpclear"></div>

			<input type="hidden" name="formonly[<?php echo $id; ?>]"   value="1" >
			<input type="hidden" name="showinform[<?php echo $id; ?>]"   value="1" >
			<input type="hidden" name="showinlist[<?php echo $id; ?>]"   value="0" >
			<input type="hidden" name="showindetail[<?php echo $id; ?>]"   value="0" >
			<?php
			RsvpHelper::includeinexport($id,  $field);
			RsvpHelper::accessOptions($id, $field);
			RsvpHelper::className($id, $field);
			?>
			<div class="rsvpclear"></div>


		</div>
		<div class='rsvpfieldpreview'  id='<?php echo $id; ?>preview'>
			<div class="previewlabel"><?php echo Text::_("RSVP_PREVIEW"); ?></div>
			<div class="gsl-form-label rsvppl" id='pl<?php echo $id; ?>' ><?php echo $field ? $field->label : Text::_("RSVP_FIELD_LABEL"); ?></div>
			<div id="pdv<?php echo $id; ?>">
				<?php
				echo $activeList;
				?>
			</div>
		</div>
		<div class="rsvpclear"></div>
		<?php
		$html = ob_get_clean();

		return RsvpHelper::setField($id, $field, $html, self::name);

	}

	function fetchElement($name, $value, &$node, $control_name)
	{
		$user =  Factory::getUser();

		if (Factory::getApplication()->input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->user_id > 0 && $this->attendee->user_id != $user->get("id"))
		{
			$value = $this->attendee->user_id;
		}
		else if (Factory::getApplication()->input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->id > 0 && $this->attendee->user_id == 0)
		{
			$value = 0;
		}

		$showinform = $this->attribute("showinform") || $this->attribute("formonly");

		$listid = intval($this->attribute("listid"));
		$html = "";

		if ($showinform && $listid > 0)
		{

			if (!include_once(rtrim(JPATH_ADMINISTRATOR, '/') . '/' . 'components' . '/' . 'com_acymailing' . '/' . 'helpers' . '/' . 'helper.php'))
			{
				$html = 'This code can not work without the AcyMailing Component';
				return $html;
			}
			else
			{
				$listClass = acymailing_get('class.list');
				$allLists = $listClass->getFrontendLists('listid');
				if (!$allLists || count($allLists) == 0 || !array_key_exists($listid, $allLists))
				{
					$html = 'Please create an acyMailing List';
					return $html;
				}
			}

			$list = $allLists[$listid];

			if (!include_once(rtrim(JPATH_ADMINISTRATOR, '/') . '/' . 'components' . '/' . 'com_acymailing' . '/' . 'helpers' . '/' . 'helper.php'))
			{
				echo 'This code can not work without the AcyMailing Component';
				return false;
			}

			// subscribed already?
			$checked = "";
			$userClass = acymailing_get('class.subscriber');
			$attendee = false;
			if ($this->attendee && $this->attendee->user_id>0){
				$attendee = $this->attendee->user_id;
			}
			else if ($this->attendee && $this->attendee->email_address !=""){
				$attendee = $this->attendee->email_address;
			}
			if ($attendee){
				$subid = $userClass->subid($attendee);
				if ($subid){
					$subs = $userClass->getSubscription($subid, 'listid');
					if ($subs && array_key_exists($listid ,$subs ) && $subs[$listid]->status){
						$checked = " checked='checked'";
					}
				}
			}
			else {
				// new attendees are checked by default
				$checked = " checked='checked'";
			}

			$html = "<label for='newslettersub'>$list->name <input type='checkbox' id='newslettersub' name='".$name . "[]' value='$listid' $checked /></label>";
		}

		return $html;

	}

	function getInput() {
		$name = $this->name;
		$id = $this->id;
		$value = $this->value;
		$fieldname = $this->fieldname;

		$user =  Factory::getUser();

		if (Factory::getApplication()->input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->user_id > 0 && $this->attendee->user_id != $user->get("id"))
		{
			$value = $this->attendee->user_id;
		}
		else if (Factory::getApplication()->input->getCmd("task") == "attendees.edit" && isset($this->attendee) && $this->attendee->id > 0 && $this->attendee->user_id == 0)
		{
			$value = 0;
		}

		$showinform = $this->attribute("showinform") || $this->attribute("formonly");

		$listid = intval($this->attribute("listid"));
		$html = "";

		if ($showinform && $listid > 0)
		{

			if (!include_once(rtrim(JPATH_ADMINISTRATOR, '/') . '/' . 'components' . '/' . 'com_acymailing' . '/' . 'helpers' . '/' . 'helper.php'))
			{
				$html = 'This code can not work without the AcyMailing Component';
				return $html;
			}
			else
			{
				$listClass = acymailing_get('class.list');
                // No longer getFrontendLists as we are loading by id now.
				$allLists = $listClass->getLists('listid');
				if (!$allLists || count($allLists) == 0 || !array_key_exists($listid, $allLists))
				{
					$html = 'Please create an acyMailing List';
					return $html;
				}
			}

			$list = $allLists[$listid];

			if (!include_once(rtrim(JPATH_ADMINISTRATOR, '/') . '/' . 'components' . '/' . 'com_acymailing' . '/' . 'helpers' . '/' . 'helper.php'))
			{
				echo 'This code can not work without the AcyMailing Component';
				return false;
			}

			// subscribed already?
			$checked = "";
			$userClass = acymailing_get('class.subscriber');
			$attendee = false;
			if ($this->attendee && $this->attendee->user_id>0){
				$attendee = $this->attendee->user_id;
			}
			else if ($this->attendee && $this->attendee->email_address !=""){
				$attendee = $this->attendee->email_address;
			}
			if ($attendee){
				$subid = $userClass->subid($attendee);
				if ($subid){
					$subs = $userClass->getSubscription($subid, 'listid');
					if ($subs && array_key_exists($listid ,$subs ) && $subs[$listid]->status){
						$checked = " checked='checked'";
					}
				}
			}
			else {
				// new attendees are checked by default
				$checked = $this->attribute('defaultchecked')?" checked='checked'": "";
			}

			$html = "<label for='newslettersub'>$list->name <input type='checkbox' id='newslettersub' name='".$name . "[]' value='$listid' $checked /></label>";
		}

		return $html;


	}

	function render_NOT_USED(&$xmlElement, $value, $control_name = 'params')
	{
		$showinform = 1; // $xmlElement->attributes("showinform");

		$name = $xmlElement->attributes()->name;
		$label = $xmlElement->attributes('label');
		$descr = $xmlElement->attributes('description');
		if (!$showinform)
			$label = "";

		$result[0] = $label . " ";
		$result[1] = $this->fetchElement($name, $value, $xmlElement, $control_name);
		$result[2] = $descr;
		$result[3] = $label;
		$result[4] = $value;
		$result[5] = $name;

		return $result;

	}

	function toXML($field)
	{
		$result = array();
		$result[] = "<field ";
		if (is_string($field->params) && strpos($field->params, "{") === 0)
		{
			$field->params = json_decode($field->params);
		}
		foreach (get_object_vars($field) as $k => $v)
		{
			if ($k == "options" || $k == "html" || $k == "defaultvalue" || $k == "name")
				continue;
			if ($k == "field_id")
			{
				$k = "name";
				$v = "field" . $v;
			}
			if ($k == "params")
			{
				if (is_object($field->params))
				{
					foreach (get_object_vars($field->params) as $label => $value)
					{
						$result[] = $label . '="' . addslashes(htmlspecialchars($value)) . '" ';
					}
				}
				continue;
			}
			$result[] = $k . '="' . addslashes(htmlspecialchars($v)) . '" ';
		}
		$result[] = " />";
		$xml = implode(" ", $result);
		return $xml;

	}

	public function convertValue($value)
	{
		return $value;

	}

	public  function postUpdateAction($node)
	{
		$attendeeparams = new Registry($this->attendee->params);
//var_dump($attendeeparams );
		$field = $this->attribute("name");
		$value = $attendeeparams->get($field);
		if (!$value){
			$value = array(0);
		}
		if (!is_array($value)){
			$value = array($value);
		}

		$newslettersub = Factory::getApplication()->input->get("newslettersub", $value);

		if (!include_once(rtrim(JPATH_ADMINISTRATOR, '/') . '/' . 'components' . '/' . 'com_acymailing' . '/' . 'helpers' . '/' . 'helper.php'))
		{
			echo 'This code can not work without the AcyMailing Component';
			return false;
		}

		$listid = $this->attribute('listid');
		// subscribed already?
		$checked = "";
		$userClass = acymailing_get('class.subscriber');

		$attendee = false;
		if ($this->attendee && $this->attendee->user_id>0){
			$attendee = $this->attendee->user_id;
		}
		else if ($this->attendee && $this->attendee->email_address !=""){
			$attendee = $this->attendee->email_address;
		}
		if ($attendee){
			$subid = $userClass->subid($attendee);

			// create subscriber/member if needed
			if (!$subid){
				$myUser = new stdClass();
				if (intval($attendee)>0){
					$attendee = JEVHelper::getUser($attendee);
					$myUser->email = $attendee->email;
					$myUser->name = $attendee->name;
					$myUser->userid = $attendee->id;
					$myUser->confirmed = 1;
				}
				else {
					$myUser->email = $attendee;
					$myUser->confirmed = 1;
				}
				// save new subscriber
				$subid = $userClass->save($myUser);
			}
			$subs = $userClass->getSubscription($subid, 'listid');

			if ($subs ){
				$newSubscription = array();
				$newList = array();
				if (!in_array($listid, $newslettersub) && array_key_exists($listid ,$subs ) && $subs[$listid]->status ){
					// remove
					$newList['status'] = 0;
					$newSubscription[$listid] = $newList;
				}
				else if (in_array($listid, $newslettersub)  && (!array_key_exists($listid ,$subs )  || (array_key_exists($listid ,$subs ) &&  !$subs[$listid]->status))) {
					// add
					$newList['status'] = 1;
					$newSubscription[$listid] = $newList;
				}
				if (count($newSubscription)){
					$userClass->saveSubscription($subid,$newSubscription);
				}
			}
		}
	}

}
class_alias("JFormFieldJevracymailingsubscription", "FormFieldJevracymailingsubscription");
