<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Component\ComponentHelper;

include_once(JPATH_ADMINISTRATOR.'/'."components/com_rsvppro/fields/JevrFieldText.php");

class JFormFieldJevrcbtext extends JevrFieldText
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	var	$_name = 'Jevrcbtext';
	#static public $label = "Editable CB  Field";
	const name = 'jevrcbtext';

    static function isEnabled()
    {

        if (File::exists(JPATH_SITE . '/components/com_comprofiler/comprofiler.php') && ComponentHelper::isEnabled("com_comprofiler"))
        {
            return true;
        }

        return false;

    }

	public static function loadScript($field=false){
		$lang = Factory::getLanguage();
		$lang->load("jevrcbtext", JPATH_ADMINISTRATOR);


		HTMLHelper::script( 'administrator/components/'.RSVP_COM_COMPONENT.'/fields/js/jevrcbtext.js' );

		if ($field){
			$id = 'field'.$field->field_id;
		}
		else {
			$id = '###';
		}
		ob_start();
?>
<div class='rsvpfieldinput'>
<div class="gsl-form-label"><?php echo Text::_("RSVP_FIELD_TYPE");?></div>
<div class="gsl-form-controls gsl-form-small" style="font-weight:bold;"><?php echo Text::_("RSVP_TEMPLATE_TYPE_JEVRCBTEXT");?></div>

	<input type="hidden" name="dv[<?php echo $id; ?>]"  value="" />
<div class="rsvpclear"></div>
<div class="gsl-form-label"><?php echo Text::_("RSVP_TEMPLATE_TYPE_JEVRCBTEXT_FIELD_SELECTION");?></div>
	<div class="gsl-form-controls gsl-form-small" style="font-weight:bold;"><?php RsvpHelper::fieldId($id);?></div>
	<select name="params[<?php echo $id; ?>][fieldname]" id="fieldname<?php echo $id; ?>"  onchange="jevrcbfield.setvalue('<?php echo $id; ?>');">
		<?php
		if (JFormFieldJevrcbtext::isEnabled()){
			// get the community builder language file - in the vain hope they have moved to Joomla 1.5 system
			$lang = Factory::getLanguage();
			$lang->load("com_comprofiler", JPATH_SITE);

			$cblanguagePath = JPATH_SITE . '/components/com_comprofiler/plugin/language';
			if (!defined('CBLIB')) {
				if(!defined('CBLIB')) include_once(JPATH_SITE.'/libraries/CBLib/CB/Application/CBApplication.php');
			}
			$languages =include( $cblanguagePath . "/default_language/language.php" );

			$db = Factory::getDBO();
			$db->setQuery("SELECT title, name FROM #__comprofiler_fields WHERE ( name != 'NA' ) ");
			$rawrows = $db->loadObjectList();

			// strip out exlucded fields
			$rows = array();
			$exfields = array();
			if (File::exists(JPATH_ADMINISTRATOR."/components/com_rsvppro/fields/cbexclusions.txt")){
				$exfields = file_get_contents(JPATH_ADMINISTRATOR."/components/com_rsvppro/fields/cbexclusions.txt");
				$exfields = explode("\n", $exfields);
			}
			else if (File::exists(JPATH_ADMINISTRATOR."/components/com_rsvppro/fields/cbexclusions.starter.txt")){
				$exfields = file_get_contents(JPATH_ADMINISTRATOR."/components/com_rsvppro/fields/cbexclusions.starter.txt");
				$exfields = explode("\n", $exfields);
			}
			foreach ($rawrows as $row){
				if (in_array($row->title, $exfields) || in_array($row->name, $exfields)) continue;
				$rows[] = $row;
			}

			$fieldname = "";
			$activeField = "";
			$canmodify = true;
			$updatefromprofile = true;
			if ($field)
			{
				try {
					$params = json_decode($field->params);
					$fieldname = isset($params->fieldname) ? $params->fieldname : "";
					$canmodify = isset($params->canmodify) ? $params->canmodify : 1;
					$updatefromprofile = isset($params->updatefromprofile) ? $params->updatefromprofile : 1;
				}
				catch (Exception $e) {

				}
			}

			if (count($rows) > 0)
			{
				//foreach ($rows as $row) {
				for ($i = 0; $i < count($rows); $i++)
				{
					$row = $rows[$i];
					if (array_key_exists($row->title, $languages))
					{
						$cbFieldName = $languages[$row->title];
					}
					else
					{
						$cbFieldName = $row->title;
					}

					$selected = "";
					if ($field && $fieldname == $row->name)
					{
						$selected = "selected='selected'";
						$activeField = $cbFieldName;
					}
			?>

						<option value="<?php echo $row->name; ?>" <?php echo $selected; ?> ><?php echo$cbFieldName ?></option>
		<?php
				}
			}
		}
	?>
		</select>

	<div class="rsvpclear"></div>

	<?php
	RsvpHelper::hidden($id,  $field, self::name);
	RsvpHelper::label($id,  $field, self::name);
	RsvpHelper::tooltip($id,  $field);
	?>

	<div class="rsvpclear"></div>
	<?php
	RsvpHelper::size($id,  $field, self::name);
	RsvpHelper::maxlength($id,  $field, self::name);

	?>
        <div class="gsl-form-label"><?php echo Text::_("RSVP_CBFIELD_USER_CAN_MODIFY"); ?></div>
        <div class="gsl-form-controls radio gsl-button-group">
            <label for="canmodify1<?php echo $id; ?>" class="gsl-button radio" ><?php echo Text::_("JYES"); ?>
            <input type="radio" name="params[<?php echo $id; ?>][canmodify]"  id="canmodify1<?php echo $id; ?>" value="1" <?php
        if ($canmodify)
        {
            echo 'checked="checked"';
        }
                ?>  />
            </label>
            <label for="canmodify0<?php echo $id; ?>"  class="gsl-button radio" ><?php echo Text::_("JNO"); ?>
            <input type="radio" name="params[<?php echo $id; ?>][canmodify]" id="canmodify0<?php echo $id; ?>" value="0" <?php
           if (!$canmodify)
           {
               echo 'checked="checked"';
           }
                ?>  />
            </label>
        </div>
        <div class="rsvpclear"></div>
    <div class="gsl-form-label"><?php echo Text::_("RSVP_CBFIELD_UPDATES_FROM_PROFILE"); ?></div>
    <div class="gsl-form-controls radio gsl-button-group">
        <label for="updatefromprofile1<?php echo $id; ?>" class="gsl-button radio" ><?php echo Text::_("JYES"); ?>
            <input type="radio" name="params[<?php echo $id; ?>][updatefromprofile]"  id="updatefromprofile1<?php echo $id; ?>" value="1" <?php
			if ($updatefromprofile)
			{
				echo 'checked="checked"';
			}
			?>  />
        </label>
        <label for="updatefromprofile0<?php echo $id; ?>"  class="gsl-button radio" ><?php echo Text::_("JNO"); ?>
            <input type="radio" name="params[<?php echo $id; ?>][updatefromprofile]" id="updatefromprofile0<?php echo $id; ?>" value="0" <?php
			if (!$updatefromprofile)
			{
				echo 'checked="checked"';
			}
			?>  />
        </label>
    </div>
    <div class="rsvpclear"></div>
	<?php

	RsvpHelper::required($id,  $field);
	RsvpHelper::requiredMessage($id,  $field);
	RsvpHelper::conditional($id,  $field);
    RsvpHelper::className($id, $field);
	RsvpHelper::peruser($id, $field);
	RsvpHelper::formonly($id,  $field);
	RsvpHelper::showinform($id,  $field);
	RsvpHelper::showindetail($id,  $field);
	RsvpHelper::showinlist($id,  $field);
	RsvpHelper::showinticket($id, $field);
	RsvpHelper::includeinexport($id,  $field);
	RsvpHelper::allowoverride($id,  $field);
	RsvpHelper::accessOptions($id,  $field);
	RsvpHelper::applicableCategories("facc[$id]","facs[$id]", $id,  $field?$field->applicablecategories:"all");
	?>

	<div class="rsvpclear"></div>

</div>
<div class='rsvpfieldpreview'  id='<?php echo $id;?>preview'>
	<div class="previewlabel"><?php echo Text::_("RSVP_PREVIEW");?></div>
	<div class="gsl-form-label rsvppl" id='pl<?php echo $id;?>' ><?php echo $field?$field->label:Text::_("RSVP_FIELD_LABEL");?></div>
	<input type="text"  id="pdv<?php echo $id;?>" value="<?php echo $field?$field->defaultvalue:"";?>" size="<?php echo $field?$field->size:5;?>"  />
</div>
<div class="rsvpclear"></div>
		<?php
		$html = ob_get_clean();

		return RsvpHelper::setField($id,  $field, $html, self::name	);

	}

	function getInput()
	{
		//$name, $value, &$node
		$node =  $this->element;
		$name = $this->name;
		$id = $this->id;
		$value = $this->value;
		$fieldname = $this->fieldname;

		$size = ( $this->attribute('size') ? 'size="'.$this->attribute('size').'"' : '' );
		$class = ( $this->attribute('class') ? 'class="'.$this->attribute('class').' xxx"' : 'class="text_area xxx"' );
		$showinform = $this->attribute("showinform");
                $maxlength = ( $this->attribute('maxlength') ? 'maxlength="'.$this->attribute('maxlength').'"' : '' );

		$html = "";

		if ($showinform)
		{
			if (Factory::getApplication()->isClient('administrator') && is_array($value) && count($value)==1 && $value[0]==""){
				$value= $this->convertValue($value[0],  "php");
				if (is_array($value) && count($value)==1 && is_array($value[0])){
					$value = $value[0];
				}
			}
			else if (Factory::getApplication()->isClient('administrator') && $value==""){
				$newvalue= $this->convertValue($value,  "php");
				if (is_array($newvalue) && count($newvalue)==1 && $this->attribute("peruser")==0){
					$value = current($newvalue);
				}
				else {
					$value = $newvalue;
				}
			}

			/*
			 * Required to avoid a cycle of encoding &
			 * html_entity_decode was used in place of htmlspecialchars_decode because
			 * htmlspecialchars_decode is not compatible with PHP 4
			 */
			if (is_array($value)){
				$value = array_values($value);
				foreach ($value as &$val){
					if (is_array($val)){
						foreach (array_keys($val) as $key){
							$val[$key] = htmlspecialchars(html_entity_decode($val[$key], ENT_QUOTES), ENT_QUOTES);
						}
					}
					else {
						$val = htmlspecialchars(html_entity_decode($val, ENT_QUOTES), ENT_QUOTES);
					}
				 }
				 unset($val);
			}
			else {
				$value = htmlspecialchars(html_entity_decode($value, ENT_QUOTES), ENT_QUOTES);
			}
			if ($value=="" || !isset($this->attendee) || is_bool($this->attendee)){
				$user =  Factory::getUser();
				if (is_bool($this->attendee)){
					$isbool = $this->attendee;
				}
				if (!isset($this->attendee) || is_bool($this->attendee)){
					$this->attendee = new stdClass();
					$this->attendee->user_id = $user->id;
				}
				$value = $this->convertValue($value,  "php");
				if (isset($isbool)){
					$this->attendee = $isbool;
				}

				if ($this->attribute("peruser")==0) {
					if (is_string($value)){
						$value = strip_tags($value);
					}
					else {
						$value = current($value);
					}
				}
			}

			if ($this->attribute("peruser")==1 || $this->attribute("peruser")==2){
				if (!is_array($value)){
					$value = array($value);
				}
				if (count($value)<$this->currentAttendees){
					// flesh out the value if there are not the right number of items
					for ($i=0;$i<=$this->currentAttendees-count($value);$i++){
						if ($this->attribute("default")!=""){
							$default = $this->attribute("default");
						}
						else if (isset($value[0]) && $value[0]!=""){
							$default = $value[0];
						}
						else if (isset($value[1]) && $value[1]!=""){
							$default = $value[1];
						}
						else {
							$default = $this->attribute("default");
						}
						$value[] = $default;
					}
				}

				for ($v=0;$v<count($value);$v++){
					if (is_string($value[$v])){
						$value[$v] = strip_tags($value[$v]);
					}
					else {
						$value[$v] = current($value[$v]);
					}
				}

				$elementname = $name.'[]';
				$html = "";
				$i = 0;
				foreach ($value as $val){
					if ($i==0){
						if ($this->attribute("peruser")==2){
							$thisclass = str_replace(" xxx"," disabledfirstparam rsvpparam rsvpparam0 rsvp_" . $fieldname,$class);
						}
						else {
							// is this the attendee name field?
							if ($val=="" && !Factory::getApplication()->isClient('administrator') && $this->attribute("isname")){
								if ($this->attendee && $this->attendee->user_id>0){
									$atdee = JEVHelper::getUser($this->attendee->user_id);
								}
								else {
									$atdee = Factory::getUser();
								}
								$val  = $atdee->name;
							}
							$thisclass = str_replace(" xxx"," rsvpparam rsvpparam0 rsvp_" . $fieldname,$class);
						}
					}
					else {
						$thisclass = str_replace(" xxx"," rsvpparam rsvpparam".$i."  rsvp_" . $fieldname,$class);
					}

					if ( $this->attribute("updatefromprofile", 1) && $this->attribute("canmodify", 1))
					{
						$profileValue = $this->convertValue("",  'php');
						if (isset($profileValue[0]))
						{
							$profileValue = isset($profileValue[0][$this->attribute("fieldname")]) ? $profileValue[0][$this->attribute("fieldname")] : $profileValue[0];
						}
						else
						{
							$profileValue = "";
						}

						$cupfvalue = $profileValue;
						if (isset($this->form->_rawData[$fieldname . '_cupf']))
						{
							$cupfvalue = $this->form->_rawData[$fieldname . '_cupf'];
						}
						if(is_array($cupfvalue))
						{
							$cupfvalue = $cupfvalue[$i];
						}

						// cupfvalue is customised value
						// upfvalue is old profile value

						$upfvalue = $profileValue;
						if (isset($this->form->_rawData[$fieldname . '_upf']))
						{
							$upfvalue = $this->form->_rawData[$fieldname . '_upf'];
						}
						if(is_array($upfvalue))
						{
							$upfvalue = $upfvalue[$i];
						}

						// Has the value been customised?
						if ($upfvalue != $cupfvalue)
						{
							$val = $cupfvalue;
						}
						else
						{
							$val = $profileValue;
						}

						$onchange = "onchange = 'document.getElementById(\"" .  $id . '_cupf' . "\").value = this.value'";

						$cupfname = str_replace($fieldname, $fieldname . "_cupf", $elementname);
						$html .= '<input type="hidden" name="' . $cupfname . '" id="' . $id . "_" . $i. '_cupf" value="' . $upfvalue . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . ' />';

						$upfname = str_replace($fieldname, $fieldname . "_upf", $elementname);
						$html .= '<input type="hidden" name="' . $upfname . '" id="' . $id . "_" . $i. '_upf" value="' . $upfvalue . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . ' />';
					}

					if ( $this->attribute("canmodify"))
					{
						$onchange = "onchange = 'document.getElementById(\"" .  $id . '_cupf' . "\").value = this.value'";
						$html .= '<input type="text" name="' . $elementname . '" id="' . $id . "_" . $i . '" value="' . $val . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . ' ' . $onchange . ' />';
					}
					else
					{
						$html .= '<input type="text" readonly="readonly" name="' . $elementname . '" id="' . $id . "_" . $i . '" value="' . $val . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . '  />';
					}

					$i++;
				}
				if ($this->attribute("default")!=""){
					$default = $this->attribute("default");
				}
				else if (isset($value[0]) && $value[0]!=""){
					$default = $value[0];
				}
				else if (isset($value[1]) && $value[1]!=""){
					$default = $value[1];
				}
				else {
					$default = $this->attribute("default");
				}

				$val =$default;
				$thisclass = str_replace(" xxx"," paramtmpl rsvp_" . $fieldname,$class);

				$onchange = "";
				if ( $this->attribute("updatefromprofile", 1) && $this->attribute("canmodify", 1))
				{
					$profileValue = $this->convertValue("",  'php');
					if (isset($profileValue[0]))
					{
						$profileValue = isset($profileValue[0][$this->attribute("fieldname")]) ? $profileValue[0][$this->attribute("fieldname")] : $profileValue[0];
					}
					else
					{
						$profileValue = "";
					}

					// cupfvalue is customised value
					// upfvalue is old profile value

					$cupfvalue = $profileValue;

					$upfvalue = $profileValue;

					$onchange = "onchange = 'document.getElementById(this.id + \"_cupf\").value = this.value'";

					$cupfname = str_replace($fieldname, $fieldname . "_cupf", $elementname);
					$html .= '<input type="hidden" name="paramtmpl_' . $cupfname . '" id="' . $id . '_xxx_cupf" value="' . $upfvalue . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . ' />';

					$upfname = str_replace($fieldname, $fieldname . "_upf", $elementname);
					$html .= '<input type="hidden" name="paramtmpl_' . $upfname . '" id="' . $id . '_xxx_upf" value="' . $upfvalue . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . ' />';
				}

				if ( $this->attribute("canmodify"))
				{
					$onchange = "onchange = 'document.getElementById(this.id + \"_cupf\").value = this.value'";
    				$html .= '<input type="text" name="paramtmpl_'.$elementname.'" id="'.$id.'_xxx" value="'.$val.'" '.$thisclass.' '.$size.' '.$maxlength.' ' . $onchange . ' />';
				}
				else
				{
					$html .= '<input type="text" readonly="readonly" name="paramtmpl_'.$elementname.'" id="'.$id.'_xxx" value="'.$val.'" '.$thisclass.' '.$size.' '.$maxlength.'  />';
                }

				return $html;

			}

			$elementname = $name;
			$thisclass = str_replace(" xxx"," ",$class);

			$html = "";
			$onchange = "";
			if ( $this->attribute("updatefromprofile", 1) && $this->attribute("canmodify", 1))
			{
				$profileValue = $this->convertValue("",  'php');
				$profileValue = isset($profileValue[$this->attribute("fieldname")]) ? $profileValue[$this->attribute("fieldname")] : $profileValue;

				$cupfvalue = $profileValue;
				if (isset($this->form->_rawData[$fieldname . '_cupf']))
				{
					$cupfvalue = $this->form->_rawData[$fieldname . '_cupf'];
				}

				// cupfvalue is customised value
                // upfvalue is old profile value

				$upfvalue = $profileValue;
				if (isset($this->form->_rawData[$fieldname . '_upf']))
				{
					$upfvalue = $this->form->_rawData[$fieldname . '_upf'];
				}

				// Has the value been customised?
				if ($upfvalue != $cupfvalue)
				{
					$value = $cupfvalue;
				}
				else
                {
	                $value = $profileValue;
                }

				$onchange = "onchange = 'document.getElementById(\"" .  $id . '_cupf' . "\").value = this.value'";

				$cupfname = str_replace($fieldname, $fieldname . "_cupf", $elementname);
				$html .= '<input type="hidden" name="' . $cupfname . '" id="' . $id . '_cupf" value="' . $upfvalue . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . ' />';

				$upfname = str_replace($fieldname, $fieldname . "_upf", $elementname);
				$html .= '<input type="hidden" name="' . $upfname . '" id="' . $id . '_upf" value="' . $upfvalue . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . ' />';
			}

			if ( $this->attribute("canmodify", 1))
            {
	            $html .= '<input type="text" name="' . $elementname . '" id="' . $id . '" value="' . $value . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . '  ' . $onchange .' />';
            }
            else
            {
	            $html .= '<input type="text" readonly="readonly"  name="' . $elementname . '" id="' . $id . '" value="' . $value . '" ' . $thisclass . ' ' . $size . ' ' . $maxlength . ' />';
	         //   $html .= $value;
            }

		}
		return $html;
	}

	function render_NOT_USED(&$xmlElement, $value, $control_name = 'params')
	{
		$showinform = $xmlElement->attributes("showinform");

		$name = $xmlElement->attributes()->name;
		$label = $xmlElement->attributes('label');
		$descr = $xmlElement->attributes('description');
		if (!$showinform)
			$label = "";

		$result[0] = $label . " ";
		$result[1] = $this->fetchElement($name, $value, $xmlElement, $control_name);
		$result[2] = $descr;
		$result[3] = $label;
		$result[4] = $value;
		$result[5] = $name;

		return $result;

	}

	function toXML($field)
	{
		$result = array();
		$result[] = "<field ";
		if (is_string($field->params) && strpos($field->params, "{") === 0)
		{
			$field->params = json_decode($field->params);
		}
		foreach (get_object_vars($field) as $k => $v)
		{
			if ($k == "options" || $k == "html" || $k == "defaultvalue" || $k == "name")
				continue;
			if ($k == "field_id")
			{
				$k = "name";
				$v = "field" . $v;
			}
			if ($k == "params")
			{
				if (is_object($field->params))
				{
				   foreach (get_object_vars($field->params) as $label=>$value)
				   {
					   $result[] = $label . '="' . addslashes(htmlspecialchars($value)) . '" ';
				   }
				}
				continue;
			}
			$result[] = $k . '="' . addslashes(htmlspecialchars($v)) . '" ';
		}
		$result[] = " />";
		$xml = implode(" ", $result);
		return $xml;

	}

	public function convertValue($value, $format="html", $index = 0)
	{
		if (!is_null($value) && $value !="" && (!is_numeric($value) && $format="html")) {
			return $value;
		}
		$fieldname = $this->attribute("fieldname");

		if (!JFormFieldJevrcbtext::isEnabled()) return $value;

		/**
		 * CB framework
		 * @global CBframework $_CB_framework
		 */
		global $_CB_framework;
		/** @global array $ueConfig */
		global $ueConfig;
		if (defined('JPATH_ADMINISTRATOR'))
		{
			include_once( JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php' );
		}
		else
		{
			include_once( Factory::getApplication()->getCfg('absolute_path') . '/administrator/components/com_comprofiler/plugin.foundation.php' );
		}

		$_CB_framework->cbset('_ui', 1); // we're in 1: frontend, 2: admin back-end

		if ($_CB_framework->getCfg('debug'))
		{
			//ini_set('display_errors', true);
			//error_reporting(E_ALL);
		}

		cbimport('language.front');
		cbimport('cb.tabs');
		cbimport('cb.imgtoolbox');

		global $_PLUGINS;
		$_PLUGINS->loadPluginGroup('user');

		include_once(JPATH_SITE . "/components/com_comprofiler/plugin/user/plug_cbcore/cb.core.php");

		$baseurl = JURI::root();
		if (is_null($value) && !$this->attendee && $format!="php" )
		{
			$html = "";
		}
		else
		{
			if (is_null($value) || $value == "")
			{
				if ($this->attendee && $this->attendee->user_id > 0)
					$value = $this->attendee->user_id;
				else if ($format !="php"){
					return "";
				}
				else {
					if (Factory::getApplication()->input->getCmd("task")=="attendees.edit" ){
						return "";
					}
					else {
						$value = Factory::getUser()->id;
					}
				}
			}
			// Does the value need to be updated to reflect the profile change
			if ($format == "html" && $this->attribute("updatefromprofile", 1) && $this->attribute("canmodify", 1))
            {
	            $profileValue = $this->convertValue("",  'php');
	            $profileValue = isset($profileValue[0]) ? $profileValue[0] : $profileValue;
	            $profileValue = isset($profileValue[$this->attribute("fieldname")]) ? $profileValue[$this->attribute("fieldname")] : $profileValue;

	            $cupfvalue = $value;
	            if (isset($this->form->_rawData[$this->fieldname . '_cupf']))
	            {
		            $cupfvalue = $this->form->_rawData[$this->fieldname . '_cupf'];
	            }
	            if (is_array($cupfvalue))
                {
	                $cupfvalue = $cupfvalue [$index];
                }

	            // cupfvalue is customised value
	            // upfvalue is old profile value

	            $upfvalue = $value;
	            if (isset($this->form->_rawData[$this->fieldname . '_upf']))
	            {
		            $upfvalue = $this->form->_rawData[$this->fieldname . '_upf'];
	            }
	            if (is_array($upfvalue))
	            {
		            $upfvalue = $upfvalue [$index];
	            }

	            // Has the value been customised?
	            if ($upfvalue != $cupfvalue)
	            {
		            $value = $cupfvalue;
	            }
	            else
                {
	                $value = $profileValue;
                }
            }
			if (is_numeric($value) && ($value != Factory::getUser()->id && $value !=  $this->attendee->user_id )) {
				return $value;
			}
			if (!is_numeric($value)){
				return $value;
			}
			$user =  JEVHelper::getUser($value);
			if (!isset($user->cbProfile))
			{
				$db = Factory::getDBO();
				$user->cbProfile = new stdClass();
				$db->setQuery('SELECT cbprofile.*, user.name, user.username, user.lastvisitDate, user.registerDate ' .
						'FROM #__comprofiler AS cbprofile ' .
						'LEFT JOIN #__users AS user ON ( user.id = cbprofile.user_id ) ' .
						' WHERE ( cbprofile.user_id = \'' . $user->id . '\' ) ');
				$user->cbProfile = $db->loadObject();
			}

			static $fieldclasses;
			if (!isset($fieldclasses))
			{
				$db = Factory::getDBO();
				$db->setQuery('SELECT * FROM #__comprofiler_fields AS fld');
				$fieldclasses = $db->loadObjectList('name');
			}
			if ($user->cbProfile)
			{

				if (isset($user->cbProfile->$fieldname))
				{
					if (array_key_exists($fieldname, $fieldclasses))
					{
						$cbUser = CBuser::getInstance($user->id);
						//$html = $cbUser->getField( $fieldname, "", "html", "span", 'profile');
						$html = @$cbUser->getField($fieldname, "", $format, "span", 'adminfulllist');
						if (is_string($html) && trim($html) == "")
						{
							$html = $user->cbProfile->$fieldname;
						}
					}
					else
					{
						$html = $user->cbProfile->$fieldname;
					}
				}
				else
				{
					$cbUser = CBuser::getInstance($user->id);
					$html = @$cbUser->getField($fieldname, "", $format, "span", 'profile');
					//$html = $cbUser->getField( $fieldname, "", "html", "span", 'adminfulllist');
					if (is_string($html) && trim($html) == "" && isset($user->$fieldname))
					{
						$html = $user->$fieldname;
					}
				}
			}
			else
			{
				$html = "";
			}
		}
		if (!$this->attendee)
        {
	        if ($this->attribute("peruser")==1){
		        return array_fill(0, 1, $html);
	        }
	        else if ($this->attribute("peruser")==2 ){
		        $return = array_fill(0, 1, $html);
		        return $return;
	        }
	        return $html;
        }
		if (!isset($this->attendee->guestcount)){
			$this->attendee->guestcount=1;
		}
		if ($this->attribute("peruser")==1 && $this->attendee->guestcount>0){
			return array_fill(0, $this->attendee->guestcount, $html);
		}
		else if ($this->attribute("peruser")==2 && $this->attendee->guestcount>0){
			$return = array_fill(0, $this->attendee->guestcount, $html);
			//$return[0]="";
			return $return;
		}
		return $html;

	}

	function skipRequiredScript()
	{
		// Skip required check if adding an attendee manually
		if (Factory::getApplication()->input->getCmd("task")=="attendees.edit"){
			return true;
		}
		return false;
	}

	function currentAttendeeCount($node, $value){
		if (is_array($value) && count($value)>1) {
			return count($value)-1;
		}
		return 1;
	}

	function fieldName()
	{
		return Text::_("RSVP_TEMPLATE_TYPE_JEVRCBTEXT");

	}

}
class_alias("JFormFieldJevrcbtext", "FormFieldJevrcbtext");
