<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: jevboolean.php 1569 2009-09-16 06:22:03Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

use Joomla\Utilities\ArrayHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;

include_once(JPATH_ADMINISTRATOR ."/components/com_rsvppro/fields/JevrFieldList.php");
$language = Factory::getLanguage();
$language->load('com_rsvppro', JPATH_ADMINISTRATOR);

class JFormFieldJevrdblist extends JevrFieldList
{

	protected $node;
	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var $_name = 'jevrdblist';
	const name = 'jevrdblist';

	public static function loadScript($field=false){

		if ($field)
		{
			$id = 'field' . $field->field_id;
		}
		else
		{
			$id = '###';
		}
		ob_start();
?>
<div class='rsvpfieldinput'>
        <div class="gsl-form-label"><?php echo Text::_("RSVP_FIELD_TYPE"); ?></div>
        <div class="gsl-form-controls gsl-form-small" style="font-weight:bold;"><?php echo Text::_("RSVP_TEMPLATE_TYPE_jevrdblist"); ?><?php RsvpHelper::fieldId($id); ?></div>
        <div class="rsvpclear"></div>

	<?php
	RsvpHelper::hidden($id,  $field, self::name);
	RsvpHelper::label($id,  $field, self::name);
	RsvpHelper::tooltip($id, $field);

        if ($field)
        {
                try {
                        $params = json_decode($field->params);
                }
                catch (Exception $e) {
                        $params = array();
                }
        }
        $fieldquery = isset($params->fieldquery) ? $params->fieldquery : "";

	RsvpHelper::textArea("fieldquery$id", "params[$id][fieldquery]", $field, Text::_("JEVR_DBLIST_QUERY_FIELD"), Text::_('JEVR_DBLIST_QUERY_FIELD_DESC'),"fieldquery", "SELECT ug.title FROM #__usergroups AS ug \nINNER JOIN #__user_usergroup_map AS ugm ON ugm.group_id = ug.id \nWHERE ugm.user_id={ATTENDEE_USER_ID}");

        RsvpHelper::required($id, $field);
        RsvpHelper::requiredMessage($id, $field);
	?>

    <div class="gsl-form-label"><?php echo Text::_("RSVP_DEFAULT_VALUE");?></div>
    <div class="gsl-form-controls">
		<textarea name="dv[<?php echo $id;?>]" id="dv<?php echo $id;?>" onchange="jevrtextarea.setvalue('<?php echo $id;?>');" onkeyup="jevrtextarea.setvalue('<?php echo $id;?>');"
                  rows="<?php echo $field?$field->rows:5;?>" cols="<?php echo $field?$field->cols:20;?>" ><?php echo $field?$field->defaultvalue:"";?></textarea>
    </div>
    <div class="rsvpclear"></div>

	<?php
        RsvpHelper::conditional($id, $field);
        RsvpHelper::className($id, $field);
        RsvpHelper::peruser($id, $field);
        RsvpHelper::formonly($id, $field);
        RsvpHelper::showinform($id, $field);
        RsvpHelper::showindetail($id, $field);
        RsvpHelper::showinlist($id, $field);
		RsvpHelper::showinticket($id, $field);
		RsvpHelper::includeinexport($id,  $field);
        RsvpHelper::allowoverride($id, $field);
        RsvpHelper::accessOptions($id, $field);
        RsvpHelper::applicableCategories("facc[$id]", "facs[$id]", $id, $field ? $field->applicablecategories : "all");
	?>

	<div class="rsvpclear"></div>

</div>
    <div class='rsvpfieldpreview'  id='<?php echo $id;?>preview'>
            <div class="previewlabel"><?php echo Text::_("RSVP_PREVIEW");?></div>
            <div class="gsl-form-label rsvppl" id='pl<?php echo $id;?>' ><?php echo $field ? $field->label : Text::_("RSVP_FIELD_LABEL"); ?></div>
            <div id="pdv<?php echo $id;?>">
            </div>
    </div>
    <div class="rsvpclear"></div>
		<?php
		$html = ob_get_clean();

		return RsvpHelper::setField($id,  $field, $html, self::name	);

	}

	function getInput()
	{
		$name = $this->name;
		$value =  $this->value;
		$class = ( $this->element['class'] ? 'class="'.$this->element['class'].'"' : 'class="inputbox"' );

		$default =  Text::_("RSVP_PLEASE_SELECT");

		$db = Factory::getDbo();
		$fieldquery = $this->attribute('fieldquery',0);
		if (!$fieldquery) {
			return "<strong>Invalid attributes - please specify field query</strong>";
		}
                $user = Factory::getUser();
                $id = $user->id;
                if (isset($this->attendee->user_id)){
                    $id = $this->attendee->user_id;
                }
                $fieldquery = str_replace("{ATTENDEE_USER_ID}", $id, stripslashes($fieldquery));
		$db->setQuery($fieldquery);
		$data = $db->loadColumn();
		$options = array();
		$options[] = JHTML::_('select.option', 0, $default);
		foreach ($data as $option)
		{
			$options[] = JHTML::_('select.option', $option, $option);
		}

		if ($this->attribute('multifilter',0)==1){
			if ($value != ""){
				$value = explode(",",$value);
				$value = ArrayHelper::toInteger($value);
			}
			else {
				$value = array();
			}

			$size =  ( $this->attribute('filtersize') ? ' size="'.$this->attribute('filtersize').'"' : '' );
			$multiple = ' multiple="multiple"';
			return JHTML::_('select.genericlist', $options, $this->name, $class.$size.$multiple, 'value', 'text', $value, $this->id);
		}
		else {
			return JHTML::_('select.genericlist', $options, $this->name, $class, 'value', 'text', $value, $this->id);
		}
	}

	function fetchRequiredScript($name,  $control_name)
	{
		$elementid = $this->id;
	    $script = "";

		$default = $this->attribute('default', "9038y459086");

		if ($default === "")
        {
            $default = '0';
        }

		if ($this->attribute('required') && $default !== "9038y459086")
		{
			//$script = "jevrsvpRequiredFields.fields.push({'name':'" . $control_name . $name . "', 'id':'" . $elementid . "', 'default' :'" . $this->attribute('default') . "' ,'reqmsg':'" . trim(Text::_($this->attribute('requiredmessage'), true)) . "'}); ";

			if ($this->attribute("peruser") == 1 || $this->attribute("peruser") == 2)
			{

				$i = 0;
				$script = "";
				foreach ($this->value as $val)
				{
					if ($val == "#%^£xx£^%#" || $i > 2)
						continue;
					$elementid = $this->id . '_' . $i;
					$elementname = $this->name."[]";
					//$script .= "jevrsvpRequiredFields.fields.push({'name':'" . $elementname . "', 'id':'" . $elementid . "',  'default' :'" . $this->attribute('default') . "' ,'reqmsg':'" . trim(Text::_($this->attribute('requiredmessage'), true)) . "'}); ";
					$script .= "jevrsvpRequiredFields.fields.push({'name':'" . $elementname . "', 'id':'" . $elementid . "',  'default' :'" . $default . "' ,'reqmsg':'" . trim(Text::_($this->attribute('requiredmessage'), true)) . "'}); ";
					break;
					$i++;
				}
			}
			else
			{
				$elementid = $this->id;
				$elementname = $this->name;
				$script = "jevrsvpRequiredFields.fields.push({'name':'" . $elementname . "', 'id':'" . $elementid . "',  'default' :'" . $default . "' ,'reqmsg':'" . trim(Text::_($this->attribute('requiredmessage'), true)) . "'}); ";
			}

		}
		return $script ;
	}
/*
	function fetchCategoryRestrictionScript($name, &$node, $control_name, $cats)
	{
		$script = "JevrCategoryFields.fields.push({'name':'".$name."', 'default' :'".$this->attribute('default') ."' ,'catids':".  json_encode($cats)."}); ";
		return $script;
	}
 */


}
class_alias("JFormFieldJevrdblist", "FormFieldJevrdblist");
