<?php

// No direct access
defined('_JEXEC') or die;

use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\Object\CMSObject;

/**
 * JEvents component helper.
 *
 * @package        RSVP Pro
 * @since          1.6
 */
class RsvpproHelper
{

	public static $extention = 'com_rsvppro';

	/**
	 * Configure the Linkbar.
	 *
	 * @param string    The name of the active view.
	 */
	public static function addSubmenu($vName = "")
	{
		return;
		$task   = Factory::getApplication()->input->getCmd("task", "cpanel.cpanel");
		$option = Factory::getApplication()->input->getCmd("option", "com_categories");

		if ($option == 'com_categories')
		{
			$doc = Factory::getDocument();
			if (!version_compare(JVERSION, "3.0", 'ge'))
			{
				$hide_options = '#toolbar-popup-options {'
					. 'display:none;'
					. '}';
			}
			else
			{
				$hide_options = '#toolbar-options {'
					. 'display:none;'
					. '}';
			}
			$doc->addStyleDeclaration($hide_options);
		}

		if ($vName == "")
		{
			$vName = $task;
		}

		if (JevJoomlaVersion::isCompatible("3.0"))
		{
			JHtmlSidebar::addEntry(
				Text::_('CONTROL_PANEL'),
				'index.php?option=com_rsvppro',
				$vName == 'cpanel.cpanel'
			);

			$juser      = Factory::getUser();
			$authorised = false;
			if ($juser->authorise('core.admin', 'com_rsvppro'))
			{
				$authorised = true;
			}

			// could be called from categories component
			JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");

			JHtmlSidebar::addEntry(
				Text::_('RSVP_SESSIONS'),
				"index.php?option=$option&task=sessions.list",
				$vName == 'sessions.list'
			);

			if ($authorised)
			{
				JHtmlSidebar::addEntry(
					Text::_('RSVP_PRO_PAYMENT_METHODS'),
					"index.php?option=" . RSVP_COM_COMPONENT . "&task=pmethods.overview",
					$vName == 'pmethods.overview'
				);

				JHtmlSidebar::addEntry(
					Text::_('RSVP_TEMPLATES'),
					"index.php?option=$option&task=templates.list",
					$vName == 'templates.list'
				);

				JHtmlSidebar::addEntry(
					Text::_('RSVP_CONFIGURATION'),
					"index.php?option=" . RSVP_COM_COMPONENT . "&task=params.edit",
					$vName == 'params.edit'
				);
				JHtmlSidebar::addEntry(
					Text::_('COM_RSVPPRO_TITLE_EMAILREMINDERS_QUEUE'),
					"index.php?option=" . RSVP_COM_COMPONENT . "&view=emailreminders",
					$vName == 'emailreminders'
				);
				JHtmlSidebar::addEntry(
					Text::_('COM_RSVPPRO_TITLE_EMAILINVITEES_QUEUE'),
					"index.php?option=" . RSVP_COM_COMPONENT . "&view=emailinvitees",
					$vName == 'emailinvitees'
				);
			}

			JHtmlSidebar::addEntry(Text::_('RSVP_RETURN_TO_JEVENTS'), "index.php?option=com_jevents&task=cpanel.cpanel", false);
		}
		else
		{
			JSubMenuHelper::addEntry(
				Text::_('CONTROL_PANEL'), 'index.php?option=com_rsvppro', $vName == 'cpanel.cpanel'
			);
			$juser      = Factory::getUser();
			$authorised = false;
			if ($juser->authorise('core.admin', 'com_rsvppro'))
			{
				$authorised = true;
			}
// could be called from categories component
			JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");
			JSubMenuHelper::addEntry(
				Text::_('RSVP_TEMPLATES'), "index.php?option=$option&task=templates.list", $vName == 'templates.list'
			);
			JSubMenuHelper::addEntry(
				Text::_('RSVP_SESSIONS'), "index.php?option=$option&task=sessions.list", $vName == 'sessions.list'
			);
			if ($authorised)
			{
				JSubMenuHelper::addEntry(
					Text::_('RSVP_PRO_PAYMENT_METHODS'), "index.php?option=" . RSVP_COM_COMPONENT . "&task=pmethods.overview", $vName == 'pmethods.overview'
				);
				JSubMenuHelper::addEntry(
					Text::_('RSVP_CONFIGURATION'), "index.php?option=" . RSVP_COM_COMPONENT . "&task=params.edit", $vName == 'params.edit'
				);
			}
		}
	}

	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @param int        The category ID.
	 * @param int        The article ID.
	 *
	 * @return    CMSObject
	 */
	public static function getActions($categoryId = 0, $articleId = 0)
	{
		$user   = Factory::getUser();
		$result = new CMSObject;

		if (empty($articleId) && empty($categoryId))
		{
			$assetName = 'com_rsvppro';
		}
		else if (empty($articleId))
		{
			$assetName = 'com_rsvppro.category.' . (int) $categoryId;
		}
		else
		{
			$assetName = 'com_rsvppro.article.' . (int) $articleId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.createreg', 'core.createglobal', 'core.sendmessage'
		);

		foreach ($actions as $action)
		{
			$result->set($action, $user->authorise($action, $assetName));
		}

		return $result;

	}

}
