<?php

/**
 * copyright (C) 2009 GWE Systems Ltd - All rights reserved
 */
// no direct access
defined('_JEXEC') or die('Restricted Access');

use Joomla\Registry\Registry;
use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

class JevRsvpAttendees
{

	public $params;
	public $rsvpdata;
	public $jomsocial = false;
	public $view;

	public function __construct($params, $jomsocial, &$rsvpdata)
	{
		$this->params = $params;
		$this->jomsocial = $jomsocial;
		$this->rsvpdata = $rsvpdata;
		$this->canCancel = true;

		jimport('joomla.application.component.view');

		$theme = JEV_CommonFunctions::getJEventsViewName();

		if (version_compare(JVERSION, "1.6.0", 'ge'))
		{
			$this->_basepath = JPATH_SITE . '/plugins/jevents/jevrsvppro/rsvppro/';
		}
		else
		{
			$this->_basepath = JPATH_SITE . '/plugins/jevents/rsvppro/';
		}
		$this->view = new HtmlView(array('base_path' => $this->_basepath,
					"template_path" => $this->_basepath . "tmpl/default"
					, "name" => $theme
				));

		$this->view->addTemplatePath($this->_basepath . "tmpl/" . $theme);

		$this->view->addTemplatePath($this->_basepath . "tmpl/" . $theme);
		$this->view->addTemplatePath(JPATH_SITE . '/' . 'templates' . '/' . Factory::getApplication()->getTemplate() . '/' . 'html' . '/' . "plg_rsvppro" . '/' . "default");
		$this->view->addTemplatePath(JPATH_SITE . '/' . 'templates' . '/' . Factory::getApplication()->getTemplate() . '/' . 'html' . '/' . "plg_rsvppro" . '/' . $theme);

		$this->view->setLayout("invites");

		$this->view->jomsocial = $this->jomsocial;
		$this->view->params =  $this->params;

		include_once(JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/attendeehelper.php");
		$this->helper = new RsvpAttendeeHelper($this->params);

	}

	public function setView(&$view)
	{
		$this->view = $view;

	}

	public function fetchAttendanceForm($row, $rsvpdata, $attending, $emailaddress)
	{
		$db = Factory::getDBO();
		$user = Factory::getUser();

		$rsvp_attendanceform = "";

		// Is this a blocked overlaps sesssion - if so need to make sure the attendee is not already attending an overlapping session
		/*
		  $rsvp_attendanceform =  $this->view->loadTemplate("overlappingsession");
		  if ($rsvp_attendanceform != "") {
		  return $rsvp_attendanceform;
		  }
		 */

		// Must use strtotime format for force JevDate to not just parse the date itself!!!
		$jnow = new JevDate("+1 second");
		$now  = $jnow->toUnix();

		// Common data related to registration close dates
		if ($rsvpdata->allrepeats)
		{
			$regclose               = $rsvpdata->regclose == "0000-00-00 00:00:00" ? $row->dtstart() : strtotime($rsvpdata->regclose);
			$regopen                = $rsvpdata->regopen == "0000-00-00 00:00:00" ? strtotime("-1 year") : strtotime($rsvpdata->regopen);
			$cancelclose            = $rsvpdata->cancelclose == "0000-00-00 00:00:00" ? $row->dtstart() : strtotime($rsvpdata->cancelclose);
			$rsvpdata->adjustedregclose       = $regclose;
			$rsvpdata->adjustedcancelclose    = $cancelclose;
			$rsvpdata->adjustedregopen        = $regopen;
		}
		else
		{
			$regclose            = $rsvpdata->regclose == "0000-00-00 00:00:00" ? $row->dtstart() : strtotime($rsvpdata->regclose);
			$cancelclose         = $rsvpdata->cancelclose == "0000-00-00 00:00:00" ? $row->dtstart() : strtotime($rsvpdata->cancelclose);
			$regopen             = $rsvpdata->regopen == "0000-00-00 00:00:00" ? strtotime("-1 year") : strtotime($rsvpdata->regopen);
			$eventstart          = $row->dtstart();
			$repeatstart         = $row->getUnixStartTime();
			$rsvpdata->adjustedregclose    = $regclose + ($repeatstart - $eventstart);
			$rsvpdata->adjustedcancelclose = $cancelclose + ($repeatstart - $eventstart);
			$rsvpdata->adjustedregopen     = $regopen + ($repeatstart - $eventstart);
		}
		// Disable cancellations
		if ($now > $this->rsvpdata->adjustedcancelclose)
		{
			$this->params->set('allowno', 0);
			$this->rsvpdata->allowcancellation = 0;
		}

		if (!isset($this->view->templateInfo))
		{
			$xmlfile = JevTemplateHelper::getTemplate($this->rsvpdata);
			if (is_int($xmlfile) && $xmlfile > 0)
			{
				$db = Factory::getDbo();
				$db->setQuery("Select * from #__jev_rsvp_templates where id=" . intval($xmlfile));
				$this->view->templateInfo = $db->loadObject();
				if ($this->view->templateInfo)
				{
					$this->view->templateParams = $this->view->templateInfo->params;
					$this->view->templateParams = json_decode($this->view->templateParams);
				}
				else
				{
					$this->view->templateParams = false;
				}
			}
			else
			{
				$this->view->templateParams = false;
				$this->view->templateInfo = null;
			}
			$this->templateParams = $this->view->templateParams ;
			$this->templateInfo = $this->view->templateInfo ;
		}

		// if tracking capacity find how many spaces are used up/left
		if ($this->params->get("capacity", 0))
		{

			$sql = "SELECT atdcount FROM #__jev_attendeecount as a WHERE a.at_id=" . $rsvpdata->id;
			if (!$rsvpdata->allrepeats)
			{
				$sql .= " and a.rp_id=" . $row->rp_id();
			}
			$db->setQuery($sql);
			$attendeeCount = intval($db->loadResult());

			$unpaidWaitingList = "";
			if ($this->templateParams)
			{
				if (isset($this->templateParams->waitingnopay) && $this->templateParams->waitingnopay)
				{
					$unpaidWaitingList = "  OR atdees.attendstate=4";
				}
			}

			$query = "SELECT sum(atdees.atdcount) as waitingcount "
				. "\n FROM #__jev_attendees AS atdees "
				. "WHERE atdees.at_id = " . intval($rsvpdata->id) . " AND atdees.waiting=1 AND atdees.confirmed=1 AND (atdees.attendstate=1 $unpaidWaitingList)";
			if (!$rsvpdata->allrepeats)
			{
				$query .= " and atdees.rp_id=" . $row->rp_id();
			}

			$db->setQuery($query);
			$waitingCount = intval($db->loadResult());

			$rsvpdata->attendeeCount          = $attendeeCount;
			$rsvpdata->waitingCount           = $waitingCount;
			$rsvpdata->attendeeCountExWaiting = $attendeeCount - $waitingCount;
			$rsvpdata->withCapacity            = 1;
		}
		else
		{
			$rsvpdata->attendeeCount = 0;
			$rsvpdata->waitingCount  = 0;
			$rsvpdata->attendeeCountExWaiting = 0;
			$rsvpdata->withCapacity  = 0;
		}
		$this->attendeeCount            = $rsvpdata->attendeeCount;
		$this->waitingCount             = $rsvpdata->waitingCount;
		$this->attendeeCountExWaiting   = $rsvpdata->attendeeCountExWaiting;
		$this->withCapacity             = $rsvpdata->withCapacity;

		// can this user cancel or amend his registration ?
		$canamend = true;
		if (!$rsvpdata->allowcancellation && !$rsvpdata->allowchanges && $attending)
		{
			$canamend = false;
			// BUT if pending we can made a change
			if ($this->params->get("allowunconfirmedpendingunpaidchanges", 1) && $this->attendee->attendstate == 3)
			{
				$canamend = true;
			}
			// if fees are due but nothing paid yet then allow changes too
			if ($this->params->get("allowunconfirmedpendingunpaidchanges", 1) && isset($this->attendee->outstandingBalances)
					&& $this->attendee->outstandingBalances['hasfees'] && $this->attendee->outstandingBalances['feepaid'] == 0 && $this->attendee->outstandingBalances['totalfee'] > 0)
			{
				$canamend = true;
			}
		}
		// I need the attendance form if I'm administering and attending the event otherwise I can't cancel attendees!
		if ($user->id == $row->created_by() || JEVHelper::isAdminUser($user) || JEVHelper::canPublishEvent($row, $user) )
		{
			$canamend = true;
		}

		$rsvpdata->canamend = $canamend;

		// Are we after the changes period has ended
		if (!$canamend)
		{
			$this->view->attendee =  $this->attendee;
			$rsvp_attendanceform .= $this->view->loadTemplate("emptyattendanceform");
			$rsvp_attendanceform .= $this->isAttendingInfo($row, $rsvpdata, $attending, $emailaddress);
		}
		else
		{
			if (!$attending)
			{
				$rsvp_attendanceform = $this->attendanceForm($row, $rsvpdata, $attending, $emailaddress);
			}
			// otherwise check the date against the cancellation close
			else if ($this->canCancel($rsvpdata, $row))
			{
				if ($rsvpdata->allowcancellation && !$rsvpdata->allowchanges)
				{
					$rsvp_attendanceform = $this->cancellationForm($row, $rsvpdata, $attending, $emailaddress);
				}
				else if (!$rsvpdata->allowcancellation && $rsvpdata->allowchanges)
				{
					$rsvp_attendanceform = $this->changesForm($row, $rsvpdata, $attending, $emailaddress);
				}
				else if (!$rsvpdata->allowcancellation && !$rsvpdata->allowchanges && isset($this->attendee->outstandingBalances) && $this->attendee->outstandingBalances['hasfees']  && $this->attendee->outstandingBalances['feebalance']>0 ){
					$rsvp_attendanceform = $this->changesForm($row, $rsvpdata, $attending, $emailaddress);
				}
				else
				{
					$rsvp_attendanceform = $this->attendanceForm($row, $rsvpdata, $attending, $emailaddress);
				}
			}
			// $this->canCancel is set by canCancel method
			else if ((!$this->canCancel || !$rsvpdata->allowcancellation) && $rsvpdata->allowchanges)
			{
				$rsvp_attendanceform = $this->changesForm($row, $rsvpdata, $attending, $emailaddress);
			}
			// if cancellation is allowed but is no longer possible
			else if ($attending && $rsvpdata->allowcancellation && !$this->canCancel)
			{

				$rsvp_attendanceform = $this->cancellationExpiredForm($row, $rsvpdata, $attending, $emailaddress);
				//SEE TOPIC https://www.jevents.net/forum/viewtopic.php?f=24&t=16686&p=85996#p85996
				// include a can no longer cancel output!
			}
			else if (isset($this->attendee->outstandingBalances) && $this->attendee->outstandingBalances['hasfees']  && $this->attendee->outstandingBalances['feebalance']>0 ){
				$rsvp_attendanceform = $this->changesForm($row, $rsvpdata, $attending, $emailaddress);
			}
		}
		return $rsvp_attendanceform;

	}

	public function attendanceForm($row, $rsvpdata, $attending, $emailaddress)
	{
		HTMLHelper::script( 'plugins/jevents/jevrsvppro/rsvppro/rsvp.js' );
		HTMLHelper::stylesheet('plugins/jevents/jevrsvppro/rsvppro/rsvp.css');

		$html = "";
		$user = Factory::getUser();
		if ($user->id == 0 && !$this->params->get("attendemails", 0))
		{
			return $html;
		}

		if (Factory::getApplication()->input->get("hideformpending", 0))
		{
			$html = "<strong>" . Text::_("JEV_ATTENDANCE_PENDING") . "</strong>";
			return $html;
		}

		// if only show registration form to invitees then check if this user is invited
		// with strict check on whether super admin is invited
		if ($rsvpdata->allowregistration == 2 && !$this->jevrinvitees->isInvitee($row, $rsvpdata, false, $emailaddress))
		{
			return $html;
		}

		// Make sure waiting list is up to date first of all
		if ($rsvpdata && $rsvpdata->id > 0)
			$this->updateWaitingList($rsvpdata, $rsvpdata->id);

		$this->view->attendee =  $this->attendee;
        $this->view->canCancel =  $this->canCancel;
		return $this->view->loadTemplate("attendanceform");

	}

	public function isAttendingInfo($row, $rsvpdata, $attending, $emailaddress)
	{
		HTMLHelper::script( 'plugins/jevents/jevrsvppro/rsvppro/rsvp.js' );
		HTMLHelper::stylesheet('plugins/jevents/jevrsvppro/rsvppro/rsvp.css');

		$html = "";
		$user = Factory::getUser();
		if ($user->id == 0 && !$this->params->get("attendemails", 0))
		{
			return $html;
		}

		// if only show registration form to invitees then check if this user is invited
		// with strict check on whether super admin is invited
		if ($rsvpdata->allowregistration == 2 && !$this->jevrinvitees->isInvitee($row, $rsvpdata, false, $emailaddress))
		{
			return $html;
		}

		// Make sure waiting list is up to date first of all
		if ($rsvpdata && $rsvpdata->id > 0)
			$this->updateWaitingList($rsvpdata, $rsvpdata->id);

		$this->view->attendee =  $this->attendee;
		if ($this->attendee->attendstate==0){
			return $this->view->loadTemplate("youarenotattending");
		}
		else {
			return $this->view->loadTemplate("youareattending");
		}

	}

	public function cancellationForm($row, $rsvpdata, $attending, $emailaddress)
	{
		HTMLHelper::script( 'plugins/jevents/jevrsvppro/rsvppro/rsvp.js' );
		HTMLHelper::stylesheet('plugins/jevents/jevrsvppro/rsvppro/rsvp.css');

		$html = "";
		$user = Factory::getUser();
		if ($user->id == 0 && !$this->params->get("attendemails", 0))
		{
			return $html;
		}

		// if only show registration form to invitees then check if this user is invited
		// with strict check on whether super admin is invited
		if ($rsvpdata->allowregistration == 2 && !$this->jevrinvitees->isInvitee($row, $rsvpdata, false, $emailaddress))
		{
			return $html;
		}

		// Make sure waiting list is up to date first of all
		if ($rsvpdata && $rsvpdata->id > 0)
			$this->updateWaitingList($rsvpdata, $rsvpdata->id);

		$this->view->attendee =  $this->attendee;
		return $this->view->loadTemplate("cancelform");

	}

	public function cancellationExpiredForm($row, $rsvpdata, $attending, $emailaddress)
	{
		HTMLHelper::script( 'plugins/jevents/jevrsvppro/rsvppro/rsvp.js' );
		HTMLHelper::stylesheet('plugins/jevents/jevrsvppro/rsvppro/rsvp.css');

		$html = "";
		$user = Factory::getUser();
		if ($user->id == 0 && !$this->params->get("attendemails", 0))
		{
			return $html;
		}

		// if only show registration form to invitees then check if this user is invited
		// with strict check on whether super admin is invited
		if ($rsvpdata->allowregistration == 2 && !$this->jevrinvitees->isInvitee($row, $rsvpdata, false, $emailaddress))
		{
			return $html;
		}

		// Make sure waiting list is up to date first of all
		if ($rsvpdata && $rsvpdata->id > 0)
			$this->updateWaitingList($rsvpdata, $rsvpdata->id);

		$this->view->attendee =  $this->attendee;
		$this->view->canCancel = $this->canCancel;
		return $this->view->loadTemplate("cancelexpiredform");

	}

	public function changesForm($row, $rsvpdata, $attending, $emailaddress)
	{
		HTMLHelper::script( 'plugins/jevents/jevrsvppro/rsvppro/rsvp.js' );
		HTMLHelper::stylesheet('plugins/jevents/jevrsvppro/rsvppro/rsvp.css');

		$html = "";
		$user = Factory::getUser();
		if ($user->id == 0 && !$this->params->get("attendemails", 0))
		{
			return $html;
		}

		// if only show registration form to invitees then check if this user is invited
		// with strict check on whether super admin is invited
		if ($rsvpdata->allowregistration == 2 && !$this->jevrinvitees->isInvitee($row, $rsvpdata, false, $emailaddress))
		{
			return $html;
		}

		// Make sure waiting list is up to date first of all
		if ($rsvpdata && $rsvpdata->id > 0)
			$this->updateWaitingList($rsvpdata, $rsvpdata->id);

		$this->view->attendee =  $this->attendee;
		return $this->view->loadTemplate("changeform");

	}

	public function showAttendees(&$row, $rsvpdata)
	{

		$html = "";
		$row->attendeeCount = 0;

		HTMLHelper::script( 'plugins/jevents/jevrsvppro/rsvppro/rsvp.js' );
		HTMLHelper::stylesheet('plugins/jevents/jevrsvppro/rsvppro/rsvp.css');
		// if attendance tracking not enabled then skip this
		if (!$rsvpdata->allowregistration)
			return $html;

		// Usually want the current count
		$db = Factory::getDBO();
		$sql = "SELECT atdcount FROM #__jev_attendeecount as a WHERE a.at_id=" . $rsvpdata->id;
		if (!$rsvpdata->allrepeats)
		{
			$sql .= " and a.rp_id=" . $row->rp_id();
		}
		$db->setQuery($sql);
		// convert to integer in case no entry (i.e. zero confirmed attendees)
		$row->attendeeCount = $attendeeCount = intval($db->loadResult());

		// Must refetch the waiting attendee count because its messed up when invitees are also present!
		//$sql = "SELECT count(atdees.waiting) as waitingcount  FROM #__jev_attendees AS atdees "
		$sql = "SELECT sum(atdees.atdcount) as waitingcount  FROM #__jev_attendees AS atdees "
				. "WHERE atdees.at_id =".  $rsvpdata->id . " and atdees.waiting=1";
		if (!$rsvpdata->allrepeats)
		{
			$sql .= " and atdees.rp_id=" . $row->rp_id();
		}
		else {
			$sql .= " and atdees.rp_id=0";
		}

		$unpaidWaitingList = "";

		if (RsvpHelper::getTemplateSpecificParameter($rsvpdata, 'waitingnopay', 0)){
			$unpaidWaitingList = "  OR atdees.attendstate=4";
		}

		$sql .= " AND (atdees.attendstate=1 $unpaidWaitingList)";

		$db->setQuery($sql);
		$row->attendeeswaiting = $db->loadResult();

		$user = Factory::getUser();
		if ($user->id == 0 && !$this->params->get("showtoanon", 0))
		{
			return $html;
		}

		// Add reference to current row and rsvpdata to the registry so that we have access to these in the fields
		$registry = JevRegistry::getinstance("jevents");
		$registry->set("rsvpdata", $rsvpdata);
		$registry->set("event", $row);

		// only list attendees if appropriate i.e. showattendees or event creator/super admin AND when there aren't too many of them
		if (($rsvpdata->showattendees || $user->id == $row->created_by() || JEVHelper::isAdminUser($user) || JEVHelper::canPublishEvent($row, $user)) && $attendeeCount < (int) $this->params->get('showattendeeslimit', 200))
		{

			$emailaddress = $this->getEmailAddress();

			// if only show attendees to invitees then check if this user is invited
			if ($rsvpdata->showattendees == 2 && !$this->jevrinvitees->isInvitee($row, $rsvpdata, $emailaddress) && !JEVHelper::isAdminUser($user) && !JEVHelper::canPublishEvent($row, $user))
			{
				return $html;
			}

                        if ($rsvpdata->showattendees == 3){
                            $currentattendee = $registry->get("attendee", false);
                            if (!$currentattendee) {
                                return $html;
                            }

                        }
			// record attendee count in $row
			$row->attendeeCount = $attendeeCount;

			$namefields = array("u.username", "u.name", "CONCAT_WS(' - ',u.name, u.username)", "CONCAT_WS(' - ',u.name, u.email)", "CONCAT_WS(' - ',u.username, u.email)");
			$namefield = $namefields [$this->params->get("userdatatype", 0)];

			$sql = "SELECT $namefield as name, u.username, a.* FROM #__jev_attendees as a LEFT JOIN #__users as u on u.id=a.user_id WHERE a.at_id=" . $rsvpdata->id;
			if (!$rsvpdata->allrepeats)
			{
				$sql .= " and a.rp_id=" . $row->rp_id();
			}
			// if no maybes or pendings then only show actual attendees
			/*
			  if (!$this->params->get("allowmaybe", 0) && !$this->params->get("allowpending", 0)) {
			  $sql .= " and a.attendstate=1";
			  }
			 */
			if (!$this->params->get("allowmaybe", 0))
			{
				$sql .= " and a.attendstate!=2";
			}
			if (!$this->params->get("allowpending", 0)
                                // only show pending attendees to creator or jevents admin users
                               || !($user->id == $row->created_by() || JEVHelper::isAdminUser($user) || JEVHelper::canPublishEvent($row, $user))
                                )
			{
				$sql .= " and a.attendstate!=3";
			}
			if ($user->id != $row->created_by() && !JEVHelper::isAdminUser($user) && !JEVHelper::canPublishEvent($row, $user))
			{
				if (!$this->params->get("shownonattendees", 0))
				{
					$sql .= " and a.attendstate!=0";
				}
				if (!$this->params->get("showunpaidattendees", 0))
				{
					$sql .= " and a.attendstate!=4";
				}
			}
			$sql .= " ORDER BY a.confirmed DESC, a.created asc";

			$db->setQuery($sql);
			$attendees = $db->loadObjectList();

			$row->attendeenames = array();
			if (is_array($attendees)){
				foreach ($attendees as &$attendee)
				{
					if ($attendee)
					{
						//$attendee->guestcount = 1;
					}

					// New parameterised fields may have a name field that we should use
					if ($rsvpdata->template != "")
					{
						$xmlfile = JevTemplateHelper::getTemplate($rsvpdata);
						if ((is_int($xmlfile) || file_exists($xmlfile)) && ($attendee->lockedtemplate == 0 || $attendee->lockedtemplate == $xmlfile))
						{
							static $rsvpParameters;
							if (!isset($rsvpParameters))
							{
								$rsvpParameters = new JevRsvpParameter("", $xmlfile, $rsvpdata, $row);
							}
							if (isset($attendee->params))
							{
								$params = clone $rsvpParameters;
								// inject the attendee parameter data into the copy!
								$params->loadData($attendee->params, $rsvpdata, $row);
								//$params = new JevRsvpParameter($attendee->params, $xmlfile, $rsvpdata, $row);
							}
							else
							{
								$params = clone $rsvpParameters;
								//$params = new JevRsvpParameter("", $xmlfile, $rsvpdata, $row);
							}

							// Analyse Guests now to dave repeated calls to renderToBasicArray
							$this->analyseGuests($attendee, $rsvpdata, $row);

							$params = $params->renderToBasicArray( 'xmlfile', $attendee);
//$this->checktime(false , "after renderToBasicArray");
							// Analyse Guests now to dave repeated calls to renderToBasicArray
							$this->analyseGuests($attendee, $rsvpdata, $row, $params);
							foreach ($params as $param)
							{
								// is this a name field?  If so then use this in preference to the user's profile name
								if (isset($param["isname"]) && $param["isname"])
								{
									$value = $param["value"];
									if (is_array($value) && isset($value[0]))
									{
										if ($value[0] != "")
										{
											$attendee->name = $value[0];
										}
									}
									else if (!is_array($value) && $value != "")
									{
										$attendee->name = $value;
									}
								}
							}
						}
					}
                    else
                    {
                        // TODO remove this after 2019/01/01
                        // Analyse Guests - needed temporarily to reset atdcount and guestcnt values for attendees
                        $this->analyseGuests($attendee, $rsvpdata, $row);
                    }

					if ($user->id==0){
						$attendee->email_address =  substr($attendee->email_address,0,  strpos($attendee->email_address, "@"))."@email";
					}
					$showstatus = false;
					if ($user->id == $row->created_by() ||  JEVHelper::isAdminUser($user) || JEVHelper::canPublishEvent($row, $user)){
						$showstatus = true;
					}
					$img = "";
					// Show the status
					if ($showstatus)
					{
						$images = array("Cross.png", "Tick.png", "Question.png", "Pending.png", "MoneyBag.png");
						$img = $images[$attendee->attendstate];
						if (version_compare(JVERSION, "1.6.0", 'ge')){
							$pluginpath = 'plugins/jevents/jevrsvppro/rsvppro/';
						}
						else {
							$pluginpath = 'plugins/jevents/rsvppro/';
						}
						$row->attendeenames[] = ($attendee->name? $attendee->name : $attendee->email_address).' <img src="' . JURI::root() . $pluginpath.'assets/' . $img . '"  style="height:16px;" alt="' . $img . '" />';
					}
					else {
						$row->attendeenames[] = $attendee->name? $attendee->name : $attendee->email_address;
					}
				}
			}

			unset($attendee);

			$this->view->attendeeCount =  $attendeeCount;
			$this->view->attendees = $attendees;
//$this->checktime(true);
			$html = $this->view->loadTemplate("attendees");
//$this->checktime(false , "post loadTemplate");
		}
		// always include the link to allow for management
		if ($user->id == $row->created_by() || JEVHelper::isAdminUser($user) || JEVHelper::canPublishEvent($row, $user) || ($rsvpdata->showattendees==1 && $attendeeCount >=100))
		{
			$html .= $this->view->loadTemplate("attendeeslink");
		}
		return $html;

	}

	// TODO - move this to the controller
	public function confirmAttendance($rsvpdata, $row)
	{
		if (!$this->params->get("requireconfirmation", 0))
			return;

		// must avoid recursive calling
		static $confirming = false;
		if ($confirming)
		{
			return true;
		}
		$confirming = true;

		// Add reference to current row and rsvpdata to the registry so that we have access to these in the fields
		$registry = JevRegistry::getinstance("jevents");
		$registry->set("rsvpdata", $rsvpdata);
		$registry->set("event", $row);

		$jevattend_hidden = Factory::getApplication()->input->getInt("jevattend_hidden", 0);

		$emailaddress = $this->getEmailAddress();
		if ($this->params->get("attendemails", 0) && $emailaddress != "")
		{
			// Make sure can only confirm their own email address!!!
			if (trim(strtolower(Factory::getApplication()->input->getString("jevattend_email"))) && $emailaddress != trim(strtolower(Factory::getApplication()->input->getString("jevattend_email"))))
			{
				return;
			}

			$db = Factory::getDBO();

			$sql = "SELECT * FROM #__jev_attendees WHERE at_id=" . $rsvpdata->id . " and confirmed=1 and email_address=" . $db->Quote($emailaddress);
			$db->setQuery($sql);
			if ($attendee = $db->loadObject())
				return;

			// Make sure the counts are in sync!
			$this->countAttendees($rsvpdata->id);
			$waiting = "";
// /index.php/en/jevents/eventdetail/4158/unconfirmed-over-the-limit?em=dHJzdEBjb3B5bi5wbHVzLmNvbToyOTVmMjdhODdjNmNkMjI1NWYwMjc5YzQ2YzZmYjYxMA==
			if ($this->params->get("capacity", 0) && $rsvpdata->capacity > 0)
			{
				$sql = "SELECT atdcount FROM #__jev_attendeecount as a WHERE a.at_id=" . $rsvpdata->id;
				if (!$rsvpdata->allrepeats)
				{
					$sql .= " and a.rp_id=" . $row->rp_id();
				}
				$db->setQuery($sql);
				$attendeeCount = $db->loadResult();

				$sql = "SELECT * FROM #__jev_attendees WHERE at_id=" . $rsvpdata->id . " and confirmed=0 and email_address=" . $db->Quote($emailaddress);
				$db->setQuery($sql);
				$attendee = $db->loadObject();

				if ($attendee && RsvpHelper::getTemplateSpecificParameter($rsvpdata, 'unconfirmedcapacity', 0) == 0) {
					// If over capacity and waiting list then just ignore
					if ($attendeeCount + $attendee->guestcount > $rsvpdata->capacity + $rsvpdata->waitingcapacity)
					{
					    $Itemid = Factory::getApplication()->input->getInt('Itemid');
						$link = $row->viewDetailLink($row->yup(), $row->mup(), $row->dup(), false, $Itemid);
						Factory::getApplication()->enqueueMessage( Text::_("JEV_EVENT_FULL"));
                        Factory::getApplication()->redirect($link);
					}

					// Should this be on the waiting list
					if ($attendeeCount  + $attendee->guestcount  > intval($rsvpdata->capacity))
					{
						$waiting=", waiting=1 ";
					}
				}
			}

			// if an invitee then there may be no record yet
			$invitee = $this->jevrinvitees->fetchInviteeByEmail($row, $rsvpdata, $emailaddress, true);
			if ($invitee)
			{
				$sql = "INSERT INTO #__jev_attendees SET at_id=" . $rsvpdata->id . ", confirmed=1 $waiting ,  email_address=" . $db->Quote($emailaddress);
				if (!$rsvpdata->allrepeats)
				{
					$sql .= ", rp_id=" . $row->rp_id();
				}
			}
			else
			{
				$sql = "UPDATE #__jev_attendees SET confirmed=1 $waiting WHERE at_id=" . $rsvpdata->id . " AND email_address=" . $db->Quote($emailaddress);
			}
			$db->setQuery($sql);
			$db->execute();

			// Make sure the counts are in sync!
			$this->countAttendees($rsvpdata->id);

			$sql = "SELECT * FROM #__jev_attendees WHERE at_id=" . $rsvpdata->id . " and confirmed=1 and email_address=" . $db->Quote($emailaddress);
			$db->setQuery($sql);
			$attendee = $db->loadObject();

			$mainframe = Factory::getApplication();
			$Itemid = Factory::getApplication()->input->getInt("Itemid");
			list ( $year, $month, $day ) = JEVHelper::getYMD();
			$link = $row->viewDetailLink($year, $month, $day, false, $Itemid);

			$emailaddress = $this->getEmailAddress();
			if ($this->params->get("attendemails", 0) && $emailaddress != "")
			{
				$code = base64_encode($emailaddress . ":" . md5($this->params->get("emailkey", "email key") . $emailaddress));
				// use em2 - which is used for viewing !!!
				$link = $row->viewDetailLink($year, $month, $day, false, $Itemid) . "&em2=" . $code;
				$requirelogin = false;
			}

			// Do not send notification if only sending cancelations!
			if ($this->params->get("notifycreator", 0) && $this->params->get("notifycreator", 0) != 3) {
				$this->notifyCreator($rsvpdata, $row, $emailaddress, $emailaddress, $attendee, false, $attendee->waiting);
			}
			$user = Factory::getUser(0);
			if ($this->params->get("notifyuser", 0)) {
				$this->notifyUser($rsvpdata, $row, $user, $emailaddress, $emailaddress, $attendee, 'ack', $attendee->waiting);
			}

			// auto remind attendees
			if ($this->params->get("autoremind", 0) == 1 && !$attendee->waiting && ($rsvpdata->allowreminders || $this->params->get("forceautoremind", 0)))
			{
				// create reminder
				// NB email address must be in the request object
				$user = Factory::getUser(0);
				$this->helper->jevrreminders->remindUser($rsvpdata, $row, $user);
				$mainframe = Factory::getApplication();
				$mainframe->enqueueMessage(Text::_("JEV_REMINDER_CONFIRMED"),'notice');
			}

			$this->postUpdateActions($rsvpdata, $row, $attendee, $attendee->waiting, $this->getRSVPParmeters($rsvpdata, $row));

			switch ($attendee->attendstate) {
				case 0:
					Factory::getApplication()->redirect($link);
					Factory::getApplication()->enqueueMessage(Text::_("JEV_ATTENDANCE_CONFIRMED_NOT_ATTENDING"));
					break;
				case 1:
					if ($waiting){
						Factory::getApplication()->enqueueMessage(Text::_("JEV_WAITING_MESSAGE"));
						Factory::getApplication()->redirect($link);
					}
					else {
						Factory::getApplication()->enqueueMessage(Text::_("JEV_ATTENDANCE_CONFIRMED2"));
						Factory::getApplication()->redirect($link);
					}
					break;
				case 2:
					Factory::getApplication()->enqueueMessage(Text::_("JEV_ATTENDANCE_CONFIRMED_MAYBE_ATTENDING"));
					Factory::getApplication()->redirect($link);
					break;
				case 3:
					Factory::getApplication()->enqueueMessage(Text::_("JEV_ATTENDANCE_CONFIRMED_PENDING_APPROVAL"));
					Factory::getApplication()->redirect($link);
					break;
				case 4:
					if ($waiting){
						Factory::getApplication()->enqueueMessage(Text::_("JEV_WAITING_MESSAGE"));
						Factory::getApplication()->redirect($link);
					}
					else {
						Factory::getApplication()->enqueueMessage(Text::_("JEV_ATTENDANCE_CONFIRMED_OUTSTANDING_BALANCE"));
						Factory::getApplication()->redirect($link);
					}
					break;
				default:
					if ($waiting){
						Factory::getApplication()->enqueueMessage(Text::_("JEV_WAITING_MESSAGE"));
						Factory::getApplication()->redirect($link);
					}
					else {
						Factory::getApplication()->enqueueMessage(Text::_("JEV_ATTENDANCE_CONFIRMED2"));
						Factory::getApplication()->redirect($link);
					}
					break;
			}
		}

	}

	private function canCancel($rsvpdata, & $row)
	{
		$this->canCancel = true;
		$user = Factory::getUser();
		// I always show the attendance form for special users
		if ($user->id == $row->created_by() || JEVHelper::isAdminUser($user) || JEVHelper::canPublishEvent($row, $user))
		{
			$this->canCancel = true;
			return true;
		}
		else
		{
			jimport('joomla.utilities.date');
			// Must use strtotime format for force JevDate to not just parse the date itself!!!
			$jnow = new JevDate("+1 second");
			$now  = $jnow->toUnix();

			if ($now > $rsvpdata->adjustedcancelclose)
			{
				$this->canCancel = false;

				return false;
			}
			else
			{
				$this->canCancel = true;
				return true;
			}
		}
	}

	// This redirects calls to the helper class is possible
	public function __call($name, $arguments)
	{
		if (is_callable(array($this->helper, $name)))
		{
			return @call_user_func_array(array($this->helper, $name), $arguments);
		}

	}

	public function calculateBalances(&$view, $rsvpdata, $row)
	{
		return $this->helper->calculateBalances($view, $rsvpdata, $row);

	}

	public function updateWaitingList(&$rsvpdata, $atdid = 0)
	{
		return $this->helper->updateWaitingList($rsvpdata, $atdid);

	}

	public function analyseGuests(&$attendee, $rsvpdata, $event, $attendeeparams = false)
	{
		return $this->helper->analyseGuests($attendee, $rsvpdata, $event, $attendeeparams);

	}

	// post confirmation actions in parameter fields e.g. signup for newsletters etc.
	protected function postUpdateActions($rsvpdata, $row, $attendee, $onWaitingList, $rsvpparams)
	{
		if ($rsvpparams)
		{
			return $rsvpparams->postUpdateActions($rsvpdata, $row, $attendee, $onWaitingList);
		}

	}

	protected function getRsvpDataParams($rsvpdata)
	{
		$params = "";
		if ($rsvpdata->template != "")
		{
			$xmlfile = JevTemplateHelper::getTemplate($rsvpdata);

			if (is_int($xmlfile) || file_exists($xmlfile))
			{
				$params = Factory::getApplication()->input->get("params", array(), 'ARRAY');
				$jregistry = new Registry ();
				$jregistry->loadArray($params);

				// checkboxes do not return any data which causes problems when we have guests!
				$rsvpparams = new JevRsvpParameter("", $xmlfile, $rsvpdata, null);
				$emptyarray = $rsvpparams->renderToBasicArray();
				foreach ($emptyarray as $key => $ea)
				{
					if (!isset($params[$key]))
					{
						$jregistry->set($key, "");
					}
				}

				// TODO VERY IMPORTANT - CALCULATE THE FEES AND BALANCE HERE - DON'T RELY ON JAVASCRIPT!!
				if ($jregistry->get("totalfee", -1) != -1)
				{
					$jregistry->set("totalfee", 0);
					$jregistry->set("feepaid", 7.00);
					$jregistry->set("feebalance", 0);
				}

				if (version_compare(PHP_VERSION, '5.4', '>='))
				{
					$params = $jregistry->toString('JSON', array('bitmask' =>JSON_UNESCAPED_UNICODE));
				}
				else
				{
					$params = $jregistry->toString();
				}
			}
		}
		return $params;

	}

	protected function getRSVPParmeters($rsvpdata, $row)
	{
		if ($rsvpdata->template != "")
		{
			$xmlfile = JevTemplateHelper::getTemplate($rsvpdata);

			if (is_int($xmlfile) || file_exists($xmlfile))
			{
				$rsvpparams = new JevRsvpParameter("", $xmlfile, $rsvpdata, $row);
				return $rsvpparams;
			}
		}
		return false;

	}

	private function checktime($start = true, $action = "action")
	{
		static $starttime;
		if ($start)
		{
			list($usec, $sec) = explode(" ", microtime());
			$starttime = (float) $usec + (float) $sec;
		}
		else
		{
			list ($usec, $sec) = explode(" ", microtime());
			$time_end = (float) $usec + (float) $sec;
			echo "$action = " . round($time_end - $starttime, 4) . "<br/>";
			$starttime = $time_end;
		}

	}

	/*
	 * We cannot rely on __call magic function to pass variables by reference!
	 */
	private function notifyUser($rsvpdata, & $row, $user, $name, $username, $attendee = null, $messagetype = 'ack', $onWaitingList = false, $transaction = false, $subject = "", $message = "", $speciallink=false) {
		if (isset($this->event) && !isset($this->helper->event)){
			$this->helper->event = $this->event;
		}
		return $this->helper->notifyUser($rsvpdata,  $row, $user, $name, $username, $attendee, $messagetype, $onWaitingList, $transaction, $subject, $message, $speciallink);
	}

	private function notifyCreator($rsvpdata,& $row, $name, $username, $attendee = null, $cancellation = false, $onWaitingList = false) {
		if (isset($this->event) && !isset($this->helper->event)){
			$this->helper->event = $this->event;
		}
		return $this->helper->notifyCreator($rsvpdata, $row, $name, $username, $attendee, $cancellation, $onWaitingList) ;

	}

}
