<?php
/**
 * copyright (C) 2009 GWE Systems Ltd - All rights reserved
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted Access' );

use Joomla\Utilities\ArrayHelper;
use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Factory;


class JevRsvpInvitees
{

	public $params;
	public $jomsocial = false;
	public $cbuilder = false;
	public $groupjive= false;

	public function __construct($params, $jomsocial, $cbuilder=false, $groupjive=false){
		$this->params = $params;
		$this->jomsocial = $jomsocial;
		$this->cbuilder = $cbuilder;
		$this->groupjive = $groupjive;

		jimport('joomla.application.component.view');

		$theme = JEV_CommonFunctions::getJEventsViewName();

		if (version_compare(JVERSION, "1.6.0", 'ge')){
			$this->_basepath = JPATH_SITE.'/plugins/jevents/jevrsvppro/rsvppro/';
		}
		else {
			$this->_basepath = JPATH_SITE.'/plugins/jevents/rsvppro/';
		}
		$this->view = new HtmlView(array( 'base_path'=>$this->_basepath,
		"template_path"=>$this->_basepath."tmpl/default"
		,"name"=>$theme
		));

		$this->view->addTemplatePath($this->_basepath."tmpl/".$theme);

		if (file_exists($this->_basepath . "tmpl/" . $params->get('frontendstyling', 'xxx')))
		{
			$this->view->addTemplatePath($this->_basepath . "tmpl/" . $params->get('frontendstyling', 'xxx'));
		}

		$this->view->addTemplatePath($this->_basepath."tmpl/".$theme);
		$this->view->addTemplatePath( JPATH_SITE .'/'.'templates'.'/'.Factory::getApplication()->getTemplate().'/'.'html'.'/'."plg_rsvppro".'/'."default");
		$this->view->addTemplatePath( JPATH_SITE .'/'.'templates'.'/'.Factory::getApplication()->getTemplate().'/'.'html'.'/'."plg_rsvppro".'/'.$theme);

		$this->view->setLayout("invites");

		$this->view->jomsocial = $this->jomsocial;
		$this->view->cbuilder = $this->cbuilder;
		$this->view->groupjive = $this->groupjive;
		$this->view->params =  $this->params;

		include_once(JPATH_ADMINISTRATOR."/components/com_rsvppro/libraries/inviteehelper.php");
		$this->helper = new RsvpInviteeHelper($this->params);

	}

	public function createInvitations($row, $rsvpdata){

		$html = "";
		$user=Factory::getUser();
		if ($user->id==0){
			return $html;
		}
		if (!$rsvpdata->invites) return $html;

		if ($user->id==$row->created_by() ||  JEVHelper::isAdminUser($user) || JEVHelper::canDeleteEvent($row, $user)){
			$invitees = $this->helper->fetchInvitees($row,$rsvpdata);
			$this->view->invitees = $invitees;
		}

		if ($this->params->get("invitejoomlagroups",0)){

			$where = array();
			if (!$user->authorise("core.manage", 'com_rsvppro') ){
				$where[] ="map2.user_id =".$user->id;
			}
			$inviteusertype = $this->params->get("inviteusertype", array(1,2,3,4,5,6));
			if ($inviteusertype)
			{
				if (is_array($inviteusertype)){
					$inviteusertype = ArrayHelper::toInteger($inviteusertype);
					$inviteusertype[] = -1;
					$inviteusertype = implode(",",$inviteusertype);
				}
				$where[] = ' map2.group_id IN ( ' . $inviteusertype .')';
			}
			$db = Factory::getDBO();
			$sql = 'SELECT DISTINCT(ug.title) as name, ug.* FROM #__usergroups as ug
				LEFT JOIN #__user_usergroup_map AS map2 ON map2.group_id = ug.id					';
			$sql .= " WHERE ".implode(" AND ", $where)  . "ORDER BY ug.title ASC";

			$db->setQuery($sql);

			try {
				$jugroups = $db->loadObjectList();
			}
			catch (RuntimeException $e)
			{
				$error = $e->getMessage();
				echo $error;
				$jugroups = array();
			}

			$this->view->jugroups = $jugroups;
		}

		if ($this->jomsocial){
			$db = Factory::getDBO();
			$db->setQuery("select * from #__community_groups as a LEFT JOIN #__community_groups_members as b ON a.id=b.groupid where (a.published=1 OR (b.approved=1 AND b.memberid=".$user->id.")) group by a.id ORDER BY a.name");

			$jsgroups = $db->loadObjectList();
			$this->view->jsgroups = $jsgroups;
		}

		if ($this->groupjive){
			$db = Factory::getDBO();
			$user = Factory::getUser();
			$aid = JEVHelper::getAid($user);
			// everybody or registered users
			$aid.=",-2";
			$aid.=",-1";

			$db->setQuery("select * from #__groupjive_groups WHERE (type=1 OR (user_id=".$user->id.")) and published=1 ORDER BY name" );
			$cbgroups = $db->loadObjectList();

			$this->view->cbgroups = $cbgroups;
		}

		$db = Factory::getDBO();
		$db->setQuery("select * from #__jev_invitelist  where user_id =".$user->id);
		$invitelists = $db->loadObjectList();
		$this->view->invitelists = $invitelists;

		$this->view->row = $row;
		$this->view->rsvpdata = $rsvpdata;
		return $this->view->loadTemplate("invitesform");

	}

	// This redirects calls to the helper class is possible
	public function __call($name, $arguments){
		if (is_callable(array($this->helper, $name))){
			return call_user_func_array(array($this->helper, $name),$arguments);
		}
	}




}
