<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
defined('_JEXEC') or die('Restricted Access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;



$db = Factory::getDBO();
$user =  Factory::getUser();

$pluginpath = 'plugins/jevents/jevrsvppro/rsvppro/';
$pathIMG = JURI::root() . 'administrator/images/';
PluginHelper::importPlugin("rsvppro");
?>

<form action="index.php" method="post" name="adminForm" id="adminForm">

	<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist  table table-striped">
		<tr>
			<th width="20" nowrap="nowrap">
				<?php echo HTMLHelper::_('grid.checkall'); ?>
			</th>
			<th class="title" >
				<?php echo  Text::_('RSVP_TRANSACTION_NUMBER'); ?>
			</th>
			<th class="title" >
				<?php echo  Text::_('RSVP_TRANSACTION_GATEWAY'); ?>
			</th>
			<th class="title" >
				<?php echo  Text::_('RSVP_TRANSACTION_CURRENCY'); ?>
			</th>
			<th class="title" >
				<?php echo  Text::_('RSVP_TRANSACTION_AMOUNT'); ?>
			</th>
			<th class="title" >
				<?php echo  Text::_('RSVP_TRANSACTION_DATE'); ?>
			</th>
			<th class="title" >
				<?php echo  Text::_('RSVP_TRANSACTION_PAYMENTSTATE'); ?>
			</th>
			<th class="title" >
				<?php echo  Text::_('RSVP_TRANSACTION_DETAIL'); ?>
			</th>
			<th class="title" >
				<?php echo  Text::_('RSVP_SEND_TRANSACTION_NOTIFICATION'); ?>
			</th>
		</tr>

		<?php
				$k = 0;
				$nullDate = $db->getNullDate();

				for ($i = 0, $n = count($this->transactions); $i < $n; $i++)
				{
					$transaction = &$this->transactions[$i];

				?>
				<tr class="row<?php echo $k; ?>">
					<td width="20"  >
						<?php echo HTMLHelper::_('grid.id', $i,   $transaction->transaction_id); ?>
					</td>
					<td   >
						<?php
								$activePlugin = false;
								Factory::getApplication()->input->set("gateway",$transaction->gateway);
								Factory::getApplication()->triggerEvent( 'onActiveGatewayClass', array(&$activePlugin));

								if ($activePlugin && class_exists($activePlugin) && method_exists($activePlugin, "editTransaction")){
									?>
									<a href="#edit" onclick="Joomla.listItemTask('cb<?php echo $i; ?>','attendees.edittransaction');return false;" title="<?php echo Text::_('JEV_CLICK_TO_EDIT'); ?>"><?php echo $transaction->transaction_id; ?></a>
									<?php
								}
								else {
									echo $transaction->transaction_id;
								}
								?>
					</td>
					<td   >
						<?php echo $transaction->gateway;?>
					</td>
					<td   >
						<?php echo $transaction->currency;?>
					</td>
					<td   >
						<?php echo $transaction->amount;?>
					</td>
					<td   >
						<?php
							$format = $this->params->get("timestampformat", "%Y-%m-%d %H:%M");
							$transactiondate = new JevDate($transaction->transaction_date);
							echo $transactiondate->toFormat($format)."<br/>";
							//echo strftime($format, strtotime($transaction->transaction_date));
						?>
					</td>
					<td   >
						<?php
								if (!$transaction->paymentstate)
								{
									$cimg = 'Cross.png';
								}
								else
								{
									$cimg = 'Tick.png';
								}
								$walt 	= $transaction->paymentstate ? Text::_( 'RSVP_MARK_TRANSACTION_INVALID' ) : Text::_( 'RSVP_MARK_TRANSACTION_VALID' );
								$mainframe = Factory::getApplication();
								$cimg = '<img src="' . JURI::root() . $pluginpath . '/assets/' . $cimg . '"  style="height:16px;border:none;" alt="' . $walt . '" />';

								$task 	= $transaction->paymentstate ? 'invalidtransaction' : 'validtransaction';
								$action 	= $transaction->paymentstate ? Text::_( 'RSVP_MARK_TRANSACTION_INVALID' ) : Text::_( 'RSVP_MARK_TRANSACTION_VALID' );

								$paymentstate = '
								<a href="javascript:void(0);" onclick="Joomla.listItemTask(\'cb'. $i .'\',\'attendees.'.$task .'\');return false;" title="'. $action .'">
									'. $cimg. '
								</a>'
								;
								echo $paymentstate;
						?>
						</td>
						<td>
							<?php
							if ($transaction->transaction_id>0){
								$activePlugin = false;
								Factory::getApplication()->input->set("gateway",$transaction->gateway);
								Factory::getApplication()->triggerEvent( 'onActiveGatewayClass', array(&$activePlugin));

								if ($activePlugin && class_exists($activePlugin)){

									// create the plugin
									// load plugin parameters
									$pluginname =  strtolower(str_replace("plgRsvppro","",$activePlugin));
									$plugin = PluginHelper::getPlugin("rsvppro", $pluginname);
									// Test needed for J4/J3.9 compatibility
									$dispatcher = method_exists(Factory::getApplication(),"getDispatcher") ? Factory::getApplication()->getDispatcher() : JEventDispatcher::getInstance();
									$gateway = new $activePlugin($dispatcher, (array)($plugin));

									//call_user_func_array(array($gateway,"generatePaymentPage"),array(&$html, $attendee, $rsvpdata, $event, $transaction));
									echo $gateway->transactionDetailLink( $transaction, $this->rsvpdata, $this->attendee, $this->event);
								}
							}
							?>
						</td>
						<td>
							<?php
							echo '<a href="javascript:void(0);" onclick="Joomla.listItemTask(\'cb'. $i .'\',\'attendees.resendtransactionnotice\');return false;" title="'. Text::_("RSVP_SEND_TRANSACTION_NOTIFICATION") .'">'.
							HTMLHelper::_('image','system/emailButton.png', Text::_('RSVP_SEND_TRANSACTION_NOTIFICATION'), NULL, true)
							.'</a>';
							?>
						</td>
					</tr>
<?php
					$k = 1 - $k;
				}
?>
			    </table>
			    <input type="hidden" name="option" value="<?php echo RSVP_COM_COMPONENT; ?>" />
			    <input type="hidden" name="atdee_id" value="<?php echo $this->attendee->id; ?>" />
			    <input type="hidden" name="task" value="attendees.transactions" />
			    <input type="hidden" name="boxchecked" id="boxchecked" value="0" />
			<input type="hidden" name="atd_id[]" id="atd_id" value="<?php echo $this->rsvpdata->id."|".$this->rp_id;?>"  />
			<input type="hidden" name="repeating" id="repeating" value="<?php echo $this->rsvpdata->allrepeats;?>" />

	<input type="hidden" name="Itemid" value="<?php echo Factory::getApplication()->input->getInt("Itemid",0); ?>" />
<?php echo HTMLHelper::_('form.token'); ?>
</form>

