<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: edit16.php 2983 2011-11-10 14:02:23Z geraintedwards $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Form\FormHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Form\Form;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\String\StringHelper;

?>
<div id="jevents" class="rsvppro_params">
    <form action="index.php" method="post" name="adminForm" autocomplete="off" id="adminForm">


            <div class="gsl-grid  gsl-margin-remove-left">
                <ul class="config gsl-tab-left gsl-margin-right gsl-width-auto gsl-list-divider" id="myParamsTabs" gsl-tab="connect: #rsvp-config-tabs">
				<?php
				$fieldSets = $this->form->getFieldsets();
				$first     = true;
				foreach ($fieldSets as $name => $fieldSet)
				{
					if ($name == "permissions" || $name == "noop")
					{
						continue;
					}
					$label = empty($fieldSet->label) ? $name : $fieldSet->label;
					if ($first)
					{
						$first = false;
						$class = ' class="active"';
					}
					else
					{
						$class = '';
					}
					$showon = "";
					if ($fieldSet && isset($fieldSet->showon))
					{
						HTMLHelper::_('jquery.framework');
						JEVHelper::script('showon.js', 'components/' . JEV_COM_COMPONENT . '/assets/js/');

						$showon  = ' data-showon-gsl=\'' .
							json_encode(FormHelper::parseShowOnConditions($fieldSet->showon, 'jform', '')) . '\'';
					}

					?>
                    <li <?php echo $class . " " . $showon ; ?>><a href="#<?php echo $name; ?>"><?php echo Text::_($label); ?></a></li>
					<?php
				}
				?>
	            </ul>
	            <!-- Tabs themselves //-->
                <div class=" gsl-margin-remove gsl-card-body gsl-card-default gsl-padding gsl-width-expand">
                    <ul class="gsl-switcher" id="rsvp-config-tabs">

				<?php
				$fieldSets = $this->form->getFieldsets();

				foreach ($fieldSets as $name => $fieldSet)
				{
					if ($name == "permissions" || $name == "noop")
					{
						continue;
					}

					$label = empty($fieldSet->label) ? $name : $fieldSet->label;

					$html = array();

					$html[] = '<div class="gsl-width-1-1" >';

					// $html[] = "<legend>".Text::_($label)."</legend>";
					if (isset($fieldSet->description) && !empty($fieldSet->description))
					{
						$desc   = Text::_($fieldSet->description);
						$html[] = '<div  class="gsl-width-1-1 gsl-card gsl-card-default" >' . $desc . '</div>';
					}

					foreach ($this->form->getFieldset($name) as $field)
					{
						if ($field->hidden)
						{
							continue;
						}
						$class = isset($field->class) ? $field->class : "";
						$class = " class='gsl-grid $class'";


						$showon = "";
						if ($field && $field->showon)
						{

							HTMLHelper::_('jquery.framework');
							JEVHelper::script('showon.js', 'components/' . JEV_COM_COMPONENT . '/assets/js/');

							$showon  = ' data-showon-gsl=\'' .
								json_encode(FormHelper::parseShowOnConditions($field->showon, $field->formControl, $field->group)) . '\'';
						}

						$html[] = "<div $class $showon >";
						if (strtolower($field->type) == "note" || strtolower($field->type) == "jevinfo" || strtolower($field->type) == "rules"  || strtolower($field->type) == "editor")
						{
							$html[] = '<div class="gsl-padding-remove">' . $field->label . "</div><div class='gsl-width-1-1'>" . $field->input . '</div>';
						}
						else if (!isset($field->label) || $field->label == "")
						{
							$html[] = '<div class="gsl-width-2-3"><span class="editlinktip">' . $field->label . '</span></div>';
							$html[] = '<div class="gsl-width-1-3">' . $field->input . '</div>';
						}
						else
						{
							$html[] = '<div class="gsl-width-1-1" >' . $field->input . '</div>';
						}
						$label = $field->label;

						$html[] = '</div>';

					}

					$html[] = '</div>';
					?>
                    <li>
						<?php
						echo implode("\n", $html);
						?>
                    </li>
					<?php
				}
				?>
            </ul>
                </div>
            </div>


        <input type="hidden" name="id" value="<?php echo $this->component->id; ?>"/>
        <input type="hidden" name="component" value="<?php echo $this->component->option; ?>"/>

        <input type="hidden" name="controller" value="component"/>
        <input type="hidden" name="option" value="<?php echo RSVP_COM_COMPONENT; ?>"/>
        <input type="hidden" name="task" value=""/>
		<?php echo JHTML::_('form.token'); ?>
    </form>
</div>


