<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: view.html.php 1512 2009-07-15 10:51:30Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Access\Access;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

/**
 * HTML View class for the component
 *
 * @static
 */
class AdminParamsViewParams extends RSVPAbstractView
{

	function edit()
	{

		HTMLHelper::stylesheet(  'components/'.RSVP_COM_COMPONENT.'/assets/css/rsvpadmin.css' );

		$document = Factory::getDocument();
		$document->setTitle(Text::_('RSVP_CONFIGURATION'));

		// Set toolbar items for the page
		JToolBarHelper::title( Text::_('RSVP_RSVP') .' :: '. Text::_( 'RSVP_CONFIGURATION' ), 'jevents' );

		JToolBarHelper::apply('params.apply');
		JToolBarHelper::save('params.save');
		JToolBarHelper::cancel('cpanel.cpanel');

		$model = $this->getModel();



		// Get the actions for the asset.
		$actions = Access::getActionsFromFile(
			JPATH_ADMINISTRATOR . '/components/' . RSVP_COM_COMPONENT . '/access.xml',
			"/access/section[@name='component']/"
		);

		jimport('joomla.form.form');

		// Add the search path for the admin component config.xml file.
		Form::addFormPath(JPATH_ADMINISTRATOR . '/components/' . RSVP_COM_COMPONENT);

		// Get the form.
		$modelForm = $model->getForm();

		//$component = isset($this->component)?$this->component : $this->get('Component');

		$component = $this->get('Component');
		// Bind the form to the data.
		if ($modelForm && $component->params)
		{
			$modelForm->bind($component->params);
		}

		$this->form = $modelForm;
		$this->component =  $component;

		// Set the layout
		$this->setLayout('edit');

	}


}
