<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: overview.php 1676 2010-01-20 02:50:34Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
defined('_JEXEC') or die('Restricted Access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;

$db = Factory::getDBO();
$user = Factory::getUser();
$params = ComponentHelper::getParams('com_rsvppro');
$jevparams = ComponentHelper::getParams('com_jevents');
?>
<div id="jevents" class="rsvppro_sessions">
    <form action="index.php" method="post" name="adminForm" id="adminForm">
        <div class="sessionfilters">
            <div class="floatleft">
	            <label ><?php echo Text::_('JEV_EVENT_REPEATTYPE'); ?></label>
                <?php echo $this->repeattypelist; ?> </td>
            </div>
            <div class="floatleft">
	            <label ><?php echo Text::_('JEV_EVENT_CREATOR'); ?></label>
                <?php echo $this->userlist; ?>
            </div>
            <div class="floatleft">
	            <label ><?php echo Text::_('JEV_HIDE_OLD_EVENTS'); ?></label>
                <?php echo $this->hidepast; ?>
            </div>
            <div class="floatleft">
	            <label ><?php echo Text::_('JEV_SEARCH'); ?></label>
                <input type="text" name="search" value="<?php echo $this->search; ?>" class="inputbox"
                       onChange="document.adminForm.submit();"/>
            </div>
            <div class="floatleft">
	            <label ><?php echo Text::_('RSVP_SEARCH_BY_ATTENDEE'); ?></label>
                <input type="text" name="searchattendees" value="<?php echo $this->searchattendees; ?>"
                       class="inputbox" onChange="document.adminForm.submit();"/>
            </div>
            <div class="floatleft">
	            <label ><?php echo Text::_('JEV_ON_OR_AFTER'); ?></label>
                <?php
                $minyear = JEVHelper::getMinYear();
                $maxyear = JEVHelper::getMaxYear();

                $inputdateformat = $jevparams->get("com_editdateformat", "d.m.Y");
                ob_start();
                JEVHelper::loadElectricCalendar('after', 'after', $this->after, $minyear, $maxyear, '', 'document.getElementById(\'afterset\').value = this.value?1:0;document.adminForm.submit();' , $inputdateformat);
                $calendar = ob_get_clean();
                if (empty($this->after))
                {
                	$tempdate = strftime(str_replace(array("Y", "m", "d"), array("%Y", "%m", "%d"), $inputdateformat));
	                $calendar = str_replace($tempdate, "", $calendar);
                }
                echo $calendar;
                ?>
	            <input type="hidden" name="afterset" id="afterset"  value="<?php echo empty($this->after) ? 0 : 1;?>" />
            </div>

            <?php if ($this->searchattendees) { ?>
            <div class="floatleft">
	            <label ><?php echo Text::_('RSVP_ATTENDED'); ?></label>
                <input type="checkbox" name="searchdidattend" value="1" <?php echo $this->searchdidattend?"checked='checked'":"";?>
                       class="checkbox" onChange="document.adminForm.submit();"/>
            </div>
            <?php } ?>
            <div class="floatleft">
	            <label ><?php echo Text::_('RSVP_SEARCH_BY_INVITEE'); ?></label>
                <input type="text" name="searchinvitees" value="<?php echo $this->searchinvitees; ?>"
                       class="inputbox" onChange="document.adminForm.submit();"/>
            </div>
            <div class="floatleft">
	            <label ><?php echo Text::_('RSVP_SEARCH_BY_TEMPLATE'); ?></label>
                <?php echo $this->searchtemplates; ?>
            </div>
            <?php if (isset($this->catlist) && strpos($this->catlist, "<select")!==false) { ?>
            <div class="floatleft">
                <?php echo isset($this->catlist) ? $this->catlist : ""; ?>
            </div>
            <?php } ?>
        </div>
        <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist   table table-striped">
            <tr>
                <th width="20" nowrap="nowrap">
                    <?php echo HTMLHelper::_('grid.checkall'); ?>
                </th>

                <th class="title" width="50%" nowrap="nowrap">
                    <?php echo HTMLHelper::_('grid.sort', 'JEV_ICAL_SUMMARY', 'det.summary', $this->orderdir, $this->order, "sessions.list"); ?>
                </th>
	            <th width="20%" nowrap="nowrap">
		            <?php echo HTMLHelper::_('grid.sort', 'RSVP_SESSION_TEMPLATE', 'templatetitle', $this->orderdir, $this->order, "sessions.list"); ?>
	            </th>
                <th width="10%" nowrap="nowrap">
                    <?php echo HTMLHelper::_('grid.sort', 'RSVP_STARTDATE', 'startdate', $this->orderdir, $this->order, "sessions.list"); ?>
                </th>
                <th width="10%" nowrap="nowrap">
                    <?php echo HTMLHelper::_('grid.sort', 'JEV_EVENT_CATEGORY', 'ev.catid', $this->orderdir, $this->order, "sessions.list"); ?>
                </th>
                <th width="10%" nowrap="nowrap">
                    <?php echo HTMLHelper::_('grid.sort', 'JEV_EVENT_CREATOR', 'ev.created_by', $this->orderdir, $this->order, "sessions.list"); ?>
                </th>
                <?php if ($params->get("showcapacitycol", 0) && $params->get("waitinglist", 0)) { ?>
                    <th width="10%">
                        <?php echo HTMLHelper::_('grid.sort', 'RSVP_CAPACITY', 'capacity', $this->orderdir, $this->order, "sessions.list"); ?>
                    </th>
                <?php } else { ?>
                    <th width="10%">
                        <?php echo HTMLHelper::_('grid.sort', 'RSVP_JUSTCAPACITY', 'capacity', $this->orderdir, $this->order, "sessions.list"); ?>
                    </th>
                <?php }
                ?>
                <?php if ($params->get("waitinglist", 0)) { ?>
                    <th width="10%">
                        <?php echo HTMLHelper::_('grid.sort', 'JEV_ATTENDEES_AND_WAITING', 'atdcount', $this->orderdir, $this->order, "sessions.list"); ?>
                    </th>
                <?php } else { ?>
                    <th width="10%">
                        <?php echo HTMLHelper::_('grid.sort', 'RSVP_JUSTATTENDEES', 'atdcount', $this->orderdir, $this->order, "sessions.list"); ?>
                    </th>
                <?php }
                ?>
                <?php if ($params->get("requireconfirmation", 0)) { ?>
		<th width="10%">
		    <?php echo HTMLHelper::_('grid.sort', 'RSVP_UNCONFIRMED', 'unconfirmed', $this->orderdir, $this->order, "sessions.list"); ?>
		</th>
                <?php }
                ?>
                <?php if ($params->get("allowpending", 0)) { ?>
		<th width="10%">
		    <?php echo HTMLHelper::_('grid.sort', 'RSVP_UNAPPROVED', 'unapproved', $this->orderdir, $this->order, "sessions.list"); ?>
		</th>
                <?php }
                ?>
                <th width="20%" nowrap="nowrap">
                    <?php echo HTMLHelper::_('grid.sort', 'JEV_INVITEES', 'invcount', $this->orderdir, $this->order, "sessions.list"); ?>
                </th>
            </tr>

            <?php
            $k = 0;
            $nullDate = $db->getNullDate();

            for ($i = 0, $n = count($this->rows); $i < $n; $i++) {
                $row = &$this->rows[$i];

                //$editlink = $this->repeating?$this->editLink($row->repeat):$this->editRepeatLink($row->repeat);
                // always edit event for session details!
                $editlink = $this->editLink($row->repeat);
                ?>
                <tr class="row<?php echo $k; ?>">
                    <td width="20">
                        <input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->ev_id; ?>"
                               onclick="isChecked(this.checked);"/>
                    </td>
                    <td>
                        <a href="<?php echo $editlink;?>" title="<?php echo Text::_('JEV_CLICK_TO_EDIT'); ?>"
                           target="_blank"><?php echo !empty($this->repeating) ? $row->repeat->summary : $row->summary; ?></a>
                    </td>
	                <td>
		                <?php
		                $user = Factory::getUser();
		                if (!empty($row->templatetitle))
		                {
		                	$canEditTemplate = false;
		                    if (JevTemplateHelper::canCreateGlobal() && $row->globaltemplate){
			                    $canEditTemplate = true;
		                    }
		                    if ($row->templatecreatedby == $user->id)
		                    {
			                    $canEditTemplate = true;
		                    }

			                echo $row->templatetitle;

		                    if ($canEditTemplate)
		                    {
			                    if (!$row->istemplate)
			                    {
				                    ?>
				                    <a href="<?php echo Route::_("index.php?option=com_rsvppro&task=templates.edit&cid[]=" . $row->templateid);?>" target="_blank" title="Edit custom template for this specific event">
					                    <span class="gsl-icon" data-gsl-icon="icon:cog"></span>
				                    </a>
				                    <?php
			                    }
			                    else
			                    {
				                    ?>
				                    <a href="<?php echo Route::_("index.php?option=com_rsvppro&task=templates.edit&cid[]=" . $row->templateid);?>" target="_blank" title="Edit template for all events">
					                    <span class="gsl-icon" data-gsl-icon="icon:pencil"></span>
				                    </a>
				                    <a href="#" onclick="alert('Please edit the event in order to create a custom template for this specific event');return false;" target="_blank" title="Please edit the event in order to create a custom template for this specific event">
					                    <span class="gsl-icon" data-gsl-icon="icon:cog"></span>
				                    </a>
				                    <?php
			                    }
		                    }
		                    else
		                    {
			                    if (JevTemplateHelper::canCreateOwn())
			                    {
				                    ?>
				                    <a href="#" onclick="alert('Please edit the event in order to create a custom template for this specific event');return false;" target="_blank" title="Please edit the event in order to create a custom template for this specific event">
					                    <span class="gsl-icon" data-gsl-icon="icon:cog"></span>
				                    </a>
				                    <?php
			                    }
		                    }
		                }
		                ?>
	                </td>
                    <td align="center">
                        <?php echo strftime($params->get("listdateformat", "%Y-%m-%d"), $row->starttime); ?>
                    </td>
                    <td align="center"><?php echo $row->repeat->getCategoryName();?></td>
                    <td align="center"><?php echo $row->repeat->creatorName();?></td>
                    <td align="center"><?php if ($row->allowregistration) {
                            // only show attendance data if repeating type matches the attendance record
                            if (($this->nonrepeating == 1 && $row->allrepeats == 0) || ($this->nonrepeating == 0 && $row->allrepeats == 1)) {
                                echo Text::_("RSVP_NA");
                            } else {
                                if ($row->capacity > 0) {
                                    echo $row->capacity;
                                    if ($row->waitingcapacity > 0) echo " ( $row->waitingcapacity )";
                                }
                            }
                        }
                        ?>
                    </td>
                    <td align="center"><?php if ($row->allowregistration) {
                            // only show attendance data if repeating type matches the attendance record
                            if (($row->repeat_id == 0 && $row->allrepeats == 0) || ($row->repeat_id > 0 && $row->allrepeats == 1)) {
                                echo Text::_("RSVP_NA");
                            } else {
                                ?>
                                <a href="index.php?option=com_rsvppro&task=attendees.overview&atd_id[]=<?php echo $row->atd_id . "|" . $row->repeat_id; ?>&repeating=<?php echo $row->repeat_id == 0 ? 1 : 0; ?>"
                                   title="<?php echo Text::_('JEV_CLICK_FOR_LIST'); ?>">
                                    <?php
                                    if ($row->atdcount > 0) {
                                        if ($row->capacity > 0 && $row->waitingcapacity > 0) {
                                            $row->atdcount -= $row->waitingcount;
                                        }
                                        echo $row->atdcount;
                                        if ($row->capacity > 0 && $row->waitingcapacity > 0 && $row->waitingcount > 0) {
                                            echo " + $row->waitingcount";
                                        } else if ($row->waitingcapacity > 0) {
                                            echo " + 0";
                                        }
                                    } else echo " -- ";
                                    /*
                                    if ($row->capacity>0) {
                                    echo " (".$row->capacity;
                                    if ($row->waitingcapacity>0) echo " + $row->waitingcapacity";
                                    echo ")";
                                    }
                                    */
                                    ?>
                                    <img
                                        src="<?php echo Uri::root(); ?>/components/com_rsvppro/assets/images/Leads.png"
                                        alt='Leads'/>
                                </a>
                            <?php
                            }
                        }?></td>

			<?php if ($params->get("requireconfirmation", 0)) { ?>
			<td align="center">
			    <?php
			    if (isset($row->unconfirmed) && $row->unconfirmed>0){
				echo $row->unconfirmed;
			    }
			    ?>
			</td>
			<?php }
			?>
			<?php if ($params->get("allowpending", 0)) { ?>
			<td  align="center">
			    <?php
			    if (isset($row->unapproved) && $row->unapproved>0){
				echo $row->unapproved;
			    }
			    ?>
			</td>
			<?php }
			?>

			<td align="center"><?php if ($row->invites) {
                    // only show invites data if repeating type matches the attendance record
					if (($row->inviterepeat_id == 0 && $row->allinvites == 0) || ($row->inviterepeat_id > 0 && $row->allinvites == 1)) {
                        echo Text::_("RSVP_NA");
                    } else {
                        ?>
                        <a href="index.php?option=com_rsvppro&task=invitees.overview&atd_id[]=<?php echo $row->atd_id . "|" . $row->inviterepeat_id; ?>&repeating=<?php echo $row->inviterepeat_id == 0 ? 1 : 0; ?>"
                           title="<?php echo Text::_('JEV_CLICK_FOR_LIST'); ?>">
                            <?php
                            if ($row->invcount > 0) echo $row->invcount; else echo " -- "; ?>
                            <img
                                src="<?php echo Uri::root(); ?>/components/com_rsvppro/assets/images/Invitees.png"
                                alt='Leads'/>
                        </a>
                    <?php
                    }

                }?></td>
                </tr>
                <?php
                $k = 1 - $k;
            } ?>
            <tr>
                <td align="center" colspan="10">
	                <?php
	                echo  $this->pageNav->getPaginationLinks('joomla.pagination.links', array("showLimitBox"=> true));
	                ?>
                </td>
            </tr>
        </table>
        <input type="hidden" name="option" value="<?php echo RSVP_COM_COMPONENT; ?>"/>
        <input type="hidden" name="task" value="sessions.list"/>
        <input type="hidden" name="boxchecked" value="0"/>
        <input type="hidden" name="filter_order" value="<?php echo $this->order; ?>"/>
        <input type="hidden" name="filter_order_Dir" value="<?php echo $this->orderdir; ?>"/>
        <!-- used to make sure attendee list is unfiltered when first visited //-->
        <input type="hidden" name="filter_waiting" value="-1"/>
        <input type="hidden" name="filter_confirmed" value="-1"/>
        <input type="hidden" name="Itemid" value="<?php echo Factory::getApplication()->input->getInt("Itemid", 0); ?>"/>
        <?php echo HTMLHelper::_('form.token'); ?>
    </form>
</div>
