<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: overview.php 1676 2010-01-20 02:50:34Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
defined('_JEXEC') or die('Restricted Access');

use Joomla\CMS\Application\ApplicationHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Date\Date;

$this->rows = $this->items;

ini_set("display_errors",0);
set_time_limit(180);
$date = new Date('+0 seconds');
$filename = "rsvp_export_templates_" . $date->toSql() . ".json";

foreach ($this->items as $key => & $item)
{
	$db = Factory::getDbo();
	$query = $db->getQuery(true);
	$query->select('*')
		->from('#__jev_rsvp_fields')
		->where('template_id = ' . $item->id);
	$db->setQuery($query);
	$item->fields = $db->loadObjectList();
	$item->id = 0;
	unset($item);
}

	$data = json_encode($this->items);

	// Finally, generate a file
	$size = strlen($data);

	@ob_end_clean();
	@ini_set("zlib.output_compression", "Off");
	header("Pragma: public");
	header("Expires: 0");
	header("Cache-Control: private");
	header("Content-Type: text/json; charset=utf-8");
	header("Content-Disposition: attachment; filename=$filename");
	header("Accept-Ranges: bytes");
	header("Content-Length: $size");
	echo $data;
	exit();


