<?php
/**
* @copyright	Copyright (C) 2008-2021 GWE Systems Ltd. All rights reserved.
 * @license		By negoriation with author via http://www.gwesystems.com
*/
defined('JPATH_PLATFORM') or die;

use Joomla\Registry\Registry;
use Joomla\CMS\MVC\Model\BaseDatabaseModel;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;

function ProcessJsonRequest(&$requestObject, $returnData){

	if (!isset($requestObject->typeahead)){
		return array();
	}

	$user = Factory::getUser();
	if ($user->id==0){
		PlgSystemGwejson::throwerror("There was an error");
	}
        
    $lang = Factory::getLanguage();
	$lang->load("com_rsvppro", JPATH_ADMINISTRATOR);
    $lang->load("com_rsvppro", JPATH_SITE);
	$lang->load("com_jevents", JPATH_ADMINISTRATOR);
    $lang->load("com_jevents", JPATH_SITE);

	$returnData->titles	= array();
	$returnData->exactmatch=false;

	ini_set("display_errors",0);

    include_once(JPATH_SITE."/components/com_rsvppro/models/jevtemplates.php");
    $model = BaseDatabaseModel::getInstance("JevtemplatesModelJevtemplates");
    $template = $requestObject->typeahead;

    $model->typeahead = $template;
    $templates =  $model->getItems();

    $items = array();
    if (count($templates) > 0)
    {
    	foreach ($templates as $template)
	    {
		    $templateid = $template->id;
		    include_once(JPATH_ADMINISTRATOR . "/components/com_rsvppro/models/template.php");
		    include_once(JPATH_ADMINISTRATOR . "/components/com_rsvppro/tables/template.php");
		    $datamodel = BaseDatabaseModel::getInstance("RsvpprotemplatesModelTemplate");
		    $datamodel->setId($templateid);

		    // model function needs to think we are editing the template
		    Factory::getApplication()->input->set("option", "com_rsvppro");
		    Factory::getApplication()->input->set('task', 'templates.edit');

		    $templateItem = $datamodel->getData();

		    if ($templateItem)
		    {
			    $items[] = $templateItem;
		    }
	    }
    }
	return $items;

}

