<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
defined('_JEXEC') or die('Restricted Access');

use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Layout\LayoutHelper;

$jevparams = ComponentHelper::getParams(JEV_COM_COMPONENT);

PluginHelper::importPlugin("rsvppro");

$transaction = $this->transaction;
$rsvpdata = $this->rsvpdata;
$repeat = $this->repeat;
$attendee= $this->attendee;


if ($transaction->transaction_id > 0)
{
	$activePlugin = false;

	Factory::getApplication()->input->set("gateway", $transaction->gateway);
	// Test needed for J4/J3.9 compatibility
	$dispatcher = method_exists(Factory::getApplication(),"getDispatcher") ? Factory::getApplication()->getDispatcher() : JEventDispatcher::getInstance();
	Factory::getApplication()->triggerEvent('onActiveGatewayClass', array(&$activePlugin, "paymentpage"));

	if ($activePlugin && class_exists($activePlugin) && method_exists($activePlugin, "editTransaction"))
	{
		// load plugin parameters
		$pluginname = strtolower(str_replace("plgRsvppro", "", $activePlugin));
		$plugin =  PluginHelper::getPlugin("rsvppro", $pluginname);
		$gateway = new $activePlugin($dispatcher, (array) ($plugin));
		echo $gateway->editTransaction($attendee, $rsvpdata, $repeat, $transaction);
	}
}
else
{
	// currently only support manual payment - down the line offer a choice!
	/*
	  $activePlugins = array();
	  Factory::getApplication()->triggerEvent( 'activeGateways', array(&$activePlugins,"paymentpage"));
	 */
	Factory::getApplication()->input->set("gateway", 'manual');
	Factory::getApplication()->triggerEvent('onActiveGatewayClass', array(&$activePlugin, "paymentpage"));

	if ($activePlugin && class_exists($activePlugin) && method_exists($activePlugin, "editTransaction"))
	{
		// load plugin parameters
		$pluginname = strtolower(str_replace("plgRsvppro", "", $activePlugin));
		$plugin =  PluginHelper::getPlugin("rsvppro", $pluginname);
		// Test needed for J4/J3.9 compatibility
		$dispatcher = method_exists(Factory::getApplication(),"getDispatcher") ? Factory::getApplication()->getDispatcher() : JEventDispatcher::getInstance();
		$gateway = new $activePlugin($dispatcher, (array) ($plugin));
		echo $gateway->editTransaction($attendee, $rsvpdata, $repeat, $transaction);
	}
}


