<?php
/**
 * copyright (C) 2008-2021 GWE Systems Ltd - All rights reserved
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

include_once(JPATH_COMPONENT_ADMINISTRATOR."/views/".basename(dirname(__FILE__))."/".basename(__FILE__));

/**
 * HTML View class for the component
 *
 * @static
 */
class FrontAttendeesViewAttendees extends AdminAttendeesViewAttendees
{
	function __construct($config = array()){
		parent::__construct($config);
		HTMLHelper::stylesheet( 'components/'.RSVP_COM_COMPONENT.'/assets/css/rsvppro.css' );
		HTMLHelper::stylesheet("components/com_rsvppro/assets/pagination/css/pagination.css");

		HTMLHelper::stylesheet("components/com_rsvppro/assets/adminsim/css/admin.css");
		JEVHelper::loadCustomCSS();

	}


	function overview($tpl = null)
	{
		$document = Factory::getDocument();
		$params = ComponentHelper::getParams('com_rsvppro');
		$document->setTitle($params->get('page_title',Text::_('RSVP_ATTENDEES')));

		include_once(JPATH_COMPONENT_ADMINISTRATOR."/libraries/JevPagination.php");
		$this->pageNav = new JevPagination( $this->pageNav->total, $this->pageNav->limitstart, $this->pageNav->limit,true);

		$params = ComponentHelper::getParams(RSVP_COM_COMPONENT);
		$this->params = $params;

		parent::overview($tpl);
	}

	function showToolBar(){

		$jeventsparams     = ComponentHelper::getParams('com_jevents');

		if (!$jeventsparams->get("newfrontendediting", 1))
		{
			return parent::showToolBar();
		}

	}

}
