<?php

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: Search.php 1410 2009-04-09 08:13:54Z geraint $
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2021 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        https://www.jevents.net
 */
defined('_JEXEC') or die('No Direct Access');

// Strips out full events
class jevHidebasedoncapacityFilter extends jevFilter
{

	function __construct($tablename, $filterfield, $isstring=true)
	{
		$this->filterType = "jevidebaseoncapacity";
		$this->filterNullValue = "";
		parent::__construct($tablename, $filterfield, true);

	}

	function _createFilter($prefix="")
	{
		if (!$this->filterField)
			return "";

		$filter = "atd.capacity = 0 OR (atdcnt.atdcount < (atd.capacity + atd.waitingcapacity))";
		return $filter;

	}

	// always used in conjunction with hide for non invirees filter so no need for join
	function _createJoinFilter($prefix="")
	{
		if (!$this->filterField ) return "";

		// Note, we check in plugin/jevrsvppro.php around line 339 if the below has been set before setting again.
		return "#__jev_attendeecount as atdcnt ON atdcnt.at_id=atd.id AND (atd.allrepeats=1 OR atdcnt.rp_id=rpt.rp_id) ";

	}

}
