<?php

/**
* @copyright	Copyright (C) 2008-2021 GWE Systems Ltd. All rights reserved.
 * @license		By negoriation with author via http://www.gwesystems.com
*/

use Joomla\Utilities\ArrayHelper;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Factory;

function gwejson_skiptoken()
{
	// This file checks the token
	return true;

}


function ProcessJsonRequest(&$requestObject, $returnData){

	$returnData->titles	= array();
	$returnData->exactmatch=false;

	ini_set("display_errors",0);

	if (!isset($requestObject->ev_id) || $requestObject->ev_id==0){
		throwerror("There was an error");
	}

	$token = Session::getFormToken();;
	if (!isset($requestObject->token)  || $requestObject->token!=$token){
		throwerror("There was an error - bad token.  Please refresh the page and try again.");
	}

	$user = Factory::getUser();
	if ($user->id==0){
		throwerror("There was an error");
	}

	$db=Factory::getDBO();
	$db->setQuery("SELECT * FROM #__jevents_vevent where ev_id=".intval($requestObject->ev_id));
	$event = $db->loadObject();
	if (!$event || ($event->created_by!=$user->id && ! JEVHelper::isAdminUser($user) && !JEVHelper::canDeleteEvent($event, $user))){
		throwerror("There was an error");
	}

	if ($requestObject->error){
		return "Error";
	}

	if (!isset($requestObject->task) || ($requestObject->task!=="inviteFriends" && $requestObject->task!=="inviteJSGroup" && $requestObject->task!=="inviteJUGroup"  && $requestObject->task!=="inviteCBGroup" && $requestObject->task!=="inviteList")){
		throwerror("There was an error");
	}

	$params = ComponentHelper::getParams("com_rsvppro");
	$inviteusertype = $params->get("inviteusertype",0);
	$where = "";
    $join = 'LEFT JOIN #__user_usergroup_map AS map2 ON map2.user_id = ju.id';
    if ($inviteusertype)
    {
            if (is_array($inviteusertype)){
                    $inviteusertype = ArrayHelper::toInteger($inviteusertype);
                    $inviteusertype[] = -1;
                    $inviteusertype = implode(",",$inviteusertype);
            }
            $where = ' AND map2.group_id IN ( ' . $inviteusertype .')';
    }

	if ($requestObject->task=="inviteFriends" ) {
		$sql = "SELECT ju.username, ju.name, ju.id  FROM #__users as ju "
		.$join
		." LEFT JOIN #__community_connection as jcc on jcc.connect_to=ju.id AND jcc.status=1 AND jcc.group=0"
		." WHERE jcc.connect_from=".intval($user->id)
		. $where
		." order by name asc" ;
		$db->setQuery($sql);
		$matches = $db->loadObjectList();
	}
	else if ($requestObject->task=="inviteJSGroup" ) {
		if (!isset($requestObject->groupid)) {
			throwerror("There was an error");
		}
		$groupid = intval(str_replace("invitationgroup_","",$requestObject->groupid));

		$sql = "SELECT ju.username, ju.name, ju.id  FROM #__users as ju " 
		. $join
		." LEFT JOIN #__community_groups_members as jcgm on jcgm.memberid=ju.id AND jcgm.approved=1 "
		." LEFT JOIN #__community_groups as jcg on jcgm.groupid=jcg.id"
		." WHERE jcgm.groupid=".$groupid." AND (jcg.published=1 OR (jcgm.approved=1 AND jcgm.memberid=".$user->id."))"
		. $where
		." order by name asc" ;
		$db->setQuery($sql);
		$matches = $db->loadObjectList();
	}
	else if ($requestObject->task=="inviteJUGroup" ) {
		if (!isset($requestObject->groupid)) {
			throwerror("There was an error");
		}
		$groupid = intval(str_replace("invitationgroup_","",$requestObject->groupid));

		$sql = "SELECT ju.username, ju.name, ju.id, ju.block, ju.activation  FROM #__users as ju "
		. $join
		." LEFT JOIN #__user_usergroup_map as ugm on ugm.user_id=ju.id  "
		." WHERE ugm.group_id=".$groupid
		. $where
        ." AND ju.block = 0 AND ju.activation IN('', '0')"
		." order by name asc" ;
		$db->setQuery($sql);
		$matches = $db->loadObjectList();
	}
	else if ($requestObject->task=="inviteList" ) {
		if (!isset($requestObject->listid)) {
			throwerror("There was an error");
		}
		$listid = intval(str_replace("invitationlist_","",$requestObject->listid));

		$sql = "SELECT ju.username, ju.name, ju.id, ju.block, ju.activation  FROM #__users as ju "
		.$join
		." LEFT JOIN #__jev_invitelist_member as ilm on ilm.user_id=ju.id"
		." LEFT JOIN #__jev_invitelist as il on ilm.list_id=il.id"
		." WHERE ilm.list_id=".$listid ." AND il.user_id=".$user->id
		. $where
			." AND ju.block = 0 AND ju.activation IN('', '0')"
		." order by name asc" ;
		$db->setQuery($sql);
		$matches = $db->loadObjectList();
		
		// and get the email based entries too 
		$sql = "SELECT ilm.email_name as name, email_address as username, 0 as id FROM #__jev_invitelist_member as ilm "
		." LEFT JOIN #__jev_invitelist as il on ilm.list_id=il.id"
		." WHERE ilm.list_id=".$listid ." AND il.user_id=".$user->id." AND email_address <> ''"
		." order by ilm.email_name asc" ;
		$db->setQuery($sql);
		$emailmatches = $db->loadObjectList();
		/*
		if (count($emailmatches)>0)
		{
			foreach ($emailmatches as &$match){
				$match->name =  $match->email_name;
				$match->username =  $match->email_address;
				$match->id  =  $match->email_name."(". $match->email_address.")";
			}
			unset ($match);
		}
		*/
		$matches = array_merge($matches,$emailmatches);
	}
	else if ($requestObject->task=="inviteCBGroup" ) {
		if (!isset($requestObject->groupid)) {
			throwerror("There was an error");
		}
		$groupid = intval(str_replace("invitationgroup_","",$requestObject->groupid));

		$sql = "SELECT ju.username, ju.name, ju.id, ju.block, ju.activation   FROM #__users as ju "
		. $join
		." LEFT JOIN #__groupjive_users as jgu on jgu.user_id=ju.id AND jgu.status>0 "
		." WHERE jgu.group=".$groupid." AND jgu.status>0"
		. $where
		." AND ju.block = 0 AND ju.activation IN('', '0')"
		." order by name asc" ;
		$db->setQuery($sql);
		$matches = $db->loadObjectList();
	}
	if (count($matches)==0){
		$returnData->result = 0;
	}
	else {
		$returnData->result = count($matches);
		foreach ($matches as $match) {
			$row = array("name"=>$match->name,"username"=>$match->username,"id"=>$match->id);			
			$returnData->titles[] = $row; 
		}
	}

	return $returnData;
}

