<?php
/**
 * copyright (C) 2009 - 2021 GWE Systems Ltd - All rights reserved
 */
// TODO - when saving form if not a repeating event reset the "each repeat" options to "all repeats"!!!
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\Utilities\ArrayHelper;
use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Table\Table;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Editor\Editor;
JLoader::register('JevRsvpInvitees', JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/jevrinvitees.php");

class JevRsvpAttendance
{

	private $params;
	private $jomsocial = false;
	private $cbuilder = false;
	private $groupjive = false;

	public function __construct($params)
	{
		$this->params = $params;
		jimport('joomla.filesystem.file');
		if (File::exists(JPATH_SITE . '/components/com_community/community.php'))
		{
			if (ComponentHelper::isEnabled("com_community"))
			{
				$this->jomsocial = true;
			}
		}
		if (File::exists(JPATH_SITE . '/components/com_comprofiler/comprofiler.php'))
		{
			if (ComponentHelper::isEnabled("com_comprofiler"))
			{
				if (File::exists(JPATH_SITE . "/components/com_comprofiler/plugin/user/plug_cbgroupjive/cbgroupjive.php"))
				{
					$this->groupjive = true;
				}
				$this->cbuilder = true;
			}
		}

	}

	public function editAttendance(&$extraTabs, &$row, &$params)
	{
		$customfields = array();
		// Only setup when editing an event (not a repeat)
		if (Factory::getApplication()->input->getString("jevtask", "") != "icalevent.edit" && Factory::getApplication()->input->getString("jevtask", "") != "icalevent.editcopy")
			return true;

		/*
		  jimport('joomla.application.component.view');

		  $theme = JEV_CommonFunctions::getJEventsViewName ();
		  if(version_compare(JVERSION, "1.6.0", 'ge')){
		  $this->_basepath = JPATH_SITE . "/plugins/jevents/jevrsvppro/rsvppro/";
		  }
		  else {
		  $this->_basepath = JPATH_SITE . "/plugins/jevents/rsvppro/";
		  }
		  $this->view = new HtmlView(array('base_path' => $this->_basepath, "template_path" => $this->_basepath . "tmpl/default", "name" => $theme));

		  $this->view->addTemplatePath($this->_basepath . "tmpl/" . $theme);
		  $this->view->addTemplatePath(JPATH_SITE . '/' . 'templates' . '/' . Factory::getApplication ()->getTemplate() . '/' . 'html' . '/' . "plg_rsvppro" . '/' . "default");
		  $this->view->addTemplatePath(JPATH_SITE . '/' . 'templates' . '/' . Factory::getApplication ()->getTemplate() . '/' . 'html' . '/' . "plg_rsvppro" . '/' . $theme);
		  $this->view->setLayout("edit");
		 */

		$db = Factory::getDBO();

		$conf = Factory::getConfig();
		$editor = $conf->get('editor');
		$editor =  Editor::getInstance($editor);

		HTMLHelper::script('plugins/jevents/jevrsvppro/rsvppro/rsvp.js');
		HTMLHelper::stylesheet('plugins/jevents/jevrsvppro/rsvppro/rsvp.css');

		$eventid = (int) $row->ev_id();
		$user = Factory::getUser();
		if (!($user->id == $row->created_by() || JEVHelper::isAdminUser($user) || JEVHelper::canDeleteEvent($row, $user)))
		{
			$label = Text::_('JEV_INVITATIONS');
			$customfield = array("label" => $label, "input" => Text::_('JEV_CREATOR_ONLY'));
			$customfields["rsvp"] = $customfield;
			return true;
		}
		if ($eventid > 0)
		{

			$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=" . $eventid;
			$db->setQuery($sql);
			$rsvpdata = $db->loadObject();
			if (!$rsvpdata)
			{
				$rsvpdata = $this->newRSVP();
			}
		}
		else
		{
			$rsvpdata = $this->newRSVP();
		}

		// If this is a copy reset the event id
		if (Factory::getApplication()->input->getString("jevtask", "") == "icalevent.editcopy")
		{
			$eventid = 0;
                    //  $rsvpdata->regopen = "0000-00-00 00:00:00";
                    //  $rsvpdata->regclose = "0000-00-00 00:00:00";
                    //  $rsvpdata->cancelclose = "0000-00-00 00:00:00";
		}

		if ($rsvpdata->message == "")
		{
			$rsvpdata->message = Text::_('JEV_DEFAULT_MESSAGE');
		}
		if ($rsvpdata->subject == "")
		{
			$rsvpdata->subject = Text::_('JEV_DEFAULT_SUBJECT');
		}
		if ($rsvpdata->remindermessage == "")
		{
			$rsvpdata->remindermessage = Text::_('JEV_DEFAULT_REMINDER_MESSAGE');
		}
		if ($rsvpdata->remindersubject == "")
		{
			$rsvpdata->remindersubject = Text::_('JEV_DEFAULT_REMINDER_SUBJECT');
		}
		$script = "JevRsvpLanguage.strings['JEV_HIDE_REGISTRATION_RSVP']='" . Text::_("JEV_HIDE_REGISTRATION_RSVP", true) . "';";
		$document = Factory::getDocument();
		$document->addScriptDeclaration($script);

		if (!version_compare(JVERSION, "3.0", 'ge'))
		{
			$style = <<<STYLE

div#jevrsvpattend div , div#jevrsvpinvite div, div#jevrsvpremind div{
	/*clear:left;*/
	line-height:1.6em;
}
div#jevrsvpattend .control-label, div#jevrsvpinvite .control-label, div#jevrsvpremind .control-label{
	width:240px;
	margin-right:10px;
	display:block;
	float:left;
}
div#jevrsvpattend .control-group, div#jevrsvpinvite .control-group, div#jevrsvpremind .control-group{
	clear:left;
}
STYLE;
			$document->addStyleDeclaration($style);
		}
		if ($this->params->get("attendance", 1))
		{

			ob_start();
			?>
			<input type="hidden" name="custom_rsvp_evid" value="<?php echo $eventid; ?>" />
			<div id="jevrsvpattend">
				<fieldset  class="form-horizontal" >
					<legend><?php echo Text::_('JEV_ATTENDANCE'); ?></legend>
					<div class="control-group">
						<label class='control-label'><?php echo Text::_('JEV_ALLOW_REGISTRATION'); ?></label>
						<div class="rsvp_allowregistration  radio btn-group">
							<label for="custom_rsvp_allowregistration1" class="btn radio"><?php echo Text::_('JEV_YES'); ?>
								<input type="radio" name="custom_rsvp_allowregistration" id="custom_rsvp_allowregistration1" value="1" <?php echo $rsvpdata->allowregistration == 1 ? "checked='checked'" : ""; ?> onclick="enableattendance();" />
							</label>
							<label for="custom_rsvp_allowregistration0"  class="btn radio"><?php echo Text::_('JEV_NO'); ?>
								<input type="radio" name="custom_rsvp_allowregistration" id="custom_rsvp_allowregistration0" value="0" <?php echo $rsvpdata->allowregistration ? "" : "checked='checked'"; ?> onclick="disableattendance();"/>
							</label>
							<?php
							if ($this->params->get("invites", 0))
							{
								?>
								<label for="custom_rsvp_allowregistration2" class="btn radio"><?php echo Text::_('JEV_BY_INVITATION'); ?>
									<input type="radio" name="custom_rsvp_allowregistration" id="custom_rsvp_allowregistration2" value="2" <?php echo $rsvpdata->allowregistration == 2 ? "checked='checked'" : ""; ?> onclick="enableattendance();"/>
								</label>
							<?php } ?>
						</div>
					</div>
					<input type="hidden" name="custom_rsvp_params" id="custom_rsvp_params" value="<?php echo $rsvpdata->params; ?>"  />

					<div id="jevattendance" <?php
				if (!$rsvpdata->allowregistration)
					echo "style='display:none'";
							?> >
						<div class="rsvp_sessionaccess control-group">
							<label for="custom_rsvp_sessionaccess"  class='control-label'><?php echo Text::_('JEV_SESSION_ACCESSLEVEL'); ?></label>
							<div class="controls">
								<?php
								$accesslist = JEventsHTML::buildAccessSelect(intval($rsvpdata->sessionaccess), 'class="inputbox" size="1" style="width:200px" onchange="toggleSessionAccessMessage()" ', Text::_("JEV_ACCESSLEVEL_MATCHES_EVENT"), "custom_rsvp_sessionaccess");
								if ($rsvpdata->sessionaccess < 0)
								{
									$accesslist = str_replace('<option value="">', '<option value="-1" selected="selected">', $accesslist);
								}
								else
								{
									$accesslist = str_replace('<option value="">', '<option value="-1" >', $accesslist);
								}
								echo $accesslist;
								?>
							</div>
						</div>
						<div id="rsvp_sessionaccessmessage" class="control-group" <?php	if ($rsvpdata->sessionaccess < 0) echo "style='display:none'";?> >
							<div class='control-label'><?php echo Text::_('JEV_SESSION_NOACCESS_MESSAGE'); ?></div>
							<div class="controls">
								<input type="text" size="60" maxlength="250" value="<?php echo htmlspecialchars($rsvpdata->sessionaccessmessage); ?>" id="custom_rsvp_sessionaccessmessage" name="custom_rsvp_sessionaccessmessage" />
							</div>
						</div>
						<?php
						if ($this->params->get("capacity", 0))
						{
							?>

							<div   class="rsvp_capacity  control-group">
								<label for="custom_rsvp_capacity"  class='control-label'><?php echo Text::_('JEV_CAPACITY'); ?></label>
								<div class="controls">
									<input type="text" name="custom_rsvp_capacity" id="custom_rsvp_capacity" value="<?php echo $rsvpdata->capacity; ?>" size="6" />
								</div>
							</div>
							<?php
							if ($this->params->get("waitinglist", 0))
							{
								?>
								<div  class="rsvp_waitingcapacity  control-group">
									<label for="custom_rsvp_waitingcapacity"  class='control-label'><?php echo Text::_('JEV_WAITING_CAPACITY'); ?></label>
									<div class="controls">
										<input type="text" name="custom_rsvp_waitingcapacity" id="custom_rsvp_waitingcapacity" value="<?php echo $rsvpdata->waitingcapacity; ?>" size="6" />
									</div>
								</div>
								<?php
							}
						}
						if ($this->params->get("allowpending", 0))
						{
							?>
							<div  class="rsvp_initialstate  control-group">
								<div class='control-label'><?php echo Text::_('JEV_INITIAL_REGISTRATION_STATE'); ?></div>
								<div class="radio btn-group">
									<label for="custom_rsvp_initialstate0" class="btn radio"><?php echo Text::_('JEV_INITIAL_STATE_PENDING'); ?>
										<input type="radio" name="custom_rsvp_initialstate" id="custom_rsvp_initialstate0" value="0" <?php echo $rsvpdata->initialstate == 0 ? "checked='checked'" : ""; ?> />
									</label>
									<label for="custom_rsvp_initialstate1" class="btn radio"><?php echo Text::_('JEV_INITIAL_STATE_APPROVED'); ?>
										<input type="radio" name="custom_rsvp_initialstate" id="custom_rsvp_initialstate1" value="1" <?php echo $rsvpdata->initialstate == 1 ? "checked='checked'" : ""; ?> />
									</label>
								</div>
							</div>
							<?php
						}
						jimport("joomla.filesystem.file");
						$templates = Folder::files(dirname(__FILE__) . "/params/", ".xml");
						// only offer extra fields templates if there is more than one available
						if ($rsvpdata->template == "")
						{
							$rsvpdata->template = $this->params->get("defaultcf");
						}
						// And the new db versions
						$db = Factory::getDBO();
						$user = Factory::getUser();
						$db->setQuery("SELECT * FROM #__jev_rsvp_templates where (global=1 OR created_by=" . $user->id . " OR id=" . intval($rsvpdata->template) . ") AND ((istemplate=1  AND published =1  ) OR id=" . intval($rsvpdata->template) . ")");

						try {
							$dbtemplates = $db->loadObjectList('id');
						}
						catch (RuntimeException $e)
						{
							$error = $e->getMessage();
							echo $error;
							$dbtemplates = array();
						}

						if (count($templates) > 1 || (count($templates) == 1 && $templates[0] == "fieldssample.xml")  || count($dbtemplates) >0 )
						{
							?>
							<div class="rsvp_extrafields">
								<strong><?php echo Text::_('JEV_EXTRA_FIELDS'); ?></strong>
								<div  class="control-group">
									<label for="custom_rsvp_template" class='control-label'><?php echo Text::_('JEV_EXTRA_FIELDS_TEMPLATE'); ?></label>
									<div class="controls">
										<?php
										$options = array();
										$options[] = HTMLHelper::_('select.option', "", Text::_('JEV_SELECT_TEMPLATE'), 'var', 'text');
										$options[] = HTMLHelper::_('select.option', -1, Text::_('JEV_BLANK_TEMPLATE'), 'var', 'text');
										foreach ($dbtemplates as $template)
										{
											// we will use the locked field to specify disabled then we will replace later
											$option = HTMLHelper::_('select.option', $template->id, $template->title, 'var', 'text', $template->locked);
											$options[] = $option;
										}

										foreach ($templates as $template)
										{
											if ($template == "fieldssample.xml")
											{
												continue;
											}
											$options[] = HTMLHelper::_('select.option', $template, ucfirst(str_replace(".xml", "", $template)), 'var', 'text');
										}
										// if only one choice then no need to ask - this is not good since it forces you to use the custom fields
										if (count($options) == 2)
										{
											//    array_shift($options);
										}

										// set default template if a new event and no template has been selected
										$rsvpparams = ComponentHelper::getParams("com_rsvppro");
										if (is_null($rsvpdata->template) && $rsvpparams->get("defaulttemplate",0)) {
											$rsvpdata->template = $rsvpparams->get("defaulttemplate",0);
										}

										$html = HTMLHelper::_('select.genericlist', $options, "custom_rsvp_template", 'onchange="changeTemplateSelection()" style="width:300px" ', 'var', 'text', $rsvpdata->template);
										// we uses the locked field to specify disabled so we replace now
										echo str_replace('disabled="disabled"', 'locked=1', $html);

										// find out if template has flat fee field
										$script = "var hasFlatFees = []; \n";
										$hasFlatFees = array();
										foreach ($dbtemplates as $template)
										{
											$db->setQuery("SELECT template_id FROM #__jev_rsvp_fields where template_id=" . $template->id . " and type='jevrflatfee' limit 1");
											$flatfees = $db->loadResult();
											if (!empty($flatfees)){
												$script .= " hasFlatFees.push(".$flatfees.");\n";
												$hasFlatFees[]= $flatfees;
											}
										}
										$document = Factory::getDocument();
										$document->addScriptDeclaration($script);
										?>
									</div>
									<?php

									JLoader::register('JevModal',JPATH_LIBRARIES."/jevents/jevmodal/jevmodal.php");
									JevModal::modal(" a.jevmodal");

									$link = Route::_("index.php?option=com_rsvppro&task=templates.edit&tmpl=component&cid[0]=xxGGxx&customise=1");
									if (intval($rsvpdata->template) > 0 && array_key_exists($rsvpdata->template, $dbtemplates))
									{
										$style = "";
										$locked =  $dbtemplates[$rsvpdata->template]->locked;
									}
									else
									{
										$style = "style='display:none' ";
                                        if (intval($rsvpdata->template) > 0 && !array_key_exists($rsvpdata->template, $dbtemplates))
                                        {
                                                echo "<strong>".Text::_("RSVP_MISSING_SESSION_TEMPLATE")."<strong><br/>";
                                        }
										$locked =  true;
									}
									if (JevTemplateHelper::canCreateOwn() || JevTemplateHelper::canCreateGlobal())
									{
										?>
										<div class="controls">
											<a <?php echo $style; ?> href='#<?php echo str_replace(" ", "_", Text::_('JEV_CUSTOMISE_EXTRA_FIELDS_TEMPLATE')); ?>'
											                         onclick="customiseTemplate('<?php echo $link; ?>', '<?php echo Text::_('JEV_CUSTOMISE_EXTRA_FIELDS_TEMPLATE', true);?>');return false;"
											                         id="custom_rsvp_template_link"
											                         style="display: <?php echo $locked ? 'none' : 'inline-block'; ?>"
											>
												<?php echo Text::_('JEV_CUSTOMISE_EXTRA_FIELDS_TEMPLATE'); ?>
											</a>
										</div>
										<?php
									}
									else
									{
										?>
										<div class="controls">
											<span id="custom_rsvp_template_link"></span>
										</div>
										<?php
									}
									?>
								</div>
							<?php
							if ($this->params->get("overrideprice", 1))
							{
								?>
								<div  class="rsvp_overrideprice  control-group" style="display:<?php echo in_array($rsvpdata->template, $hasFlatFees)?"block":"none"; ?>;">
									<label for="custom_rsvp_overrideprice"  class='control-label'><?php echo Text::_('JEV_OVERRIDE_FLAT_FEE'); ?></label>
									<div class="controls">
										<input type="text" name="custom_rsvp_overrideprice" id="custom_rsvp_overrideprice" value="<?php echo $rsvpdata->overrideprice; ?>" size="6" />
									</div>
								</div>
								<?php
							}
							?>
							</div>
						<?php
						}
						?>
						<div class="rsvp_allowcancellation control-group">
							<div class='control-label'><?php echo Text::_('JEV_ALLOW_CANCELLATION'); ?></div>
							<div class=" radio btn-group">
								<label for="custom_rsvp_allowcancellation1" class="btn radio"><?php echo Text::_('JEV_YES'); ?>
									<input type="radio" name="custom_rsvp_allowcancellation" id="custom_rsvp_allowcancellation1" value="1"  <?php echo $rsvpdata->allowcancellation ? "checked='checked'" : ""; ?> onclick="updateCancelClose(1);"/>
								</label>
								<label for="custom_rsvp_allowcancellation0" class="btn radio"><?php echo Text::_('JEV_NO'); ?>
									<input type="radio" name="custom_rsvp_allowcancellation" id="custom_rsvp_allowcancellation0" value="0" <?php echo $rsvpdata->allowcancellation ? "" : "checked='checked'"; ?>  onclick="updateCancelClose(0);"/>
								</label>
							</div>
						</div>

						<?php
						// handle legacy events before allowchanges was introduced
						if ($rsvpdata->allowchanges == -1)
						{
							$rsvpdata->allowchanges = $rsvpdata->allowcancellation;
						}
						?>
						<div class="rsvp_allowchanges control-group">
							<div class='control-label'><?php echo Text::_('JEV_ALLOW_CHANGES'); ?></div>
							<div class=" radio btn-group">
								<label for="custom_rsvp_allowchanges1" class="btn radio"><?php echo Text::_('JEV_YES'); ?>
									<input type="radio"  name="custom_rsvp_allowchanges" id="custom_rsvp_allowchanges1" value="1"  <?php echo $rsvpdata->allowchanges ? "checked='checked'" : ""; ?> onclick="updateCancelClose(1);"/>
								</label>
								<label for="custom_rsvp_allowchanges0" class="btn radio"><?php echo Text::_('JEV_NO'); ?>
									<input type="radio" name="custom_rsvp_allowchanges" id="custom_rsvp_allowchanges0" value="0" <?php echo $rsvpdata->allowchanges ? "" : "checked='checked'"; ?>  onclick="updateCancelClose(0);"/>
								</label>
							</div>
						</div>
                                                <?php
                                                $warning0 = "";
                                                $warning1 = "";
                                                if ($rsvpdata->id){
                                                    $warning = " onclick=\"if (!confirm('".Text::_("JEV_CHANGING_THIS_SETTING_WILL_DELETE_ANY_EXISTING_ATTENDEES", true)."')){jQuery('input[name=custom_rsvp_allrepeats]:not(:checked)').parent().trigger('click'); }; \" ";
                                                    $warning0 = $rsvpdata->allrepeats ? $warning : "";
                                                    $warning1 = $rsvpdata->allrepeats ? "" : $warning ;
                                                }
                                                    ?>
						<div class="rsvp_allrepeats control-group">
							<div  class='control-label'><?php echo Text::_('JEV_REGISTER_TRACK_ATTENDANCE'); ?></div>
							<div class=" radio btn-group">
								<label for="custom_rsvp_allrepeats1" class="btn radio"><?php echo Text::_('JEV_ALL_REPEATS'); ?>
									<input type="radio" <?php echo $warning1;?> name="custom_rsvp_allrepeats" id="custom_rsvp_allrepeats1" value="1" <?php echo $rsvpdata->allrepeats ? "checked='checked'" : ""; ?>/>
								</label>
								<label for="custom_rsvp_allrepeats0" class="btn radio "><?php echo Text::_('JEV_SPECIFIC_REPEATS'); ?>
									<input type="radio"  <?php echo $warning0;?> name="custom_rsvp_allrepeats" id="custom_rsvp_allrepeats0" value="0" <?php echo $rsvpdata->allrepeats ? "" : "checked='checked'"; ?>/>
								</label>
							</div>
						</div>
						<div class="rsvp_showattendees control-group">
							<div  class='control-label'><?php echo Text::_('JEV_SHOW_ATTENDEES'); ?></div>
							<div class=" radio btn-group">
								<label for="custom_rsvp_showattendees1" class="btn radio"><?php echo Text::_('JEV_YES'); ?>
									<input type="radio"  name="custom_rsvp_showattendees" id="custom_rsvp_showattendees1" value="1" <?php echo $rsvpdata->showattendees == 1 ? "checked='checked'" : ""; ?>/>
								</label>
								<label for="custom_rsvp_showattendees0" class="btn radio"><?php echo Text::_('JEV_NO'); ?>
									<input type="radio"  name="custom_rsvp_showattendees" id="custom_rsvp_showattendees0" value="0" <?php echo $rsvpdata->showattendees ? "" : "checked='checked'"; ?>/>
								</label>
								<?php
								if ($this->params->get("invites", 0))
								{
									?>
									<label for="custom_rsvp_showattendees2" class="btn radio"><?php echo Text::_('JEV_BY_INVITATION'); ?>
										<input type="radio"  name="custom_rsvp_showattendees" id="custom_rsvp_showattendees2" value="2" <?php echo $rsvpdata->showattendees == 2 ? "checked='checked'" : ""; ?>/>
									</label>
								<?php } ?>
                                                                <label for="custom_rsvp_showattendees3" class="btn radio"><?php echo Text::_('JEV_ONLY_TO_ATTENDEES'); ?>
                                                                        <input type="radio"  name="custom_rsvp_showattendees" id="custom_rsvp_showattendees3" value="3" <?php echo $rsvpdata->showattendees == 3 ? "checked='checked'" : ""; ?>/>
                                                                </label>
							</div>
						</div>
						<?php
						// Do we allow conditional sessions?
						if ($this->params->get("conditionsessions", 0))
						{
							try {
								?>
								<div  class="rsvp_conditionsession control-group" >
									<label for="custom_rsvp_conditionsession"  class='control-label'><?php echo Text::_('RSVP_CONDITIONAL_REGISTRATION_SESSION'); ?></label>
									<div class="controls">
									<?php
										$conditionsession = "";
										$conditionsessionlabel = "";
										if (trim($rsvpdata->conditionsession)!=="" && strpos($rsvpdata->conditionsession, "|")>0){
											list($csatd_id, $csrp_id) = explode("|",$rsvpdata->conditionsession);
											$conditionsession = $rsvpdata->conditionsession;
											$db = Factory::getDbo();
											if ($csrp_id>0){
												$query = "SELECT CONCAT_WS( ' - ', det.summary, DATE_FORMAT(rpt.startrepeat , '%e %b %Y')) as title"
												. "\n FROM #__jevents_vevent as ev "
												. "\n LEFT JOIN #__jevents_repetition as rpt ON rpt.eventid=ev.ev_id"
												. "\n LEFT JOIN #__jevents_vevdetail as det ON rpt.eventdetail_id=det.evdet_id"
												. "\n LEFT JOIN #__jev_attendance AS atd ON atd.ev_id = ev.ev_id"
												. "\n WHERE atd.id = ".$csatd_id . " AND rpt.rp_id = ".$csrp_id;
												$db->setQuery($query);
											}
											else {
												$query = "SELECT det.summary as title "
												. "\n FROM #__jevents_vevent as ev "
												. "\n LEFT JOIN #__jevents_vevdetail as det ON ev.detail_id=det.evdet_id"
												. "\n LEFT JOIN #__jev_attendance AS atd ON atd.ev_id = ev.ev_id"
												. "\n WHERE atd.id = ".$csatd_id ;
												$db->setQuery($query);
											}
											$conditionsessionlabel = $db->loadResult();

										}
										?>
										<input type="hidden" name="custom_rsvp_conditionsession" id="custom_rsvp_conditionsession" value="<?php echo $conditionsession;?>"/>
										<div id="scrollable-dropdown-menu" style="float:left">
											<input name="evconditionsession_notused"  id="evconditionsession" class="jevtypeahead" value="<?php echo $conditionsessionlabel;?>"  type="text" autocomplete="off" size="50">
										</div>
										<?php
										JLoader::register('JevTypeahead', JPATH_LIBRARIES . "/jevents/jevtypeahead/jevtypeahead.php");
										$datapath = Route::_("index.php?option=com_rsvppro&ttoption=com_rsvppro&task=gwejson&file=findsession", false);
										$prefetchdatapath = Route::_("index.php?option=com_rsvppro&ttoption=com_rsvppro&task=gwejson&file=findsession&prefetch=1", false);
										JevTypeahead::typeahead('#evconditionsession', array('remote' => $datapath,
											//'prefetch'=>  $prefetchdatapath,
											'data_value' => 'title',
											'data_id' => 'session_id',
											'field_selector' => '#custom_rsvp_conditionsession',
											'minLength' => 3,
											'limit' => 10,
											'scrollable' => 1,));
											//,'emptyCallback' => 'noMatchingLocations()'));
									?>
										<div style="clear:left"></div>
									</div>
								</div>
							<?php
							}
							catch (Exception $ex) {

							}
						}
							?>
							<div class="rsvp_attendintro ">
							<div style="font-weight:bold"><?php echo Text::_('JEV_ATTEND_INTRO'); ?></div>
							<?php
							// parameters : areaname, content, hidden field, width, height, rows, cols
							echo $editor->display('custom_rsvp_attendintro', $rsvpdata->attendintro, "100%", 250, '50', '10', false);
							?>
						</div>
						<?php
						echo $this->openCloseDates($rsvpdata, $row);
						?>
					</div>
				</fieldset>
			</div>
			<?php
			$input = ob_get_clean();

			$label = Text::_('JEV_ATTENDANCE');
			$rawlabel = 'JEV_ATTENDANCE';
			$extraTabs[] = array("title" => $label, "paneid" => 'jev_attend_pane', "content" => $input, "rawtitle"=>$rawlabel);
		}

		if ($this->params->get("invites", 0))
		{
		    $rsvpdata->invites = ($rsvpdata->invites || ($this->params->get("autoinvite", "") != "" && $this->params->get("defaultallowinvites", 0) == 1) || $this->params->get("defaultallowinvites", 0) == 1);
			if ($eventid ==0 ){
				$rsvpdata->hidenoninvitees = $this->params->get('defaultshoweventinvites', "0");
			}
            HTMLHelper::script(  'components/'.RSVP_COM_COMPONENT.'/assets/js/forms.js' );
			ob_start();
			?>
			<div id="jevrsvpinvite">
				<fieldset class="form-horizontal" >
					<legend><?php echo Text::_('JEV_INVITATION_OPTIONS'); ?></legend>
					<div class="control-group">
						<div class='control-label'><?php echo Text::_('JEV_CREATE_INVITES'); ?></div>
						<div class="rsvp_allowinvitations  radio btn-group">
							<label for="custom_rsvp_invites1" class="btn radio"><?php echo Text::_('JEV_YES'); ?>
								<input type="radio" name="custom_rsvp_invites" id="custom_rsvp_invites1" value="1" onclick="enableinvites()" <?php echo $rsvpdata->invites ? "checked='checked'" : ""; ?>/>
							</label>
							<label for="custom_rsvp_invites0" class="btn radio"><?php echo Text::_('JEV_NO'); ?>
								<input type="radio" name="custom_rsvp_invites" id="custom_rsvp_invites0" value="0" onclick="disableinvites()"  <?php echo $rsvpdata->invites ? "" : "checked='checked'"; ?>/>
							</label>
						</div>
					</div>
					<div id="jev_allinvites" <?php echo $rsvpdata->invites ? "" : "style='display:none;'"; ?> >
						<div class="rsvp_allinvites control-group">
							<div class='control-label'><?php echo Text::_('JEV_ALL_INVITES'); ?></div>
							<div class=" radio btn-group">
								<label for="custom_rsvp_allinvites1" class="btn radio"><?php echo Text::_('JEV_ALL_REPEATS'); ?>
									<input type="radio" name="custom_rsvp_allinvites" id="custom_rsvp_allinvites1" value="1" <?php echo $rsvpdata->allinvites ? "checked='checked'" : ""; ?>/>
								</label>
								<label for="custom_rsvp_allinvites0" class="btn radio"><?php echo Text::_('JEV_SPECIFIC_REPEATS'); ?>
									<input type="radio" name="custom_rsvp_allinvites" id="custom_rsvp_allinvites0" value="0" <?php echo $rsvpdata->allinvites ? "" : "checked='checked'"; ?>/>
								</label>
							</div>
						</div>
						<div class="control-group">
							<div class='control-label'><?php echo Text::_('JEV_HIDE_NONE_INVITEES'); ?></div>
							<div class=" radio btn-group">
								<label for="custom_rsvp_hidenoninvitees1" class="btn radio"><?php echo Text::_('JEV_YES'); ?>
									<input type="radio" name="custom_rsvp_hidenoninvitees" id="custom_rsvp_hidenoninvitees1" value="1" <?php echo $rsvpdata->hidenoninvitees ? "checked='checked'" : ""; ?>/>
								</label>
								<label for="custom_rsvp_hidenoninvitees0" class="btn radio"><?php echo Text::_('JEV_NO'); ?>
									<input type="radio" name="custom_rsvp_hidenoninvitees" id="custom_rsvp_hidenoninvitees0" value="0" <?php echo $rsvpdata->hidenoninvitees ? "" : "checked='checked'"; ?>/>
								</label>
							</div>
						</div>
					</div>
					<div id="jev_invites" <?php echo $rsvpdata->invites ? "" : "style='display:none;'"; ?>>
						<em><?php echo Text::_('JEV_ADD_INVITES_MESSAGE'); ?></em>
					</div>

					<div id="jevmessage"  class="control-group" <?php
			if (!$rsvpdata->invites)
			{
				echo "style='display:none'";
			}
			?>>
						<div style="font-weight:bold">
							<?php
							echo Text::_('JEV_EMAIL_MESSAGE');
							echo " " . HTMLHelper::_('tooltip', Text::_('JEV_DEFAULT_MESSAGE_DESC'), null, 'tooltip.png', null, null, 0);
							?>
						</div>
						<div  class='control-label'>
							<?php echo Text::_('JEV_EMAIL_SUBJECT'); ?>
						</div>
						<div class="controls">
							<input type="text" name="custom_rsvp_subject" value="<?php echo $rsvpdata->subject; ?>" size="50" maxlength="255" />
						</div>
						<?php
						// parameters : areaname, content, hidden field, width, height, rows, cols
						if ($rsvpdata->message == strip_tags($rsvpdata->message))
						{
							$rsvpdata->message = htmlspecialchars(nl2br($rsvpdata->message));
						}
						?>
						<div class="controls">
							<?php echo $editor->display('custom_rsvp_message', $rsvpdata->message, "100%", 250, '50', '10', false); ?>
							<h4><?php echo Text::_("RSVP_SELECT_FIELD_TO_INSERT"); ?> : </h4>
							<select onchange="ticketsEditorPlugin.insert('custom_rsvp_message','custom_rsvp_message_fields' )" id="custom_rsvp_message_fields">
								<option value="Select ...:">Select ...</option>
								<optgroup label="<?php echo Text::_("RSVP_EVENT_FIELDS", true); ?>" >
                                                                    <option value="USERNAME"><?php echo Text::_("JEVR_USERNAME"); ?></option>
                                                                    <option value="NAME"><?php echo Text::_("RSVP_INVITEE_REAL_NAME"); ?></option>
                                                                    <option value="EMAIL"><?php echo Text::_("RSVP_INVITEE_EMAIL"); ?></option>
                                                                    <option value="EVENT"><?php echo Text::_("RSVP_EVENT_TITLE"); ?></option>
                                                                    <option value="DATE}%Y %m %d{/DATE"><?php echo Text::_("RSVP_INVITE_EVENT_DATE"); ?></option>
                                                                    <option value="TIME}%H %M{/TIME"><?php echo Text::_("RSVP_EVENT_TIME"); ?></option>
                                                                    <option value="LINK}{EVENT}{/LINK"><?php echo Text::_("RSVP_EVENT_LINK"); ?></option>
																	<option value="RAWLINK"><?php echo Text::_("RSVP_EVENT_LINK_RAW_URL"); ?></option>
                                                                    <option value="CREATOR"><?php echo Text::_("RSVP_EVENT_CREATOR"); ?></option>
                                                                    <option value="CUSTOM"><?php echo Text::_("RSVP_CUSTOM_FIELD_SUMMARY"); ?></option>
                                                                    <option value="WAITINGMESSAGE"><?php echo Text::_("RSVP_WAITING_MESSAGE"); ?></option>
                                                                    <option value="ATTENDSTATE"><?php echo Text::_("RSVP_ATTEND_STATE"); ?></option>
                                                                    <option value="CONFIRMED"><?php echo Text::_("RSVP_CONFIRMED_STATE"); ?></option>
                                                                    <option value="DIRECTATTENDLINK}linktext{/DIRECTATTENDLINK"><?php echo Text::_("RSVP_DIRECT_ATTEND"); ?></option>
                                                                    <option value="DIRECTNOATTENDLINK}linktext{/DIRECTNOATTENDLINK"><?php echo Text::_("RSVP_DIRECT_NO_ATTEND"); ?></option>
                                                                    <option value="REPEATSUMMARY"><?php echo Text::_("RSVP_EVENT_REPEATSUMMARY"); ?></option>
                                                                    <option value="TICKETS"><?php echo Text::_("RSVP_TICKET_LINK");?></option>
                                                                    <option value="PDFTICKETS"><?php echo Text::_("RSVP_PDF_TICKETS");?></option>
                                                                    <option value="SENDERNAME"><?php echo Text::_("RSVP_SENDERNAME");?></option>
                                                                    <option value="SENDEREMAIL"><?php echo Text::_("RSVP_SENDEREMAIL");?></option>
                                                                    <option value="SENDERUSERNAME"><?php echo Text::_("RSVP_SENDERUSERNAME");?></option>
								</optgroup>
							</select>

						</div>
					</div>
				</fieldset>
			</div>
			<?php
			$input = ob_get_clean();
			$label = Text::_('JEV_INVITATION_OPTIONS');
			$rawlabel = 'JEV_INVITATION_OPTIONS';
			$extraTabs[] = array("title" => $label, "paneid" => 'jev_invite_pane', "content" => $input, "rawtitle"=>$rawlabel);
		}

		if ($this->params->get("reminders", 0))
		{
			PluginHelper::importPlugin("rsvppro");
			$extrareminders = array();
			$results = Factory::getApplication()->triggerEvent('onEditReminders', array(&$extrareminders));

			ob_start();
			?>
			<div id="jevrsvpremind">
				<fieldset class="form-horizontal" >
					<legend><?php echo Text::_('JEV_REMINDER_OPTIONS'); ?></legend>
					<div   class="control-group">
						<div class='control-label'><?php echo Text::_('JEV_ALLOW_REMINDERS'); ?></div>
						<div class="rsvp_allowreminders  radio btn-group">
							<label for="custom_rsvp_allowreminders1" class="btn radio"><?php echo Text::_('JEV_YES'); ?>
								<input type="radio" name="custom_rsvp_allowreminders" id="custom_rsvp_allowreminders1" value="1" onclick="enablereminders()" <?php echo $rsvpdata->allowreminders == 1 ? "checked='checked'" : ""; ?>/>
							</label>
							<label for="custom_rsvp_allowreminders0" class="btn radio"><?php echo Text::_('JEV_NO'); ?>
								<input type="radio" name="custom_rsvp_allowreminders" id="custom_rsvp_allowreminders0" value="0" onclick="disablereminders()"  <?php echo $rsvpdata->allowreminders ? "" : "checked='checked'"; ?>/>
							</label>
							<?php
							foreach ($extrareminders as $k => $v)
							{
								?>
								<label for="custom_rsvp_allowreminders<?php echo $k; ?>" class="btn radio"><?php echo $v; ?>
									<input type="radio" name="custom_rsvp_allowreminders" id="custom_rsvp_allowreminders<?php echo $k; ?>" value="<?php echo $k; ?>" onclick="enablereminders()"  <?php echo $rsvpdata->allowreminders == $k ? "checked='checked'" : ""; ?>/>
								</label>
								<?php
							}
							?>
						</div>
					</div>
					<div id="jevreminder" <?php
				if (!$rsvpdata->allowreminders)
				{
					echo "style='display:none'";
				}
							?>  >
						<div class="rsvp_allreminders control-group">
							<div class='control-label'><?php echo Text::_('JEV_REMIND_ALL_REPEATS'); ?></div>
							<div class="rsvp_allowreminders  radio btn-group">
								<label for="custom_rsvp_remindallrepeats1" class="btn radio"><?php echo Text::_('JEV_FIRST_REPEAT'); ?>
									<input type="radio" name="custom_rsvp_remindallrepeats" id="custom_rsvp_remindallrepeats1" value="1" <?php echo $rsvpdata->remindallrepeats == 1 ? "checked='checked'" : ""; ?>/>
								</label>
								<label for="custom_rsvp_remindallrepeats2" class="btn radio"><?php echo Text::_('JEV_ALL_INDIVIDUAL_REPEATS'); ?>
									<input type="radio" name="custom_rsvp_remindallrepeats" id="custom_rsvp_remindallrepeats2" value="2" <?php echo $rsvpdata->remindallrepeats == 2 ? "checked='checked'" : ""; ?>/>
								</label>
								<label for="custom_rsvp_remindallrepeats0" class="btn radio"><?php echo Text::_('JEV_SPECIFIC_REMINDER_REPEATS'); ?>
									<input type="radio" name="custom_rsvp_remindallrepeats" id="custom_rsvp_remindallrepeats0" value="0" <?php echo $rsvpdata->remindallrepeats == 0 ? "checked='checked'" : ""; ?>/>
								</label>
							</div>
						</div>

						<div class="rsvp_remindernotice control-group">
							<div class='control-label'>
								<label for="custom_rsvp_remindernotice" ><?php echo Text::_('JEV_REMINDER_INTERVAL'); ?></label>
							</div>
							<div class="controls">
								<input type="text" name="custom_rsvp_remindernotice" id="custom_rsvp_remindernotice" value="<?php echo intval($rsvpdata->remindernotice / 3600) ?>" size="12" />
							</div>
						</div>
						<div class="rsvp_remindermessage">
							<div style="font-weight:bold" ><?php
			 echo Text::_('JEV_REMINDER_EMAIL_MESSAGE');

			 echo " " . HTMLHelper::_('tooltip', Text::_('JEV_DEFAULT_MESSAGE_DESC'), null, 'tooltip.png', null, null, 0);
							?></div>
							<div  class='control-label'><?php echo Text::_('JEV_EMAIL_SUBJECT'); ?></div>
							<div class="controls">
								<input type="text" name="custom_rsvp_remindersubject" value="<?php echo $rsvpdata->remindersubject; ?>" size="50" maxlength="255" />
							</div>
							<?php
							// parameters : areaname, content, hidden field, width, height, rows, cols
							if ($rsvpdata->remindermessage == strip_tags($rsvpdata->remindermessage))
							{
								$rsvpdata->remindermessage = htmlspecialchars(nl2br($rsvpdata->remindermessage));
							}
							?>
							<div class="controls">
								<?php echo $editor->display('custom_rsvp_remindermessage', $rsvpdata->remindermessage, "100%", 250, '50', '10', false); ?>
							</div>
						</div>
					</div>
				</fieldset>
			</div>
			<?php
			$input = ob_get_clean();

			JLoader::register('JevModal',JPATH_LIBRARIES."/jevents/jevmodal/jevmodal.php");
			JevModal::modal(" a.jevmodal");

			$label = Text::_('JEV_REMINDER_OPTIONS');
			$customfield = array("label" => $label, "input" => $input);
			$customfields["rsvp"] = $customfield;

			$rawlabel = 'JEV_REMINDER_OPTIONS';
			$extraTabs[] = array("title" => $label, "paneid" => 'jev_remind_pane', "content" => $input, "rawtitle"=>$rawlabel);
		}

		return true;

	}

	private function openCloseDates($rsvpdata, $row)
	{
        // icomoon vs bootstrap icons vs UIKit
		$params = ComponentHelper::getParams(JEV_COM_COMPONENT);
		if (!GSLMSIE10 && $params->get("newfrontendediting", 1))
		{
			$clockicon = '<button class="gsl-button gsl-button-small gsl-button-primary" onclick="let elem = this.parentNode.querySelector(\'input\').dispatchEvent(new MouseEvent(\'click\',{bubbles:true,cancelable:true,view: window}));return false;"><span class="gsl-icon" gsl-icon="icon: clock"></span></button>';
		}
		else
		{
			$clockicon = Factory::getApplication()->isClient('administrator') ? "icon-clock" : "icon-time";
			$clockicon = '<span class="add-on" onclick="let elem = this.parentNode.querySelector(\'input\').dispatchEvent(new MouseEvent(\'click\',{bubbles:true,cancelable:true,view: window}));return false;"><i class="' . $clockicon . '"></i></span>';
		}
        $rsvpparams = ComponentHelper::getParams("com_rsvppro");
        $params = ComponentHelper::getParams(JEV_COM_COMPONENT);
        $minyear = $params->get("com_earliestyear", 1970);
        $maxyear = $params->get("com_latestyear", 2150);
        JLoader::register('JEVHelper', JPATH_SITE . "/components/com_jevents/libraries/helper.php");
        if (method_exists("JEVHelper", "getMinYear"))
        {
                $minyear = JEVHelper::getMinYear();
                $maxyear = JEVHelper::getMaxYear();
        }
		ob_start();
		?>
		<div class="regopendatewrapper">
			<fieldset>
				<legend><?php echo Text::_('JEV_STARTREGISTRATION'); ?></legend>
				<?php
				if ($row->id == 0)
				{
					?>
					<strong><?php echo Text::_("JEV_REGISTRATION_TIME_EMPTY_HANDLING_START"); ?> </strong>
					<br><br>
					<?php
				}
				?>
				<div style="float:left" class="regopendate">
					<?php
					echo Text::_('JEV_STARTREGISTRATION_DATE') . "&nbsp;";

					if ($rsvpdata->regopen == "0000-00-00 00:00:00") {
						$rsvpdata->regopen = strftime("%Y-%m-%d %H:00:00");
					}
					else if ($rsvpdata->regopen == "") {
						$rsvpdata->regopen = "0000-00-00 00:00:00";
					}

					?>
					<input type="hidden" id="custom_rsvp_regopen" name="custom_rsvp_regopen"  value="<?php echo $rsvpdata->regopen; ?>"  />
					<?php
					$inputdateformat = $params->get("com_editdateformat", "d.m.Y");
					$cal = JEVHelper::loadElectricCalendar("regopen", "regopen", substr($rsvpdata->regopen, 0, 10), $minyear, $maxyear, 'checkRegDates(\'regopentime\');', 'checkRegDates(\'regopentime\');', $inputdateformat);
					echo $cal;

					if (strlen($rsvpdata->regopen) > 10)
					{
						$regopentime = strtotime($rsvpdata->regopen);
						$hiddenregopentime = strftime("%H:%M", $regopentime);
						list($h, $m) = explode(":", $hiddenregopentime);
						if (!$params->get("com_calUseStdTime"))
						{
							$format = "%H:%M";
							$regopentime = strftime($format, $regopentime);
						}
						else
						{
							$format = IS_WIN ? "%I:%M" : "%l:%M";
							if ($h > 11)
							{
								$regopentime = strftime($format, $regopentime) . " " . Text::_("JEV_PM");
							}
							else
							{
								$regopentime = strftime($format, $regopentime) . " " . Text::_("JEV_AM");
							}
						}
					}
					else
					{
						$regopentime = "";
						$hiddenregopentime = "00:00";
					}
					?>
				</div>
				<div style="position:relative;float:left;margin-left: 5px;" class="regopentime">
					<?php echo Text::_('JEV_STARTREGISTRATION_TIME') . "&nbsp;"; ?>
					<div>
						<div class="input-append bootstrap-timepicker">
							<input class="inputbox" type="text"  id="regopentime" size="8" readonly="readonly" value="<?php echo $regopentime; ?>" /><?php echo $clockicon;?>
							<input class="inputbox" type="hidden" id="hiddenregopentime" size="8" value="<?php echo $hiddenregopentime; ?>" />
						</div>
					</div>
				</div>
				<strong class="registrationDateIntros"  style="clear:left;display:block;padding-top:10px"><?php echo Text::_("JEV_REGISTRATION_TIME_INTRO"); ?> </strong><br/>
			</fieldset>
		</div>
		<div class="regclosedatewrapper">
			<fieldset><legend><?php echo Text::_('JEV_ENDREGISTRATION'); ?></legend>
				<?php
				if ($row->id == 0)
				{
					?>
					<strong><?php echo Text::_("JEV_REGISTRATION_TIME_EMPTY_HANDLING_END"); ?> </strong>
					<br><br>
					<?php
				}
				?>
				<div style="float:left" class="regclosedate">
					<?php
					echo Text::_('JEV_ENDREGISTRATION_DATE') . "&nbsp;";
					if ($rsvpdata->regclose == "0000-00-00 00:00:00") {
						$rsvpdata->regclose = $row->publish_up();
                                        }
                                        else if ($rsvpdata->regclose == "") {
						$rsvpdata->regclose = "0000-00-00 00:00:00";
					}

					?>
					<input type="hidden" id="custom_rsvp_regclose"  name="custom_rsvp_regclose" value="<?php echo $rsvpdata->regclose; ?>" />
					<?php
					$inputdateformat = $params->get("com_editdateformat", "d.m.Y");
					$cal = JEVHelper::loadElectricCalendar("regclose", "regclose", substr($rsvpdata->regclose, 0, 10), $minyear, $maxyear, 'checkRegDates(\'regclosetime\');', 'checkRegDates(\'regclosetime\');', $inputdateformat);
					echo $cal;

					if (strlen($rsvpdata->regclose) > 10)
					{
						$regclosetime = strtotime($rsvpdata->regclose);
						$hiddenregclosetime = strftime("%H:%M", $regclosetime);
						list($h, $m) = explode(":", $hiddenregclosetime);
						if (!$params->get("com_calUseStdTime"))
						{
							$format = "%H:%M";
							$regclosetime = strftime($format, $regclosetime);
						}
						else
						{
							$format = IS_WIN ? "%I:%M" : "%l:%M";
							if ($h > 11)
							{
								$regclosetime = strftime($format, $regclosetime) . " " . Text::_("JEV_PM");
							}
							else
							{
								$regclosetime = strftime($format, $regclosetime) . " " . Text::_("JEV_AM");
							}
						}
					}
					else
					{
						$regclosetime = "";
						$hiddenregclosetime = "00:00";
					}
					?>
				</div>
				<div style="position:relative;float:left;margin-left: 5px;" class="regclosetime">
					<?php echo Text::_('JEV_ENDREGISTRATION_TIME') . "&nbsp;"; ?>
					<div>
						<div class="input-append bootstrap-timepicker">
							<input class="inputbox" type="text" id="regclosetime" size="8" readonly="readonly" value="<?php echo $regclosetime; ?>" /><?php echo $clockicon;?>
							<input class="inputbox" type="hidden" id="hiddenregclosetime" size="8" value="<?php echo $hiddenregclosetime; ?>" />
						</div>
					</div>
				</div>
				<strong class="registrationDateIntros" style="clear:left;display:block;padding-top:10px"><?php echo Text::_("JEV_REGISTRATION_TIME_INTRO"); ?> </strong><br/>
			</fieldset>
		</div>
		<div id='jevendcancel' style="display:<?php echo $rsvpdata->allowcancellation ? 'block' : 'none'; ?>">
			<fieldset><legend><?php echo Text::_('JEV_ENDCANCELLATIONS'); ?></legend>
				<?php
				if ($row->id == 0)
				{
					?>
					<strong><?php echo Text::_("JEV_REGISTRATION_TIME_EMPTY_HANDLING_ENDCANCEL"); ?> </strong>
					<br><br>
					<?php
				}
				?>
				<div style="float:left">
					<?php
					echo Text::_('JEV_ENDCANCELLATION_DATE') . "&nbsp;";

                                        if ($rsvpdata->cancelclose == "0000-00-00 00:00:00") {
						$rsvpdata->cancelclose = $row->publish_up();
                                        }
                                        else if ($rsvpdata->cancelclose == "") {
						$rsvpdata->cancelclose = "0000-00-00 00:00:00";
					}

					?>
					<input type="hidden" id="custom_rsvp_cancelclose"  name="custom_rsvp_cancelclose" value="<?php echo $rsvpdata->cancelclose; ?>" />
					<?php
					$inputdateformat = $params->get("com_editdateformat", "d.m.Y");
					$cal = JEVHelper::loadElectricCalendar("cancelclose", "cancelclose", substr($rsvpdata->cancelclose, 0, 10), $minyear, $maxyear, 'checkRegDates(\'cancelclosetime\');', 'checkRegDates(\'cancelclosetime\');', $inputdateformat);
					echo $cal;

					if (strlen($rsvpdata->cancelclose) > 10)
					{
						$cancelclosetime = strtotime($rsvpdata->cancelclose);
						$hiddencancelclosetime = strftime("%H:%M", $cancelclosetime);
						list($h, $m) = explode(":", $hiddencancelclosetime);
						if (!$params->get("com_calUseStdTime"))
						{
							$format = "%H:%M";
							$cancelclosetime = strftime($format, $cancelclosetime);
						}
						else
						{
							$format = IS_WIN ? "%I:%M" : "%l:%M";
							if ($h > 11)
							{
								$cancelclosetime = strftime($format, $cancelclosetime) . " " . Text::_("JEV_PM");
							}
							else
							{
								$cancelclosetime = strftime($format, $cancelclosetime) . " " . Text::_("JEV_AM");
							}
						}
					}
					else
					{
						$cancelclosetime = "";
						$hiddencancelclosetime = "00:00";
					}
					if (version_compare(JVERSION, "1.6.0", 'ge'))
					{
						$pluginpath = 'plugins/jevents/jevrsvppro/rsvppro/';
					}
					else
					{
						$pluginpath = 'plugins/jevents/rsvppro/';
					}
					?>
				</div>
				<div style="position:relative;float:left;margin-left: 5px;" >
					<?php echo Text::_('JEV_ENDCANCELLATION_TIME') . "&nbsp;"; ?>
					<div>
						<div class="input-append bootstrap-timepicker">
							<input class="inputbox" type="text" id="cancelclosetime" size="8" value="<?php echo $cancelclosetime; ?>" /><?php echo $clockicon;?>
							<input class="inputbox" type="hidden" id="hiddencancelclosetime" size="8" value="<?php echo $hiddencancelclosetime; ?>" />
						</div>
					</div>
				</div>
				<strong class="registrationDateIntros" style="clear:left;display:block;padding-top:10px"><?php echo Text::_("JEV_ENDCANCELLATIONS_INTRO"); ?> </strong><br/>
			</fieldset>
		</div>
		<div id="rsvpspacer"></div>
		<?php
			HTMLHelper::stylesheet("components/com_rsvppro/assets/css/bootstrap-timepicker.css");
		?>
		<script  type="text/javascript" >
			<?php
			// use #jevents because on some templates using 'body' leads to the timepicker being outside the edit page.

			if (!$params->get("com_calUseStdTime"))
			{
				$timeoptions = "{showMeridian:false, minuteStep:5, defaultTime:'%s', template:'dropdown'}";
			}
			else
			{
				$timeoptions = "{showMeridian:true, minuteStep:5, defaultTime:'%s', template:'dropdown'}";
			}
//			$timeoptions = "{showMeridian:true, minuteStep:5, defaultTime:'%s', template:'dropdown'}";
			?>
			document.addEventListener('DOMContentLoaded', function () {
			if (jQuery("#regopentime").length) {
				jQuery("#regopentime").timepicker(<?php echo sprintf($timeoptions,$regopentime);?>);
				jQuery("#regopentime").on('change',function() {convertTime('regopentime');});
			}
			if (jQuery("#regclosetime").length) {
				jQuery("#regclosetime").timepicker(<?php echo sprintf($timeoptions,$regclosetime);?>);
				jQuery("#regclosetime").on('change',function() {convertTime('regclosetime')});
			}
			if (jQuery("#cancelclosetime").length) {
				jQuery("#cancelclosetime").timepicker(<?php echo sprintf($timeoptions,$cancelclosetime);?>);
				jQuery("#cancelclosetime").on('change',function() {convertTime('cancelclosetime')});
			}
            })
		</script>

<!--
		<div>
			<label for="cvc">Enter your CVC
				<popup-info
						img="/images/default.png"
						data-text="Your card validation code (CVC) is an extra security feature — it is the last 3 or 4 numbers on the back of your card."
				>
					Version 2<br><br>Your card validation code (CVC) is an extra security feature — it is the last 3 or 4 numbers on the back of your card.
				</popup-info>
			</label>
			<input type="text" id="cvc">
			<script defer>
                // Create a class for the element
                class PopUpInfo extends HTMLElement {
                    constructor() {
                        // Always call super first in constructor
                        super();

                        // Create a shadow root
                        const shadow = this.attachShadow({mode: 'closed'});

                        //const text = this.getAttribute('data-text');
                        const text = this.innerHTML;

	                    // Insert icon
                        let imgUrl;
                        if(this.hasAttribute('img')) {
                            imgUrl = this.getAttribute('img');
                        } else {
                            imgUrl = '/images/alt.png';
                        }

                        // Create spans
                        const html = `
<link rel='stylesheet' href='/media/com_jevents/css/uikit.gsl.css?3.6.13' />
<style>
      .wrapper {
        position: relative;
      }
      .info {
        font-size: 0.8rem;
        color:#000;
        width: 200px;
        display: inline-block;
        border: 1px solid black;
        padding: 10px;
        background: white;
        border-radius: 10px;
        opacity: 0;
        transition: 0.6s all;
        position: absolute;
        bottom: 20px;
        left: 10px;
        z-index: 3;
      }
      img {
        width: 1.2rem;
      }
      .icon:hover + .info, .icon:focus + .info {
        opacity: 1;
      }
</style>
<div class="gsl-scope" id="gslc">
	<div class='wrapper'>
		<span class='icon gsl-button gsl-button-small gsl-button-primary' tabindex='0'>
			<img src='${imgUrl}' />
		</span>
		<span class='info'>${text}</span>
	</div>
</div>
<br>
<br>
<br>
`;
                        shadow.innerHTML = html;
                    }

                    connectedCallback() {
                        console.log('Custom element added to page.');
                        // I could simulate gslUIkit here to load icons etc. BUT I can't use uikit since the shadow dom doesn't have access to document!
                        // also see https://github.com/mdn/web-components-examples/blob/master/life-cycle-callbacks/main.js
                    }
                }

                // Define the new element
                customElements.define('popup-info', PopUpInfo);
			</script>
		</div>
//-->
		<?php
		$html = ob_get_clean();
		return $html;

	}

	public function storeAttendance($event)
	{
		$evdetail = $event->_detail;
		if (!isset($evdetail->_customFields) || !is_array($evdetail->_customFields) || !array_key_exists("rsvp_allowregistration", $evdetail->_customFields))
			return;

		$db = Factory::getDBO();

		$eventid = isset($evdetail->_customFields["rsvp_evid"]) ? intval($evdetail->_customFields["rsvp_evid"]) : 0;
		if ($eventid == 0)
		{
			$eventid = $event->ev_id;
		}
		if ($eventid > 0)
		{

			$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=" . $eventid;
			$db->setQuery($sql);
			$rsvpdata = $db->loadObject();

			// Store details in registry - will need them for waiting lists!
			$registry = JevRegistry::getinstance("jevents");
			$registry->set("rsvpdata", $rsvpdata);
			$registry->set("event", $event);

			Table::addIncludePath(JPATH_ADMINISTRATOR . "/components/com_rsvppro/tables/");
			$rsvpitem =  Table::getInstance('jev_attendance');
			//$rsvpitem = new Table("#__jev_attendance", "id", $db);
			// ensure picks up default values
			foreach ($this->newRSVP() as $k => $v)
			{
				$rsvpitem->$k = $v;
			}
			$rsvpitem->id = 0;
			foreach ($evdetail->_customFields as $key => $value)
			{
				if (strpos($key, "rsvp_") === 0)
				{
					$key = str_replace("rsvp_", "", $key);
					$rsvpitem->$key = $value;

					// update to seconds already done by newRSVP unless set from custom fields
					if ($key == "remindernotice")
					{
						$rsvpitem->remindernotice *= 3600;
					}

					if ($key == "regopen" && ($value == "" || $value == "0000-00-00 00:00:00"))
					{
						$rsvpitem->$key = strftime("%Y-%m-%d %H:00:00");
					}

					if ($key == "regclose" && ($value == "" || $value == "0000-00-00 00:00:00"))
					{
						$start = JevDate::strftime('%Y-%m-%d %H:00:00', $evdetail->dtstart);
						$rsvpitem->$key = $start;
					}

					if ($key == "cancelclose" && ($value == "" || $value == "0000-00-00 00:00:00"))
					{
						$start = JevDate::strftime('%Y-%m-%d %H:00:00', $evdetail->dtstart);
						$rsvpitem->$key = $start;
					}
				}
			}
			unset($rsvpitem->evid);
			$rsvpitem->ev_id = intval($eventid);

			if (Factory::getApplication()->input->getString("freq") == "none")
			{
				$rsvpitem->allrepeats = 1;
				$rsvpitem->allinvites = 1;
				$rsvpitem->remindallrepeats = 1;
			}
			if ($rsvpdata && $rsvpdata->id > 0)
			{
				$rsvpitem->id = intval($rsvpdata->id);
				$success = $rsvpitem->store();

				// Also clear out defunct attendance and invitation records
				// if !registration allows then remove all attendance records
				if (!$rsvpitem->allowregistration)
				{
					/*
					 * Keep the attendees in case someone wants to disable registrations temporarily and then reinstate them
					  $sql = "DELETE FROM #__jev_attendees WHERE at_id=" . $rsvpdata->id;
					  $db->setQuery($sql);
					  $db->execute();
					 */
				}

				// if attendance is recorded once for all repeats then remove repeat specific attendance records
				if ($rsvpitem->allrepeats)
				{
					$sql = "DELETE FROM #__jev_attendees WHERE at_id=" . $rsvpdata->id . " AND rp_id>0";
					$db->setQuery($sql);
					$db->execute();

					//$sql = "DELETE FROM #__jev_attendance WHERE ev_id=" . $rsvpdata->ev_id . " AND allrepeats=0";
					//$db->setQuery($sql);
					//$db->execute();
				}
				else
				{
					// if attendance is recorded separately for each repeats then remove general attendance records
					$sql = "DELETE FROM #__jev_attendees WHERE at_id=" . $rsvpdata->id . " AND rp_id=0";
					$db->setQuery($sql);
					$db->execute();

					//$sql = "DELETE FROM #__jev_attendance WHERE ev_id=" . $rsvpdata->ev_id . " AND allrepeats=1";
					//$db->setQuery($sql);
					//$db->execute();
				}

				// if no invites for this event then remove all invites
				if (!$rsvpitem->invites)
				{
					$sql = "DELETE FROM #__jev_invitees WHERE at_id=" . $rsvpdata->id;
					$db->setQuery($sql);
					$db->execute();
				}
				// if invites cover all repeats then remove repeat specific attendance records
				if ($rsvpitem->allinvites)
				{
					$sql = "DELETE FROM #__jev_invitees WHERE at_id=" . $rsvpdata->id . " AND rp_id>0";
					$db->setQuery($sql);
					$db->execute();
				}
				else
				{
					// if attendance is recorded separately for each repeats then remove general attendance records
					$sql = "DELETE FROM #__jev_invitees WHERE at_id=" . $rsvpdata->id . " AND rp_id=0";
					$db->setQuery($sql);
					$db->execute();
				}


				// TODO clean up reminders too
			}
			else
			{
				$success = $rsvpitem->store();
			}

			if ($success)
			{
				// Make sure the waiting list reflects any change in capacity
				if (isset($rsvpdata) && $rsvpdata->id)
				{
					JLoader::register('JevRsvpAttendees', JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/jevrattendees.php");
					$jevrDisplayAttendees = new JevRsvpAttendees($this->params, $this->jomsocial, $rsvpdata);
					$jevrDisplayAttendees->updateWaitingList($rsvpdata, $rsvpdata->id);
					//$jevrDisplayAttendance = new JevRsvpDisplayAttendance($this->params);
					//$jevrDisplayAttendance->updateWaitingList($rsvpdata->id);
				}
			}

			return $success;
		}
		return false;

	}

	public function reinstateReminders($row){

		if (isset($row->ev_id)){
			$ev_id = $row->ev_id;

			// get the data and query models
			$dataModel = new JEventsDataModel("JEventsAdminDBModel");
			$queryModel = new JEventsDBModel($dataModel);

			// get event by event id
			$jevent = $queryModel->getEventById(intval($ev_id), 1, "icaldb");
		}
		else {
			$jevent = $row;
		}

		if (!is_null($jevent) && $row->ev_id > 0) {

		    $db = Factory::getDbo();
		    $sql = "SELECT * FROM #__jev_attendance WHERE ev_id=" . $jevent->ev_id();
            $db->setQuery($sql);
            $rsvpdata = $db->loadObject();

            if (!$rsvpdata)
            {
                return;
            }

            $db= Factory::getDBO();
            // find existing reminders
            $sql = "UPDATE #__jev_reminders set sentmessage = 0 WHERE at_id=".$rsvpdata->id;

            if ($rsvpdata->remindallrepeats==0){
                $sql .= " AND rp_id=".$jevent->rp_id();
            }
            $db->setQuery($sql);
            $db->execute();
	    }
		return true;
	}

	public function deleteAttendance($idlist)
	{
		$ids = explode(",", $idlist);
		$ids = ArrayHelper::toInteger($ids);
		$idlist = implode(",", $ids);

		// fetch the attendance records
		$db = Factory::getDBO();
		$sql = "SELECT id FROM #__jev_attendance WHERE ev_id IN (" . $idlist . ")";
		$db->setQuery($sql);
		$atids = $db->loadColumn();

		$sql = "DELETE FROM #__jev_attendance WHERE ev_id IN (" . $idlist . ")";
		$db->setQuery($sql);
		$db->execute();

		if ($atids && count($atids) > 0)
		{
			$atids = implode(",", $atids);

			$sql = "DELETE FROM #__jev_attendees WHERE at_id IN (" . $atids . ")";
			$db->setQuery($sql);
			$db->execute();

			$sql = "DELETE FROM #__jev_invitees WHERE at_id IN (" . $atids . ")";
			$db->setQuery($sql);
			$db->execute();

			$sql = "DELETE FROM #__jev_reminders WHERE at_id IN (" . $atids . ")";
			$db->setQuery($sql);
			$db->execute();
		}

		return true;

	}

	private function newRSVP()
	{
		$rsvpdata = new stdClass();
		$rsvpdata->id = 0;
		$rsvpdata->allowregistration = $this->params->get("defaultallow", 0);
		// Add these as defaults from the params!!!
		if ($this->params->get("allowpending", 0))
		{
			$rsvpdata->initialstate = $this->params->get("defaultinitialstate", 1);
		}
		else
		{
			$rsvpdata->initialstate = 1;
		}
		$rsvpdata->allowcancellation = $this->params->get("defaultcancellation", 0);
		$rsvpdata->allowchanges = $this->params->get("defaultchanges", 0);
		$rsvpdata->allinvites = 1;
		$rsvpdata->allrepeats = 1;
		$rsvpdata->showattendees = $this->params->get("defaultshowattendees", 0);
		$rsvpdata->hidenoninvitees = $this->params->get('defaultshoweventinvites', "0") ;
		$rsvpdata->capacity = 0;
		$rsvpdata->waitingcapacity = 0;
		$rsvpdata->overrideprice = "";
		$rsvpdata->invites = (int) $this->params->get("defaultallowinvites", 0);
		$rsvpdata->template = "";
		$rsvpdata->attendintro = $this->params->get("defintro", "");
		$rsvpdata->message = $this->params->get("message", Text::_('JEV_DEFAULT_MESSAGE'));
		$rsvpdata->subject = $this->params->get("subject", Text::_('JEV_DEFAULT_SUBJECT'));
		$rsvpdata->allowreminders = $this->params->get("defaultallowreminders", 0);
		$rsvpdata->remindermessage = $this->params->get("remindermessage", Text::_('JEV_DEFAULT_REMINDER_MESSAGE'));
		$rsvpdata->remindersubject = $this->params->get("remindersubject", Text::_('JEV_DEFAULT_REMINDER_SUBJECT'));
		$rsvpdata->remindernotice = intval($this->params->get("reminderinterval", 24)) * 3600;
		$rsvpdata->remindallrepeats = 1;
		$rsvpdata->sessionaccess = -1;
		$rsvpdata->sessionaccessmessage = "";
		$rsvpdata->conditionsession = "";
		$rsvpdata->params = "";
		$rsvpdata->regclose = "";
		$rsvpdata->cancelclose = "";
		$rsvpdata->regopen = "";
		$rsvpdata->params = "";

		return $rsvpdata;

	}

	public function autoInvite($event)
	{
		if ($this->params->get("autoinvite", "") == "")
			return;

		$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=" . $event->ev_id;
		$db = Factory::getDBO();
		$db->setQuery($sql);
		$rsvpitem = $db->loadObject();

		if (!$rsvpitem)
			return;

		// check if this has already been processed.
		$db = Factory::getDBO();
		$db->setQuery("SELECT count(at_id) FROM #__jev_invitees WHERE at_id=" . intval($rsvpitem->id));
		if (intval($db->loadResult()) != 0)
		{
			return;
		}

		$datamodel = new JEventsDataModel();
		$row = $datamodel->queryModel->getEventById($event->ev_id, 0, "icaldb");
		if (!$row)
		{
			return;
		}
		Factory::getApplication()->input->set("jevattend_hiddeninitees", 1);
		Factory::getApplication()->input->set("jevinvitee", explode(",", $this->params->get("autoinvite", "")));
		Factory::getApplication()->input->set("rsvp_email", "email");

		$this->jevrinvitees = new JevRsvpInvitees($this->params, $this->jomsocial, $this->cbuilder, $this->groupjive);
		$this->jevrinvitees->updateInvitees($rsvpitem, $row, false);

		/*
		  if (is_callable("curl_exec")){
		  // I need the repeat id
		  $query = "SELECT  rpt.* FROM #__jevents_vevent as ev "
		  . "\n LEFT JOIN #__jevents_repetition as rpt ON rpt.eventid = ev.ev_id"
		  . "\n LEFT JOIN #__jevents_vevdetail as det ON det.evdet_id = rpt.eventdetail_id"
		  . "\n LEFT JOIN #__jevents_rrule as rr ON rr.eventid = ev.ev_id"
		  . "\n WHERE ev.ev_id = '".intval($rsvpitem->ev_id)."' ORDER BY rpt.startrepeat asc LIMIT 1" ;

		  $db->setQuery( $query );
		  $repeat = $db->loadObject();

		  if (is_null($repeat)) return;

		  $ch = curl_init();
		  $Itemid=Factory::getApplication()->input->getInt("Itemid");
		  $url = JURI::root()."index.php?option=com_jevents&task=icalrepeat.detail&Itemid=$Itemid&tmpl=component&evid=".intval($repeat->rp_id);

		  $url .= '&start_debug=1&debug_host=127.0.0.1&debug_port=10000&debug_stop=1';

		  curl_setopt($ch, CURLOPT_URL,$url);
		  curl_setopt($ch, CURLOPT_VERBOSE, 1);
		  curl_setopt($ch, CURLOPT_POST, 1);
		  curl_setopt($ch, CURLOPT_POSTFIELDS, 	"jevattend_hiddeninvitees=1&jevinvitee=".$this->params->get("autoinvite","") ."&rsvp_email=email");
		  curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		  $this->rawData = curl_exec($ch);
		  curl_close ($ch);
		  }
		 */

		// Do we auto remind invitees
		if ($this->params->get("autoremind", "") == 2) {
			JLoader::register('JevRsvpReminders', JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/jevrreminders.php");
			$this->jevrreminders = new JevRsvpReminders($this->params, 0);
			$this->jevrreminders->remindUsers($rsvpitem, $row, $this->params->get("autoremind", 0));
		}

	}

	public function autoRemind($event)
	{
		if ($this->params->get("autoremind", 0) < 3)
			return;

		JLoader::register('JevRsvpReminders', JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/jevrreminders.php");
		$this->jevrreminders = new JevRsvpReminders($this->params, 0);

		$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=" . $event->ev_id;
		$db = Factory::getDBO();
		$db->setQuery($sql);
		$rsvpitem = $db->loadObject();

		if (!$rsvpitem)
			return;

		$this->jevrreminders->remindUsers($rsvpitem, $event, $this->params->get("autoremind", 0));
	}

	public function updateReminders($event)
	{

		JLoader::register('JevRsvpReminders', JPATH_ADMINISTRATOR . "/components/com_rsvppro/libraries/jevrreminders.php");
		$this->jevrreminders = new JevRsvpReminders($this->params, 0);

		$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=" . $event->ev_id;
		$db = Factory::getDBO();
		$db->setQuery($sql);
		$rsvpitem = $db->loadObject();

		if (!$rsvpitem)
			return;

		$this->jevrreminders->updateReminders($rsvpitem, $event);
	}

	public function deleteReminders($event)
	{
		$sql = "SELECT * FROM #__jev_attendance WHERE ev_id=" . $event->ev_id;
		$db = Factory::getDBO();
		$db->setQuery($sql);
		$rsvpdata = $db->loadObject();

		$sql = "DELETE FROM #__jev_reminders WHERE at_id=" . $rsvpdata->id;
		if ($rsvpdata->remindallrepeats == 0)
		{
			$sql .= " AND rp_id=" . $event->rp_id();
		}

		$db->setQuery($sql);
		$db->execute();

	}

}
