<?php
defined( 'JPATH_BASE' ) or die( 'Direct Access to this location is not allowed.' );

use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\Session\Session;
use Joomla\CMS\HTML\HTMLHelper;

HTMLHelper::stylesheet(  'components/com_rsvppro/assets/css/rsvpattend.css' );
HTMLHelper::script( 'components/com_rsvppro/assets/js/tabs.js');

$script = "var urlroot = '" . JURI::root() . "';\n";
$script .= "var jsontoken = '" . Session::getFormToken() . "';\n";

$document = Factory::getDocument();
$document->addScriptDeclaration($script);

$html   = '<!-- attendee changeform -->';
$user   = Factory::getUser();
$Itemid = Factory::getApplication()->input->getInt("Itemid");

//list($year,$month,$day) = JEVHelper::getYMD();
//$link = $this->row->viewDetailLink($year,$month,$day,false, $Itemid);
$rp_id = intval($this->row->rp_id());
$atd_id = intval($this->rsvpdata->id);
$link = "index.php?option=com_rsvppro&task=attendees.record&at_id=$atd_id&rp_id=$rp_id&Itemid=$Itemid";
if (Factory::getApplication()->input->getCmd("tmpl","")=="component"){
	$link .= "&tmpl=component";
}

// Do we need the email address security code?
if ($this->emailaddress!=""){
	$code = base64_encode($this->emailaddress.":".md5($this->params->get("emailkey","email key").$this->emailaddress));
	$link = $link."&em=".$code;
}
$link = Route::_($link, false);
$this->link = $link;

$db= Factory::getDBO();

// Until we incorporate registration deadline we stop registrations from the time the event starts
jimport('joomla.utilities.date');

// Must use strtotime format for force JevDate to not just parse the date itself!!!
$jnow = new JevDate("+1 second");
$now  = $jnow->toUnix();

if (!isset($this->templateInfo )) {
	$xmlfile = JevTemplateHelper::getTemplate($this->rsvpdata);
	if (is_int($xmlfile) &&  $xmlfile>0){
		$db = Factory::getDbo();
		$db->setQuery("Select * from #__jev_rsvp_templates where id=" . intval($xmlfile));
		$this->templateInfo = $db->loadObject();
		if ($this->templateInfo){
			$this->templateParams = $this->templateInfo->params;
			$this->templateParams = json_decode($this->templateParams);
		}
		else {
			$this->templateParams= false;
		}		
	}	
	else {
		$this->templateParams= false;
	}
}

// Always close this div efore a return!
$html .= '<div id="templateid'.(isset($this->templateInfo )?$this->templateInfo->id : 0).'">';

// Is the user waiting
if ($this->attendee->waiting){
	if ($this->templateParams && isset($this->templateParams->waitingnopay) && $this->templateParams->waitingnopay){
		$html .= $this->loadTemplate("youarewaiting");	
	}
}

// Tell the user they are attending only if cancellation is not allows and they are attending
if (!$this->rsvpdata->allowchanges && $this->attending  && $this->attendee->attendstate==1){
	$html .= $this->loadTemplate("youareattending");
}
else if(isset($this->attendee->attendstate) && $this->attendee->attendstate==2){
	$html .= $this->loadTemplate("youmaybeattending");
}
else if(isset($this->attendee->attendstate) && $this->attendee->attendstate==3){
	$html .= $this->loadTemplate("awaitingconfirmation");
}
else if(isset($this->attendee->attendstate) && $this->attendee->attendstate==4){
	$html .= $this->loadTemplate("awaitingpayment");
}
else  if (($this->rsvpdata->allowcancellation || $this->rsvpdata->allowchanges ) && $this->attending  && ($this->attendee->attendstate==1 || $this->attendee->attendstate==4)){
	$xmlfile = JevTemplateHelper::getTemplate($this->rsvpdata);
	if (is_int($xmlfile)){
		if ($this->templateParams && isset($this->templateParams->whentickets) && count($this->templateParams->whentickets)>0){
			$html .= $this->loadTemplate("ticket");
		}
	}
}


// if we need the payment form or repayment form then display these instead.
if (Factory::getApplication()->input->getInt("paymentform",0)==1 || Factory::getApplication()->input->getInt("repaymentform",0)==1 ){
	if (isset($this->attendeeParams->outstandingBalances["feebalance"]) && floatval($this->attendeeParams->outstandingBalances["feebalance"])!=0){
		echo $html. $this->loadTemplate("emptyattendanceform")."</div>";
		return;
	}
}

// We see if registrations are open
if ($now > $this->rsvpdata->adjustedregclose) {
	echo  $html . $this->loadTemplate("registrationsclosed"). $this->loadTemplate("emptyattendanceform")."</div>";
	return;
}
else if ($now < $this->rsvpdata->adjustedregopen)
{
	echo  $html . $this->loadTemplate("registrationsnotopen"). $this->loadTemplate("emptyattendanceform")."</div>";
	return;
}

// if there is an intro to the form display it here:
if ($this->rsvpdata->attendintro !=""){
	$html .= $this->loadTemplate("intro");
}

// if tracking capacity find how many spaces are used up/left
if ($this->params->get("capacity",0) )
{

	$sql = "SELECT atdcount FROM #__jev_attendeecount as a WHERE a.at_id=".$this->rsvpdata->id;
	if (!$this->rsvpdata->allrepeats){
		$sql .= " and a.rp_id=".$this->row->rp_id();
	}
	$db->setQuery($sql);
	$attendeeCount = intval( $db->loadResult());

	$unpaidWaitingList = "";
	if ($this->templateParams)
	{
		if (isset($this->templateParams->waitingnopay) && $this->templateParams->waitingnopay){
			$unpaidWaitingList = "  OR atdees.attendstate=4";
		}
	}
	
	$query = "SELECT sum(atdees.atdcount) as waitingcount "
		. "\n FROM #__jev_attendees AS atdees "
		. "WHERE atdees.at_id = " . intval($this->rsvpdata->id) ." AND atdees.waiting=1 AND atdees.confirmed=1 AND (atdees.attendstate=1 $unpaidWaitingList)"	;
	if (!$this->rsvpdata->allrepeats){
		$query .= " and atdees.rp_id=".$this->row->rp_id();
	}
	
	$db->setQuery( $query );
	$waitingCount = intval($db->loadResult());
	
	$this->rsvpdata->attendeeCount = $attendeeCount;
	$this->rsvpdata->waitingCount = $waitingCount;
	$this->rsvpdata->attendeeCountExWaiting = $attendeeCount - $waitingCount;
	$this->rsvpdata->attendeeCount = $attendeeCount;
	$this->waitingCount = $waitingCount;
	$this->rsvpdata->attendeeCountExWaiting =  $attendeeCount - $waitingCount;

	if ($this->rsvpdata->capacity > 0) {
		if ($attendeeCount>=$this->rsvpdata->capacity){

			// I need the attendance form if I'm administering and attending the event otherwise I can't cancel attendees!
			if ($user->id==$this->row->created_by() || JEVHelper::isAdminUser($user) || $this->attending || JEVHelper::canDeleteEvent($this->row, $user)){
				$html .= $this->loadTemplate("eventfull");
			}
			else {
				$html .= $this->loadTemplate("eventfull");
				if ($attendeeCount<$this->rsvpdata->capacity + $this->rsvpdata->waitingcapacity){
					$html .= $this->loadTemplate("waitinglist");
				}
				else {
					if ($this->jomsocial && $html!=""){
						$html = '<div class="cModule jevattendform">'. $html."</div>";
					}
					echo $html. $this->loadTemplate("emptyattendanceform")."</div>";
					return;
				}
			}
		} else if($this->params->get('show_atd_count_detail', 1)) {
			$html .=  $this->loadTemplate("capacityremaing");
		}
	}
	else {
			$html .=  ($this->params->get('show_atd_count_detail', 1)) ? $this->loadTemplate("numberattending") : '';
	}
}
else {
	$this->rsvpdata->attendeeCount = 0;
	$this->rsvpdata->attendeeCount = 0;
}

if ($this->rsvpdata->capacity && isset($this->attendee->guestcount) && $this->attendee->attendstate == 4 && ($attendeeCount + $this->attendee->guestcount>$this->rsvpdata->capacity) && !$this->attendee->waiting)
{
	// if counting unpaid capacity then we have already counted this attendee so doouble count it
	if (isset($this->templateParams->unpaidcapacity) && $this->templateParams->unpaidcapacity == 1){
		if ($attendeeCount>$this->rsvpdata->capacity){
			Factory::getApplication()->enqueueMessage(Text::_("JEV_EVENT_FILLED_BEFORE_PAYMENT"), "notice");
                        $html .= "</div>";
			return;
		}
	}
	else {
		Factory::getApplication()->enqueueMessage(Text::_("JEV_EVENT_FILLED_BEFORE_PAYMENT"), "notice");
                $html .= "</div>";
		return;
	}
}

if ($this->rsvpdata->allrepeats){
	$html .=  $this->loadTemplate("changeform_single");
}
// or just this repeat
else if ($this->row->hasrepetition()){
	$html .=  $this->loadTemplate("changeform_repeating");
}


if ($this->jomsocial && $html!=""){
	$html = '<div class="cModule jevattendform"><h3><span>'.Text::_( 'JEV_ATTEND_THIS_EVENT' ).'</span></h3>'. $html."</div>";
}

echo $html . "</div>";

