<?php

defined('JPATH_BASE') or die('Direct Access to this location is not allowed.');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

$user = Factory::getUser();

$html = '<!-- attendee changeform repeating -->';
$formclass="";
if (isset($this->attendee->attendstate)){
	if ($this->attendee->attendstate==1){
		$html .= "<div class='jevattendstate'>". ($this->attendee->waiting ? Text::_('JEV_YOU_ARE_ON_WAITINGLIST') :  Text::_('JEV_YOU_ARE_ATTENDING')) ."<br/>";
		$html .=Text::_( 'JEV_TO_CHANGE_YOUR_RESITRATION_USE_THE_FORM_BELOW' )."</div>";
		$formclass="rsvp-existing-attendee";
	}
	else if ($this->attendee->attendstate==0){
		$html .="<div class='jevattendstate'>".Text::_( 'JEV_ARE_NOT_ATTENDING' )."<br/>";
		$html .=Text::_( 'JEV_TO_CHANGE_YOUR_RESITRATION_USE_THE_FORM_BELOW' )."</div>";
		//$html .="<div class='jevattendstate'>".Text::_( 'JEV_TO_CHANGE_YOUR_RESITRATION_USE_THE_FORM_BELOW' )."</div>";
	}
	else if ($this->attendee->attendstate==2){
		$html .="<div class='jevattendstate'>";
		$html .=Text::_( 'JEV_TO_CHANGE_YOUR_RESITRATION_USE_THE_FORM_BELOW' )."</div>";
	}
	else if ($this->attendee->attendstate==4){
		$html .="<div class='jevattendstate'>" . Text::_('JEV_TO_CHANGE_YOUR_RESITRATION_USE_THE_FORM_BELOW') . "</div>";
		$formclass="rsvp-existing-attendee";
	}
}

$html .= '<form action="' . $this->link . '"  method="post"  name="updateattendance" id="updateattendance"  enctype="multipart/form-data" class="'.$formclass.'" >';
$html .=  HTMLHelper::_('form.token');

// New parameterised fields
$hasparams = false;
if ($this->rsvpdata->template != "")
{
	$xmlfile = JevTemplateHelper::getTemplate($this->rsvpdata);
	if (is_int($xmlfile) || file_exists($xmlfile) )	{

		if (isset($this->attendee) && isset($this->attendee->params))
		{
			$params = new JevRsvpParameter($this->attendee->params, $xmlfile, $this->rsvpdata, $this->row);
			$feesAndBalances = $params->outstandingBalance($this->attendee);
		}
		else
		{
			$params = new JevRsvpParameter("", $xmlfile, $this->rsvpdata, $this->row);
		}

		// Add reference to current row and rsvpdata to the registry so that we have access to these in the fields
		$registry = JevRegistry::getinstance("jevents");
		$registry->set("rsvpdata", $this->rsvpdata);
		$registry->set("event", $this->row);

		// set the potential attendee in the params - needed for rendering
		$params->potentialAttendee = $user;


		if ($params->getNumParams() > 0)
		{
			$attendstate = $this->params->get("defaultattendstate", -1);
			if (isset($this->attendee->attendstate))
				$attendstate = $this->attendee->attendstate;
			$initialstate = $this->rsvpdata->initialstate ? 1 : 3;

			// if subject to payment or approval then must be a yes!
			if ($attendstate==4 || $attendstate==3) {
				$attendstate = 1;
			}

			if ($params->isMultiAttendee())
			{

				$waitingcapacity = $this->rsvpdata->capacity+$this->rsvpdata->waitingcapacity-$this->rsvpdata->attendeeCount;

				// if onlu some 'guests' can be added - block 'mixed' confirmed and waiting attendees
				$realcapacity = $this->rsvpdata->capacity-$this->rsvpdata->attendeeCount;
				if (isset ($this->attendee->atdcount) && $this->attendee->atdcount>0){
					$realcapacity += $this->attendee->atdcount;
					$waitingcapacity  += $this->attendee->atdcount;
				}
				$capacity = $realcapacity>0 ? $realcapacity : $waitingcapacity;

				if ($this->rsvpdata->capacity==0 && $this->rsvpdata->waitingcapacity==0){
					$capacity = 0;
				}

				// is this constrained further by the template
				if (RsvpHelper::getTemplateSpecificParameter($this->rsvpdata,  "maxguesttabs",0)>0 && $capacity>0){
					$capacity = min(array(RsvpHelper::getTemplateSpecificParameter($this->rsvpdata,  "maxguesttabs",0), $capacity));
				}
				else 	if (RsvpHelper::getTemplateSpecificParameter($this->rsvpdata,  "maxguesttabs",0)>0 && $this->rsvpdata->capacity==0){
					$capacity = RsvpHelper::getTemplateSpecificParameter($this->rsvpdata,  "maxguesttabs",0);
				}

				$html .= '<div id="registration-tab-pane" class="tab-page">';
				$html .= '<ul class="nav nav-tabs">';

				$html .= '<li title="' . Text::_("JEV_PRIMARY_ATTENDEE", true) . '" class="nav-item"><a href="#attendeetab0" data-toggle="tab" class="nav-link active">' . Text::_('JEV_PRIMARY_ATTENDEE') . '</a></li>';
				$currentattenddees = $params->curentAttendeeCount();
				if ($currentattenddees > 0)
				{
					for ($ca = 1; $ca < $currentattenddees; $ca++)
					{
						$html .= '<li title="' . addslashes(Text::sprintf("JEV_ATTENDEE_NUMBER", $ca + 1)) . '"  class="nav-item"><a href="#attendeetab'.$ca.'" data-toggle="tab" class="nav-link">' . Text::sprintf("JEV_ATTENDEE_NUMBER", $ca + 1) . '</a></li>';
					}
				}
				$html .= '</ul>';
				$html .= '<div class="tab-content">';
				$html .= '<div class="tab-pane active" id="attendeetab0">';

				$byemail = $this->loadTemplate("byemail");

				$html .= $params->render('params',  "xmlfile", array(), $byemail );

				if ($params->isMultiAttendee())
				{
					$this->capacity = $capacity;

					$addKillButtons = $this->loadTemplate('addkillguests');

					// Add new and kill guest buttons
					$html .= $addKillButtons;

					// labels for new guest tab
					$html .= '<input type="hidden" id="jevnexttabtitle" value="' . addslashes(Text::sprintf("JEV_ATTENDEE_NUMBER", 'xxx')) . '" />';
				}

				// Attend this event
				$this->initialstate = $initialstate;
				$this->attendstate = $attendstate;

				$attendyes =  '<input type="hidden" name="jevattend" id="jevattend_yes" value="'.$attendstate.'" />';
				$html .= $attendyes ;

				$html .= '</div>';// tab-pane
				$html .= '</div>';// tab-content
				$html .= '</div>';// tab-page
				Factory::getDocument()->addScriptDeclaration('jQuery(document).ready(function() {regTabs.initialise("registration-tab-pane",{mouseOverClass:"active",	activateOnLoad:"attendeetab0"	});});');
			}
			else
			{
				$this->initialstate = $initialstate;
				$this->attendstate = $attendstate;
				$attendyes =  '<input type="hidden" name="jevattend" id="jevattend_yes" value="'.$attendstate.'" />';

				$byemail = $this->loadTemplate("byemail");

				$html .= $params->render('params', "xmlfile",array('',$attendyes), $byemail 	);
			}
			$hasparams = true;
		}
	}
}
else
{
	$html .= '<table width="100%" class="paramlist admintable" cellspacing="1">';
	$html .= $this->loadTemplate("byemail");
	$html .= '</table>';

	if (isset($this->attendee) && isset($this->attendee->params))
	{
		$params = new JevRsvpParameter($this->attendee->params, null, $this->rsvpdata, $this->row);
		$feesAndBalances = $params->outstandingBalance($this->attendee);
	}
	else
	{
		$params = new JevRsvpParameter("", null, $this->rsvpdata, $this->row);
	}
}

// guest count
$html .='<input type="hidden" name="guestcount" id="guestcount" value="' . (isset($this->attendee->guestcount) ? $this->attendee->guestcount : 1) . '" />';
$html .='<input type="hidden" name="lastguest" id="lastguest" value="' . (isset($this->attendee->guestcount) ? $this->attendee->guestcount : 1) . '" />';


if ($hasparams)
{
	$this->attendstate = $attendstate;
	$html .=  $this->loadTemplate("attendanceform_updateattendbutton");
	$html .='<input type="hidden" name="Itemid"  value="' .  Factory::getApplication()->input->getInt("Itemid" ,1) . '" />';
	$html .='
		<noscript><input type="submit" value="' . Text::_( 'JEV_CONFIRM' ) . '" /></noscript>
</form>';
}
else
{
	$attendstate = $this->params->get("defaultattendstate", -1);
	if (isset($this->attendee->attendstate))
		$attendstate = $this->attendee->attendstate;
	$initialstate = $this->rsvpdata->initialstate ? 1 : 3;

	// if subject to payment then must be a yes!
	if ($attendstate==4) {
		$attendstate = 1;
	}

	$this->initialstate = $initialstate;
	$this->attendstate = $attendstate;

	$html .= $this->loadTemplate("attendanceform_attendyesnomaybe");
	$this->attendstate = $attendstate;
	$html .=  $this->loadTemplate("attendanceform_updateattendbutton");
	$html .='<input type="hidden" name="Itemid"  value="' .  Factory::getApplication()->input->getInt("Itemid" ,1) . '" />';
	$html .='
		<noscript><input type="submit" value="' . Text::_( 'JEV_CONFIRM' ) . '" /></noscript>
</form>';
}



echo $html;

